SystemOrganization addCategory: #SVO!
SystemOrganization addCategory: 'SVO-Announcements'!
SystemOrganization addCategory: 'SVO-Commands'!
SystemOrganization addCategory: 'SVO-Parser'!
SystemOrganization addCategory: 'SVO-Slots-VO'!
SystemOrganization addCategory: 'SVO-Tests'!
SystemOrganization addCategory: 'SVO-UI-App'!
SystemOrganization addCategory: 'SVO-UI-SVO'!
SystemOrganization addCategory: 'SVO-Utilities'!

DynamicComposableModel subclass: #ActionSlotUI
	instanceVariableNames: 'button source result model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-SVO'!

!ActionSlotUI commentStamp: 'hk 2/2/2015 21:05' prior: 0!
A DslMethodUI is thew developer UI for a user action button using DSL.

Instance Variables
	button:		<ButtonModel >
	result:		<LabelModel >
	source:		<TextInputFieldModel >
	model:

!

!ActionSlotUI class methodsFor: 'instance creation' stamp: 'hk 2/2/2015 21:06'!
on: aSlot
	^self basicNew model: aSlot; initialize! !

!ActionSlotUI methodsFor: 'accessing' stamp: 'hk 11/16/2014 15:49'!
button
	^ button! !

!ActionSlotUI methodsFor: 'ui-actions' stamp: 'hk 12/3/2014 15:50'!
exec
	model source: source text. 
	result label: model exec! !

!ActionSlotUI methodsFor: 'constants' stamp: 'hk 2/2/2015 21:20'!
height
	^ self singleHeight * 2! !

!ActionSlotUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 21:30'!
initializeLayout
	"(ActionSlotUI on: ActionSlot new) openWithSpec"
	"(CommonSlotUI on: ActionSlot new type: ActionSlotUI) openWithSpec"

	self layout: (SpecLayout composed
		newColumn: [ :clmn | 
			clmn newRow: [ :r | 
					r add: #source.
					r add: #button width: self class buttonWidth ]
				height: self singleHeight.
			clmn add: #result ])! !

!ActionSlotUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 21:06'!
initializeWidgets
	"(DslMethodUI on: DslActionSlotValue new) openWithSpec"
	source := (self newTextInput)
						autoAccept: true;
						ghostText: 'undefined'.
	source text: model source	.				
	result := (self newLabel) text: 'no result' .
	button := self newButton.
	button
		label: 'exec';
		action: [ self exec ];
		state: true.
	self initializeLayout! !

!ActionSlotUI methodsFor: 'accessing' stamp: 'hk 2/2/2015 21:09'!
model 
	^model ifNil: [ self error: 'no model' ]! !

!ActionSlotUI methodsFor: 'accessing' stamp: 'hk 2/2/2015 21:09'!
model: aSlot
	model := aSlot! !

!ActionSlotUI methodsFor: 'accessing' stamp: 'hk 11/16/2014 15:50'!
result
	^ result! !

!ActionSlotUI methodsFor: 'accessing' stamp: 'hk 12/5/2014 10:52'!
save
	model source: source text! !

!ActionSlotUI methodsFor: 'constants' stamp: 'hk 2/2/2015 21:20'!
singleHeight
	^ self class toolbarHeight ! !

!ActionSlotUI methodsFor: 'accessing' stamp: 'hk 11/16/2014 15:48'!
source
	^ source! !

!ActionSlotUI methodsFor: 'protocol' stamp: 'hk 2/9/2015 15:43'!
whenChangedDo: aBlock ! !

DynamicComposableModel subclass: #CommonSlotUI
	instanceVariableNames: 'key kill model up down forDisplay type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-SVO'!

!CommonSlotUI commentStamp: 'hk 2/2/2015 15:18' prior: 0!
A SpoAbstractSlotUI is xxxxxxxxx.

Instance Variables
	down:		<ButtonModel>
	key:		<LabelModel >
	kill:			<ButtonModel>
	model:		<Slot>
	up:			<ButtonModel >
	type: 		<SlotUI>
	forDisplay: 	<CheckBoxModel>!

!CommonSlotUI class methodsFor: 'instance creation' stamp: 'hk 2/2/2015 17:08'!
on: aSlot
	^self on: aSlot type: nil! !

!CommonSlotUI class methodsFor: 'instance creation' stamp: 'hk 2/2/2015 15:15'!
on: aSlot type: aSlotUI
	^self basicNew model: aSlot; type: aSlotUI; initialize! !

!CommonSlotUI methodsFor: 'ui-helpers' stamp: 'hk 12/2/2014 17:07'!
doubleHeight
	^2 * self singleHeight! !

!CommonSlotUI methodsFor: 'accessing' stamp: 'hk 11/17/2014 13:32'!
down
	^ down! !

!CommonSlotUI methodsFor: 'ui-actions' stamp: 'hk 12/15/2014 21:28'!
downAction
	owner isListEditor ifFalse: 
		[ model index < model maxIndex ifTrue: [ self exec: MoveDown ] ]! !

!CommonSlotUI methodsFor: 'private' stamp: 'hk 12/10/2014 17:47'!
exec: aCommand
	"Example : kontakt exec:  (MoveUp named: #vorname) "
	model frame exec: (aCommand named: model key )  ! !

!CommonSlotUI methodsFor: 'accessing' stamp: 'hk 1/20/2015 17:34'!
forDisplay
	^ forDisplay! !

!CommonSlotUI methodsFor: 'ui-helpers' stamp: 'hk 2/2/2015 18:54'!
height
	^self singleHeight max:  self typeHeight  ! !

!CommonSlotUI methodsFor: 'initialization' stamp: 'hk 12/1/2014 13:18'!
initialExtent
	"(4@4) is the size of the border"

	^ 400 @ (40 + self height) + (4 @ 4)! !

!CommonSlotUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 21:12'!
initializeLayout
	"(CommonSlotUI on: AbstractSlot new ) openWithSpec"
	
	type ifNotNil: [ self assign: (type on: self model) to: #type ].
	self layout: (SpecLayout composed
		newRow: [ :row | 
				row add: #key width: 125. 
				row	add: #forDisplay width: 20 .
				type ifNotNil: [row add: #type] .
				row add:  #up width: 20 ;  
					add: #down width: 20 ;
				 	add: #kill width: 20 ] ) ! !

!CommonSlotUI methodsFor: 'initialization' stamp: 'hk 1/20/2015 17:35'!
initializeWidgets
	"(AbstractSlotUI on: AbstractSlot new) openWithSpec"
	
	key := (self newLabel) text: model key; yourself .
	(forDisplay := self newCheckBox) 
		state: model forDisplay.
	(kill := self newButton)
		label: 'X';
		action: [self killAction];
		state: true;
		yourself.
	(up := self newButton)
		label: '<';
		action: [self upAction ];
		state: true;
		yourself.
	(down := self newButton)
		label: '>';
		action: [self downAction ];
		state: true;
		yourself.
	self initializeLayout 
! !

!CommonSlotUI methodsFor: 'accessing' stamp: 'hk 11/17/2014 13:32'!
key
	^ key! !

!CommonSlotUI methodsFor: 'accessing' stamp: 'hk 11/17/2014 13:32'!
kill
	^ kill! !

!CommonSlotUI methodsFor: 'ui-actions' stamp: 'hk 1/26/2015 22:29'!
killAction
	self owner isListEditor 
		ifTrue: [ self exec:  RemoveSvoCopy ]
		ifFalse: [ self exec: RemoveSlot ]! !

!CommonSlotUI methodsFor: 'accessing' stamp: 'hk 2/2/2015 17:06'!
model
	^model ! !

!CommonSlotUI methodsFor: 'accessing' stamp: 'hk 11/17/2014 13:32'!
model: anObject
	model := anObject! !

!CommonSlotUI methodsFor: 'ui-actions' stamp: 'hk 2/9/2015 15:11'!
save
	model forDisplay: forDisplay state.
	type ifNotNil: [ (self widgets at: #type) save ]! !

!CommonSlotUI methodsFor: 'accessing' stamp: 'hk 12/1/2014 12:49'!
singleHeight
	^self class toolbarHeight	
	! !

!CommonSlotUI methodsFor: 'initialization' stamp: 'hk 11/27/2014 19:11'!
specFor: row
	"plug-in for subclasses"! !

!CommonSlotUI methodsFor: 'accessing' stamp: 'hk 2/9/2015 14:58'!
type: aSlotUI
	type :=  aSlotUI! !

!CommonSlotUI methodsFor: 'ui-helpers' stamp: 'hk 2/2/2015 18:57'!
typeHeight
	| w |
	w := self widgets at: #type ifAbsent: [ ^0 ] .
	(w respondsTo: #height) ifFalse: [ ^0 ].
	^w height ! !

!CommonSlotUI methodsFor: 'accessing' stamp: 'hk 11/17/2014 13:32'!
up
	^ up! !

!CommonSlotUI methodsFor: 'ui-actions' stamp: 'hk 12/15/2014 21:29'!
upAction
	owner isListEditor ifFalse: 
		[ model index > 1 ifTrue: [self exec: MoveUp ] ]! !

!CommonSlotUI methodsFor: 'protocol' stamp: 'hk 2/9/2015 16:14'!
whenAkkuChangedDo: aBlock 
	| w |
	w := self widgets at: #type  .
	(w isKindOf: SvoStaticListUI) ifTrue: [ w whenAkkuChangedDo: aBlock  ]
	! !

!CommonSlotUI methodsFor: 'protocol' stamp: 'hk 2/9/2015 15:34'!
whenChangedDo: aBlock 
	(self widgets at: #type ) whenChangedDo: aBlock ! !

DynamicComposableModel subclass: #DropListUI
	instanceVariableNames: 'list model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-SVO'!

!DropListUI commentStamp: 'hk 2/2/2015 17:22' prior: 0!
A SlotListUI is xxxxxxxxx.

Instance Variables
	list:		<ListModel >
	model:	<DropList>!

!DropListUI class methodsFor: 'instance creation' stamp: 'hk 2/2/2015 17:27'!
on: aSlot
	^self basicNew model: aSlot; initialize! !

!DropListUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 21:33'!
initializeLayout
	"(DropListUI on: DropListSlot new) openWithSpec"
	"(CommonSlotUI on: DropListSlot new type: DropListUI) openWithSpec"
	
	self layout: (SpecLayout composed
		newColumn: [ :c | c add: #list ] )! !

!DropListUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 17:22'!
initializeWidgets
	"(DropListUI on: (DropListSlot new list: #(#a #b #c); key: #bla )) openWithSpec"
	list := self newDropList .
	list items: model list .
	list setSelectedItem: model selection.
	self initializeLayout ! !

!DropListUI methodsFor: 'accessing' stamp: 'hk 11/28/2014 16:44'!
list
	^ list! !

!DropListUI methodsFor: 'accessing' stamp: 'hk 2/2/2015 17:25'!
model 
	^model ifNil: [ self error: 'no model' ]! !

!DropListUI methodsFor: 'accessing' stamp: 'hk 2/2/2015 17:25'!
model: aSlot
	model := aSlot! !

!DropListUI methodsFor: 'ui-actions' stamp: 'hk 2/2/2015 17:25'!
save
	model selection: list selectedItem! !

!DropListUI methodsFor: 'protocol' stamp: 'hk 2/9/2015 15:43'!
whenChangedDo: aBlock ! !

DynamicComposableModel subclass: #DslValueSlotUI
	instanceVariableNames: 'source button label slotValue model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-SVO'!

!DslValueSlotUI commentStamp: 'hk 2/2/2015 21:05' prior: 0!
A SlotEmbeddedValueUI is a developer UI for a slot, individually copied from another SPO by DSL.

Instance Variables
	button:		<ButtonModel >
	label:		<LabelModel>
	source:		<String>
	slotValue:		<LabelModel >
	model:!

!DslValueSlotUI class methodsFor: 'instance creation' stamp: 'hk 2/2/2015 20:54'!
on: aSlot
	^self basicNew model: aSlot; initialize! !

!DslValueSlotUI methodsFor: 'accessing' stamp: 'hk 12/2/2014 17:02'!
button
	^ button! !

!DslValueSlotUI methodsFor: 'ui-actions' stamp: 'hk 12/2/2014 19:04'!
exec
	model source: source text.
	model exec.
	label label: model originalKey.
	slotValue label: model value
	! !

!DslValueSlotUI methodsFor: 'ui-helpers' stamp: 'hk 2/2/2015 20:59'!
height
	^self class toolbarHeight * 2 
	! !

!DslValueSlotUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 21:31'!
initializeLayout
	"(DslValueSlotUI on: DslValueSlot new) openWithSpec"
	
	self layout: (SpecLayout composed
		newColumn: [ :c | 
			c newRow:  [ :r |  r add: #source ; add: #button 
					width: self class buttonWidth] .
			c newRow: [ :r | r add: #label; add: #slotValue] ] )
	
	! !

!DslValueSlotUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 20:57'!
initializeWidgets
	(label := self newLabel) label: model originalKey .
	(slotValue := self newLabel) label: model value . 
	source := (self newTextInput)
						autoAccept: true;
						ghostText: 'undefined'.
	source text: model source.
	(button := self newButton)
		label: 'exec';
		action: [ self exec ];
		state: true.
	self initializeLayout
	! !

!DslValueSlotUI methodsFor: 'accessing' stamp: 'hk 12/2/2014 17:03'!
label
	^ label! !

!DslValueSlotUI methodsFor: 'accessing' stamp: 'hk 2/2/2015 20:54'!
model 
	^model ifNil: [ self error: 'no model' ]! !

!DslValueSlotUI methodsFor: 'accessing' stamp: 'hk 2/2/2015 20:54'!
model: aSlot
	model := aSlot! !

!DslValueSlotUI methodsFor: 'accessing' stamp: 'hk 12/5/2014 10:54'!
save
	model source: source text! !

!DslValueSlotUI methodsFor: 'accessing' stamp: 'hk 12/2/2014 19:05'!
slotValue
	^ slotValue! !

!DslValueSlotUI methodsFor: 'accessing' stamp: 'hk 12/2/2014 17:02'!
source
	^ source! !

!DslValueSlotUI methodsFor: 'as yet unclassified' stamp: 'hk 2/9/2015 15:43'!
whenChangedDo: aBlock ! !

DynamicComposableModel subclass: #GcVoUI
	instanceVariableNames: 'vo emptyLabel editButton identityLabel height subWidget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-App'!

!GcVoUI commentStamp: 'hk 4/7/2015 12:32' prior: 0!
A GloConnVoUI is the top UI to inspect or edit a VO.

Instance Variables
	vo:					<VO>
	emptyLabel:		<LabelModel>
	identityLabel:		<LabelModel>
	editButton:			<ButtonModel>
	subWidget:			<GloConnVoWidget>
	height:				<Number>

!

!GcVoUI class methodsFor: 'instance creation' stamp: 'hk 3/21/2015 20:20'!
on: aVO
	^self basicNew vo: aVO; initialize! !

!GcVoUI class methodsFor: 'instance creation' stamp: 'hk 4/8/2015 16:57'!
title
	^ 'VO editor'! !

!GcVoUI methodsFor: 'accessing' stamp: 'hk 3/21/2015 20:18'!
editButton
	^editButton! !

!GcVoUI methodsFor: 'accessing' stamp: 'hk 3/21/2015 20:18'!
emptyLabel
	^emptyLabel! !

!GcVoUI methodsFor: 'accessing' stamp: 'hk 3/21/2015 20:18'!
identityLabel
	^ identityLabel ! !

!GcVoUI methodsFor: 'initialization' stamp: 'hk 4/7/2015 12:39'!
initialExtent
	
		^600 @  400 
! !

!GcVoUI methodsFor: 'initialization' stamp: 'hk 4/8/2015 16:58'!
initializeLayout
	"(GcVoUI on: (DomainVO new: #bla) ) openWithSpec"
	"(GcVoUI on: (Svo2Tests makeContact   ) ) openWithSpec"

	| h |
	h := self class toolbarHeight .
	self layout: (SpecLayout composed newColumn: [ :c | 
		c newRow: [ :r | 
				r add: #identityLabel.
				r add: #emptyLabel .
				r  add: #editButton width: 80 ] height: h .
		c newRow: [ :r | r add: #subWidget] ] ).
	height := height + h +  subWidget height.
	self needRebuild: false ! !

!GcVoUI methodsFor: 'initialization' stamp: 'hk 4/7/2015 16:44'!
initializeWidgets
	emptyLabel := self newLabel .
	(identityLabel := self newLabel)
		label: vo userName .
	(editButton := self newButton ) 
		label: 'reOpen';
		action: [ self openWithSpec ];
		state: true.
	(subWidget := GcVoWidget on: vo) owner: self.
	height := 0 .
	self initializeLayout! !

!GcVoUI methodsFor: 'accessing' stamp: 'hk 4/7/2015 12:37'!
subWidget
	^subWidget! !

!GcVoUI methodsFor: 'accessing' stamp: 'hk 3/21/2015 20:18'!
vo: aVO
	vo := aVO! !

DynamicComposableModel subclass: #GcVoWidget
	instanceVariableNames: 'vo emptyLabel svoSlots valueSlots expandButton collapseButton plusButton listSlots keyDict mode height key keyLabel dropListSlots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-App'!

!GcVoWidget commentStamp: 'hk 3/25/2015 13:47' prior: 0!
A GloConnVOUI is a recursive UI to represent or edit a structured VO.

--- So far only valueSlots and svoSlots. ---

Instance Variables
	vo:					<VO>
	emptyLabel:		<LabelModel>
	identityLabel:		<LabelModel>
	keyLabel: 			<LabelModel>
	editButton:			<ButtonModel>
	expandButton:		<ButtonModel>
	collapseButton:		<ButtonModel>
	plusButton:			<ButtonModel>
	keyDict: 			<Dictionary of Array[3]>
	svoSlots:			<OrderedCollection>
	dropListSlots:		<OrderedCollection>
	valueSlots:			<OrderedCollection>
	listSlots:			<OrderedCollection>
	height:				<Number>
	mode:				<#expanded | #collapsed>
					key
					!

!GcVoWidget class methodsFor: 'instance creation' stamp: 'hk 3/24/2015 16:47'!
on: aVO 
	^self on: aVO slotKey: nil! !

!GcVoWidget class methodsFor: 'instance creation' stamp: 'hk 3/24/2015 16:47'!
on: aVO slotKey: aString
	^self basicNew vo: aVO; key: aString; initialize! !

!GcVoWidget methodsFor: 'as yet unclassified' stamp: 'hk 4/8/2015 16:08'!
andAllSubWidgetsDo: aBlock
	aBlock value: self .
	Transcript cr; show: vo userName; show: self  layout isNotNil printString .
	self ifExpanded: [ 
	self svoSlots do: 
		[ :s | | widgetKey |
		widgetKey := (self keyDict at: s key) at: 3 .
		(widgets at: widgetKey)  andAllSubWidgetsDo: aBlock ] ]
! !

!GcVoWidget methodsFor: 'ui actions' stamp: 'hk 4/8/2015 15:49'!
collapse
		mode value: #collapsed  .
	self layout: self collapsedLayout   .
		self rebuild! !

!GcVoWidget methodsFor: 'accessing' stamp: 'hk 3/22/2015 20:56'!
collapseButton
	^ collapseButton! !

!GcVoWidget methodsFor: 'initialization' stamp: 'hk 4/7/2015 17:44'!
collapsedLayout
	^SpecLayout composed newColumn: [ :c | 
		self headerLayout: c .
		c add: #emptyLabel height: 1	] ;
		yourself ! !

!GcVoWidget methodsFor: 'initialization' stamp: 'hk 3/24/2015 16:36'!
defineFixedWidgets
	emptyLabel := self newLabel .
	mode := #collapsed asReactiveVariable  .
	(keyLabel := self newLabel) label: self key . 
	(expandButton := self newButton) 
		icon: (GloConnIcons at: #right);
		state: true;
		action: [ self expand ] .
	(collapseButton := self newButton) 
		icon: (GloConnIcons at: #down);
		state: true;
		action: [ self collapse ] .
	(plusButton := self newButton) 
		icon: (GloConnIcons at: #plus);
		state: true;
		action: [  ]! !

!GcVoWidget methodsFor: 'accessing' stamp: 'hk 3/25/2015 13:46'!
dropListSlots
		^dropListSlots ifNil: [ dropListSlots := OrderedCollection new]! !

!GcVoWidget methodsFor: 'accessing' stamp: 'hk 3/16/2015 12:31'!
emptyLabel
	^emptyLabel! !

!GcVoWidget methodsFor: 'ui actions' stamp: 'hk 4/8/2015 15:49'!
expand   
	mode value: #expanded .
	self layout: self expandedLayout  .
	self rebuild! !

!GcVoWidget methodsFor: 'accessing' stamp: 'hk 3/21/2015 18:32'!
expandButton
	^ expandButton! !

!GcVoWidget methodsFor: 'initialization' stamp: 'hk 4/8/2015 16:40'!
expandedLayout
	^SpecLayout composed newColumn: [ :c | 
		self headerLayout: c .
		self valueSlotsLayout: c.   
		self listSlotLayout: c .
		self svoSlotsLayout: c  .
		height := height + self singleHeight .	"safety margin"
		c add: #emptyLabel height: 1	] ;
		yourself  ! !

!GcVoWidget methodsFor: 'constants' stamp: 'hk 3/24/2015 13:55'!
fieldWidth
	^ 130! !

!GcVoWidget methodsFor: 'initialization' stamp: 'hk 4/8/2015 16:43'!
headerLayout: c
	c newRow: [ :r | 
		self ifCollapsed: [r add: #expandButton width: 24]  
				   ifNot: [r add: #collapseButton width: 24] .
		r add: #keyLabel width: self fieldWidth  .
		r add: #emptyLabel ] height: self singleHeight  .
	height :=  self singleHeight   
! !

!GcVoWidget methodsFor: 'accessing' stamp: 'hk 3/23/2015 12:16'!
height
		^height! !

!GcVoWidget methodsFor: 'language' stamp: 'hk 4/8/2015 16:23'!
ifCollapsed: aBlock ifNot: anotherBlock
		^(mode value = #collapsed ) ifTrue: aBlock ifFalse:  anotherBlock ! !

!GcVoWidget methodsFor: 'language' stamp: 'hk 4/8/2015 16:23'!
ifExpanded: aBlock
		^(mode value = #collapsed ) ifFalse: aBlock! !

!GcVoWidget methodsFor: 'initialization' stamp: 'hk 4/8/2015 15:45'!
initializeLayout
	"(GcVoWidget on: (DomainVO new: #bla) ) openWithSpec"
	"(GcVoWidget on: (SvoTests makeContact  ) slotKey: #bla ) openWithSpec"
	"(GcVoWidget on: (SvoTests makeKontakt) ) openWithSpec"

	height := 1 . 
	self layout: self collapsedLayout .
	self needRebuild:  false.! !

!GcVoWidget methodsFor: 'initialization' stamp: 'hk 4/7/2015 16:45'!
initializeWidgets
	self defineFixedWidgets .
	vo slotsDo: [ :s | 
		s isValueSlot ifTrue: [ self valueSlots add: s ].
		s isDropListSlot ifTrue: [self dropListSlots add: s ].
		s isSvoSlot ifTrue: [self svoSlots add: s ].
		s isSvoStaticList ifTrue: [self listSlots add: s ] ] .
	self valueSlots do: 
		[ :s |   | k1 k2 k3 |
			self assign: (LabelModel new text: s key ) to: (k1 := ( 'vl', s key )asSymbol) .
			self assign: (LabelModel new text: s value ) to: (k2 := ('vv', s key )asSymbol ). 
			self assign: (TextInputFieldModel new text: s value ) to: (k3 := ('ve', s key )asSymbol) .
			self keyDict at: s key put: (Array with: k1 with: k2 with: k3) ].
	self dropListSlots do: [ :s |  ] .
	self svoSlots do: 
		[ :s |   | k1 k2 k3 |
			self assign: (LabelModel new text: s key ) to: (k1 := ( 'sl', s key )asSymbol) .
			self assign: (LabelModel new text: s value ) to: (k2 := ('sv', s key )asSymbol ). 
			self assign: ((GcVoWidget on: s svo slotKey: s key) owner: self )to: (k3 := ('se', s key )asSymbol) .
			self keyDict at: s key put: (Array with: k1 with: k2 with: k3)  ]. 
	self listSlots do: 
		[ :s |   | k1 k2 k3 |
			self assign: (LabelModel new text: s key ) to: (k1 := ( 'll', s key )asSymbol) .
			self assign: (TableListUI new items: s list ) to: (k2 := ('lv', s key )asSymbol ). 
			self assign: (TextInputFieldModel new text: s value ) to: (k3 := ('le', s key )asSymbol) .
			self keyDict at: s key put: (Array with: k1 with: k2 with: k3) ].
	self initializeLayout! !

!GcVoWidget methodsFor: 'accessing' stamp: 'hk 4/7/2015 13:37'!
key
	"when instantiated without slot key, use pName"
	^key ifNil: [ vo userName ]! !

!GcVoWidget methodsFor: 'accessing' stamp: 'hk 3/24/2015 13:31'!
key: aString
		key := aString! !

!GcVoWidget methodsFor: 'accessing' stamp: 'hk 3/22/2015 19:18'!
keyDict
		^keyDict ifNil: [ keyDict := Dictionary new ] ! !

!GcVoWidget methodsFor: 'accessing' stamp: 'hk 3/24/2015 15:52'!
keyLabel
	^keyLabel! !

!GcVoWidget methodsFor: 'initialization' stamp: 'hk 4/8/2015 16:33'!
listSlotLayout: c

	self listSlots do: 
		[ :s | | wgt lh |
		wgt := self keyDict at: s key .
		lh := (widgets at: (wgt at: 2)) height .
		c newRow: [ :r | 
			r add: #emptyLabel width: 24.
			r add: (wgt at: 1) width: self fieldWidth  .
			r add: (wgt at: 2)  ] height: lh .
		height := height + lh ] ! !

!GcVoWidget methodsFor: 'accessing' stamp: 'hk 3/22/2015 19:17'!
listSlots
		^listSlots ifNil: [ listSlots := OrderedCollection new ] ! !

!GcVoWidget methodsFor: 'ui actions' stamp: 'hk 3/26/2015 12:46'!
mode   
		^mode value! !

!GcVoWidget methodsFor: 'accessing' stamp: 'hk 3/26/2015 12:47'!
plusButton
	^ plusButton! !

!GcVoWidget methodsFor: 'ui actions' stamp: 'hk 4/8/2015 16:01'!
rebuild
	self andAllSubWidgetsDo: [ :w | w needRebuild: false; buildWithSpec  ]! !

!GcVoWidget methodsFor: 'constants' stamp: 'hk 3/24/2015 13:56'!
singleHeight
	^ self class toolbarHeight ! !

!GcVoWidget methodsFor: 'accessing' stamp: 'hk 3/21/2015 18:04'!
svoSlots
		^svoSlots ifNil: [ svoSlots := OrderedCollection new ] ! !

!GcVoWidget methodsFor: 'initialization' stamp: 'hk 4/8/2015 16:40'!
svoSlotsLayout: c

	self svoSlots do:  
		[ :slot |  | wgt dh |
		wgt := self keyDict at: slot key .
		dh :=  ( widgets at: (wgt at: 3))  height.
		c newRow: [ :r | 
			r add: #emptyLabel width: 24.
			r add: (wgt at: 3) ] "height: dh" .
		height := height + dh ]! !

!GcVoWidget methodsFor: 'accessing' stamp: 'hk 3/21/2015 18:04'!
valueSlots
		^valueSlots ifNil: [ valueSlots := OrderedCollection new ] ! !

!GcVoWidget methodsFor: 'initialization' stamp: 'hk 4/8/2015 16:33'!
valueSlotsLayout: c
	self valueSlots do: 
		[ :s |  | wgt |
		wgt := self keyDict at: s key.
		c newRow: [ :r | 
			r add: #emptyLabel width: 24.
			r add: (wgt at: 1) width: self fieldWidth.
			r add: (wgt at: 2) width: self fieldWidth.
			r add: #emptyLabel ] height: self singleHeight.
		height := height + self singleHeight ]! !

!GcVoWidget methodsFor: 'accessing' stamp: 'hk 3/16/2015 11:42'!
vo: aVO
	vo := aVO! !

!GcVoWidget methodsFor: 'protocol' stamp: 'hk 4/8/2015 15:30'!
whenChangedDo: aBlock
	mode whenChangedDo: [ self buildWithSpec .aBlock value .] .
	self svoSlots do: 
		[ :s | | widgetKey |
		widgetKey := (self keyDict at: s key) at: 3 .
		(widgets at: widgetKey)  whenChangedDo: aBlock ]
! !

!GcVoWidget methodsFor: 'as yet unclassified' stamp: 'hk 4/8/2015 13:56'!
xinitializePresenter
	mode whenChangedDo: [ self buildWithSpec  ] .
	self svoSlots do: 
		[ :s | | widgetKey |
		widgetKey := (self keyDict at: s key) at: 3 .
		(widgets at: widgetKey)  whenChangedDo: [ self buildWithSpec  ] ]
! !

DynamicComposableModel subclass: #GloConnCalcUI
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-App'!

!GloConnCalcUI class methodsFor: 'instance creation' stamp: 'hk 3/4/2015 11:13'!
on: aContext
	^self basicNew context: aContext; initialize! !

!GloConnCalcUI methodsFor: 'accessing' stamp: 'hk 3/4/2015 11:18'!
context: aCF
	context := aCF .! !

!GloConnCalcUI methodsFor: 'initialization' stamp: 'hk 2/10/2015 18:46'!
initializeLayout
	
	self layout: (SpecLayout composed newColumn: [ :c | 
		c 	newRow: [ :r | r
				add:  #pIcon width: 24 ;
				add:  #pLabel  ] height: self class toolbarHeight .
		c 	newRow: [ :r | r  
				add: #emptyLabel ;
				add: #calculator  ;
				add: #emptyLabel ] height: 6.333 * self class toolbarHeight .
		c	add: #emptyLabel  ] ).

! !

!GloConnCalcUI methodsFor: 'initialization' stamp: 'hk 3/2/2015 18:29'!
initializeWidgets
	"(GloConnCalcUI new ) openWithSpec"

	self assign: SvoCalc new to: #calculator .	
	self assign: (LabelModel new) to: #emptyLabel . 
	self assign: (ButtonModel new icon: (GloConnIcons at: #calc)) to: #pIcon.
	self assign: (LabelModel new text: 'Calculator' ) to: #pLabel .
 	self initializeLayout! !

!GloConnCalcUI methodsFor: 'protocol' stamp: 'hk 3/4/2015 11:24'!
whenChangedDo: aBlock! !

DynamicComposableModel subclass: #GloConnDashUI
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-App'!

!GloConnDashUI class methodsFor: 'instance creation' stamp: 'hk 3/4/2015 11:13'!
on: aContext
	^self basicNew context: aContext; initialize! !

!GloConnDashUI methodsFor: 'accessing' stamp: 'hk 3/4/2015 11:18'!
context: aCF
	context := aCF .! !

!GloConnDashUI methodsFor: 'initialization' stamp: 'hk 2/10/2015 17:42'!
initializeLayout
 	self layout: (SpecLayout composed newColumn: [ :c | 
		c 	newRow: [ :r | r
				add:  #pIcon width: 24 ;
				add:  #pLabel  ] height: self class toolbarHeight .
		c add: #dashButton ] ).	
	self needFullRebuild: false.
! !

!GloConnDashUI methodsFor: 'initialization' stamp: 'hk 3/2/2015 18:29'!
initializeWidgets
	"(GloConnDashUI new ) openWithSpec"
	
	self assign: (ButtonModel new
				state: false;
				icon: (GloConnIcons at: #dashboard)) to: #dashButton.
	self assign: (ButtonModel new icon: (GloConnIcons  at: #dash)) to: #pIcon.
	self assign: (LabelModel new text: 'Dashboard' ) to: #pLabel .
	self initializeLayout! !

!GloConnDashUI methodsFor: 'protocol' stamp: 'hk 3/4/2015 11:23'!
whenChangedDo: aBlock! !

DynamicComposableModel subclass: #GloConnEmptyUI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-App'!

!GloConnEmptyUI methodsFor: 'initialization' stamp: 'hk 3/3/2015 17:18'!
initializeLayout
 	self layout: (SpecLayout composed newColumn: [ :c | c add: #loginButton ] ).	
	self needFullRebuild: false.
! !

!GloConnEmptyUI methodsFor: 'initialization' stamp: 'hk 3/3/2015 17:22'!
initializeWidgets
	self assign: ( ButtonModel new state: false; label: 'please login') to: #loginButton.	
	self initializeLayout ! !

DynamicComposableModel subclass: #GloConnListUI
	instanceVariableNames: 'menuRow tableList context selection pIcon pLabel subContext changeBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-App'!

!GloConnListUI commentStamp: 'hk 3/31/2015 20:26' prior: 0!
A GloConnListUI is xxxxxxxxx.

Instance Variables
	context:		<Object>			of the list
	menuRow:		<Object>
	tableList:		<TableListUI>
	selection:  		<VO | nil>
	pIcon:			<ButtonModel>
	pLabel:			<LabelModel>
	subContext: 	<CFplain>			for the selected item asReactiveVariable
	changeBlock: 	<Block>			for retarded when:changed:do aBlock
						
					
#subUI is the dynamic widget for the list element
!

!GloConnListUI class methodsFor: 'instance creation' stamp: 'hk 3/3/2015 19:47'!
on: aContext
	^self basicNew context: aContext; initialize! !

!GloConnListUI methodsFor: 'ui actions' stamp: 'hk 3/4/2015 12:16'!
activateSubContextWith: aCFView
	self initializeSubContextUI: aCFView on: context asvo copy .



! !

!GloConnListUI methodsFor: 'accessing' stamp: 'hk 3/31/2015 17:44'!
changeBlock
	^ changeBlock! !

!GloConnListUI methodsFor: 'accessing' stamp: 'hk 3/27/2015 18:45'!
clearSubUI
	widgets removeKey: #subUI ! !

!GloConnListUI methodsFor: 'accessing' stamp: 'hk 3/4/2015 12:59'!
context
	^context! !

!GloConnListUI methodsFor: 'accessing' stamp: 'hk 3/4/2015 13:05'!
context: aCF
	context := aCF ! !

!GloConnListUI methodsFor: 'ui actions' stamp: 'hk 3/4/2015 13:14'!
deleteSelection

	selection  ifNil: [ ^self notify: 'no selection' ] .
	context asvo removeCopy: selection pName.	
	self resetList .
	tableList resetSelection! !

!GloConnListUI methodsFor: 'ui actions' stamp: 'hk 3/4/2015 12:17'!
editSelectionWith: aCFView 

	selection  ifNil: [ ^self notify: 'no selection' ] .
	self initializeSubContextUI: aCFView on: selection! !

!GloConnListUI methodsFor: 'initialization' stamp: 'hk 3/31/2015 22:51'!
initializeLayout
	self layout: (SpecLayout composed newColumn: [ :c | 
		c 	newRow: [ :r | r
				add:  #pIcon width: 24 ;
				add:  #pLabel  ] height: self class toolbarHeight .
		self withSubUIDo: [ c add: #subUI ] 
			 without: [c add: #menuRow height: self class toolbarHeight .
					c add: #tableList] ] )  .
	self needFullRebuild: false .
	"the dynamically created subUI needs to react on a change"
	self subUIDo: [ :w | w whenChangedDo: changeBlock] .
							
	Transcript cr; show: 'initialize ListUI'! !

!GloConnListUI methodsFor: 'initialization' stamp: 'hk 3/27/2015 17:07'!
initializePresenter
	self list whenSelectedItemChanged: [ :item | selection :=  item ]
! !

!GloConnListUI methodsFor: 'initialization' stamp: 'hk 3/31/2015 17:41'!
initializeSubContextUI: aCFView on: aVO
	| sub subUI |
	sub := context cfPlain .
	sub vo: aVO .
	self subContext: sub.
	sub activeView: aCFView .
	subUI := sub newUI .
	subUI whenChangedDo: self changeBlock .
	self assign: subUI to: #subUI .
	pLabel label: (sub displayName) 



! !

!GloConnListUI methodsFor: 'initialization' stamp: 'hk 3/27/2015 18:13'!
initializeWidgets
	"(GloConnListUI on: ( (CFlist new: #bla) 
					asvo: ( (VO new: #pro) copy; yourself ) ; yourself )  ) 
			openWithSpec"

	subContext := nil asReactiveVariable .

	pIcon := self newButton icon: (GloConnIcons at: #processes) .
	pLabel := self newLabel label: (context displayName)  .
	menuRow := self paneMenu .
	tableList := TableListUI new .
	self resetList .
	self initializeLayout.
	
! !

!GloConnListUI methodsFor: 'accessing' stamp: 'hk 2/14/2015 17:16'!
items: aCollection
	tableList items: aCollection! !

!GloConnListUI methodsFor: 'accessing' stamp: 'hk 3/3/2015 19:53'!
list
	^tableList ! !

!GloConnListUI methodsFor: 'accessing' stamp: 'hk 2/14/2015 17:14'!
list: aCollection
	tableList list: aCollection! !

!GloConnListUI methodsFor: 'accessing' stamp: 'hk 3/3/2015 20:01'!
menuRow
	^ menuRow! !

!GloConnListUI methodsFor: 'ui actions' stamp: 'hk 3/4/2015 12:33'!
notify: aString
	owner notify: aString! !

!GloConnListUI methodsFor: 'accessing' stamp: 'hk 3/3/2015 20:05'!
pIcon
	^ pIcon! !

!GloConnListUI methodsFor: 'accessing' stamp: 'hk 3/3/2015 20:05'!
pLabel
	^ pLabel! !

!GloConnListUI methodsFor: 'initialization' stamp: 'hk 3/4/2015 12:37'!
paneMenu
	"build the pane contexts own menu with a little help by the ROs"
	^MenuModel new addGroup: 
		[ :g | context roles do:  
			[:r | r hasMenu ifTrue: 
				[g addMenuItem: (r menuFor: (Array with: context with: self ) 
									callBack: [ :s | self notify: s ] ) ] ]] 	
! !

!GloConnListUI methodsFor: 'protocol' stamp: 'hk 3/4/2015 13:21'!
resetList
	self resetList: nil
! !

!GloConnListUI methodsFor: 'protocol' stamp: 'hk 3/4/2015 13:21'!
resetList: item
	tableList items: context list.
	tableList setSelectedItem: item
! !

!GloConnListUI methodsFor: 'protocol' stamp: 'hk 3/4/2015 13:21'!
resetSelection
	tableList resetSelection.
	selection := nil.! !

!GloConnListUI methodsFor: 'accessing' stamp: 'hk 3/4/2015 11:59'!
subContext
	^subContext value! !

!GloConnListUI methodsFor: 'accessing' stamp: 'hk 3/4/2015 11:58'!
subContext: aCF
	subContext value: aCF ! !

!GloConnListUI methodsFor: 'language' stamp: 'hk 3/27/2015 19:11'!
subUIDo: aBlock 
	^aBlock value: (self widgets at: #subUI  ifAbsent:  [^[ ] ] ) ! !

!GloConnListUI methodsFor: 'accessing' stamp: 'hk 3/3/2015 19:55'!
tableList
	^ tableList! !

!GloConnListUI methodsFor: 'protocol' stamp: 'hk 3/27/2015 18:44'!
title
	^ 'GloConnList widget'! !

!GloConnListUI methodsFor: 'protocol-events' stamp: 'hk 3/31/2015 17:43'!
whenChangedDo: aBlock    
	"tell on what change shall be redrawn"
"	subContext whenChangedDo: aBlock.
	view whenChangedDo: aBlock."
	Transcript cr; show: 'whenChangedDo ListUI' .
	changeBlock := aBlock . 	"must be retarded to initializeSubContextUI:on:  "
	pLabel whenLabelChanged: aBlock .! !

!GloConnListUI methodsFor: 'protocol-events' stamp: 'hk 2/14/2015 17:14'!
whenSelectedItemChanged: aBlock
	tableList whenSelectedItemChanged: aBlock! !

!GloConnListUI methodsFor: 'language' stamp: 'hk 3/27/2015 18:56'!
withSubUIDo: aBlock without: anotherBlock
	self widgets at: #subUI  ifAbsent:  [^anotherBlock value] . 
	^aBlock value! !

DynamicComposableModel subclass: #GloConnMainUI
	instanceVariableNames: 'loginName password loginNameLabel height menu lastCommand status context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-App'!

!GloConnMainUI commentStamp: 'hk 3/4/2015 10:57' prior: 0!
I am the app main window model.

Most of my widgets are assigned and thus referenced via self widgets. 

Instance Variables
	height:				<Numbert>
	lastCommand:		<Symbol | nil>				the widget to be displayed next 
	loginName:			<TextInputFieldModel>
	loginNameLabel:	<LabelModel>
	status: 			 	<LabelModel>				for a single status line, may become more
	menu:				<MenuModel>				main menu
	password:			<TextInputFieldModel>
	context:			<CF>						preset context

!

!GloConnMainUI class methodsFor: 'instance creation' stamp: 'hk 3/4/2015 10:14'!
on: aContext
	^ self basicNew
		context: aContext;
		initialize;
		yourself! !

!GloConnMainUI class methodsFor: 'instance creation' stamp: 'hk 1/24/2015 17:56'!
title
    ^ ''! !

!GloConnMainUI methodsFor: 'private' stamp: 'hk 1/26/2015 10:27'!
ableMainButtonMenu: aBoolean 	
	menu menuGroups do: [ :g |
		g menuItems do: [ :m | m enabled: aBoolean ] ]  ! !

!GloConnMainUI methodsFor: 'ui actions' stamp: 'hk 3/4/2015 11:08'!
action: aCF
	lastCommand := aCF aspect  .
	self reOpen ! !

!GloConnMainUI methodsFor: 'initialization - main button menu' stamp: 'hk 3/2/2015 18:25'!
addBizNetButtonGroup:g  	
			g addItem: [  :i | i
				icon: (GloConnIcons at: #bizProcess) ;
				description: 'show biz processes' ;
				action: [  ] ] .
			g addItem: [  :i | i
				icon: (GloConnIcons at: #bizNet) ;
				description: 'show biz net' ;
				action: [  ] ] ! !

!GloConnMainUI methodsFor: 'initialization - main button menu' stamp: 'hk 3/2/2015 18:25'!
addCommunicationButtonGroup:g	
			g addItem: [  :i | i
				icon: (GloConnIcons at: #contacts) ;
				description: 'show contacts' ;
				action: [  ] ] .
			g addItem: [  :i | i
				icon: (GloConnIcons at: #route) ;
				description: 'show route planning' ;
				action: [  ] ] .
			g addItem: [  :i | i
				icon: (GloConnIcons at: #mail );
				description: 'show mail' ;
				action: [  ] ]  ! !

!GloConnMainUI methodsFor: 'initialization - main button menu' stamp: 'hk 3/2/2015 18:26'!
addControllingButtonGroup:g 	
			g addItem: [  :i | i
				icon: (GloConnIcons at: #controlling) ;
				description: 'show controlling' ;
				action: [  ] ] ! !

!GloConnMainUI methodsFor: 'initialization - layout' stamp: 'hk 1/25/2015 15:28'!
addLogin: aRow
	aRow	add: #loginLabel width: 120;
			add: #loginNameLabel width: 160;
			add: #logout width: 80! !

!GloConnMainUI methodsFor: 'initialization - layout' stamp: 'hk 1/25/2015 15:28'!
addLoginRow: aColumn
	aColumn newRow: [ :r | 
			r add: #emptyLabel.
			self loginName text isEmpty
				ifTrue: [ self addLogout: r ]
				ifFalse: [ self addLogin: r ] ]
		height: self singleHeight.
	height := height + self singleHeight! !

!GloConnMainUI methodsFor: 'initialization - layout' stamp: 'hk 1/25/2015 15:26'!
addLogo: aColumn
	aColumn add: #emptyButton height: 150.
	aColumn addSplitter.
	height := height + 150! !

!GloConnMainUI methodsFor: 'initialization - layout' stamp: 'hk 1/25/2015 15:29'!
addLogout: aRow
	aRow	add: #loginName width: 120;
			add: #password width: 120;
			add: #login width: 80! !

!GloConnMainUI methodsFor: 'initialization - layout' stamp: 'hk 1/25/2015 15:41'!
addMainButtons: aColumn
	aColumn add: #menu height: self singleHeight.
	height := height + self singleHeight ! !

!GloConnMainUI methodsFor: 'initialization - main button menu' stamp: 'hk 2/3/2015 11:49'!
addMenuGap: g	
	 g addItem: [ :i | 
		i icon: (Smalltalk ui icons blankIconOfWidth: 144) ] ! !

!GloConnMainUI methodsFor: 'initialization - main button menu' stamp: 'hk 3/4/2015 11:11'!
addMiscellaneousButtonGroup: g
	g	addItem: [ :i | i
				icon: (GloConnIcons at: #calc) ;
				description: 'calculator';
				action: [ self action: (context views detect: [ :v | v aspect = #calcPane ] ) ] ].
	g	addItem: [ :i | i
				icon: (GloConnIcons at: #settings) ;
				description: 'settings';
				action: [  ] ].
	g	addItem: [ :i | i
				icon: (GloConnIcons at: #user) ;
				description: 'show user data';
				action: [  ] ]! !

!GloConnMainUI methodsFor: 'initialization - main button menu' stamp: 'hk 3/4/2015 11:42'!
addProcessButtonGroup: g 	
			g addItem: [  :i | i
				icon: (GloConnIcons at: #dash) ;
				description: 'show dash board' ;
				action: [ self dashboardAction] ] .
			g addItem: [  :i | i
				icon: (GloConnIcons at: #processes) ;
				description: 'show biz processes' ;
				action: [ self action: (context views detect: [ :v | v aspect = #bizProcessesPane "achtung unsauber !!" ] )  ] ] ! !

!GloConnMainUI methodsFor: 'protocol' stamp: 'hk 3/3/2015 20:07'!
addStatus: aString
	"may be enhanced to keep a stack"
	aString isEmpty ifFalse:  [status text: aString]! !

!GloConnMainUI methodsFor: 'initialization - main button menu' stamp: 'hk 3/2/2015 18:26'!
addTourButtonGroup: g 	
			g addItem: [  :i | i
				icon: (GloConnIcons at: #tourPlan) ;
				description: 'show transport planning' ;
				action: [  ] ] .
			g addItem: [  :i | i
				icon: (GloConnIcons at: #tour) ;
				description: 'show tour planning' ;
				action: [  ] ] .
			g addItem: [  :i | i
				icon: (GloConnIcons at: #tourSub) ;
				description: 'show subcontracts' ;
				action: [  ] ] ! !

!GloConnMainUI methodsFor: 'initialization' stamp: 'hk 3/2/2015 18:26'!
assignHeader
	self assign: (ButtonModel new
			 		state: false;
					icon: (GloConnIcons at: #header)) to: #emptyButton.
	self assign: (ButtonModel new
					action: [ self loginAction ];
					state: true;
					label: 'login') to: #login.
	self assign: (ButtonModel new
					action: [ self logoutAction ];
					state: true;
					label: 'logout') to: #logout.
	self assign: (LabelModel new 		
					text: 'Eingeloggt als ') to: #loginLabel.	
	"shifts login to the right:"
	self assign: LabelModel new to: #emptyLabel .
	self assign: (TextModel new enabled: false; text: 'GloConn International © 2015' ) to: #legal .! !

!GloConnMainUI methodsFor: 'initialization - layout' stamp: 'hk 3/1/2015 14:39'!
buildColumn: aColumn
	self addLogo: aColumn.
	self addLoginRow: aColumn.
	self addMainButtons: aColumn .
	aColumn add: #status height: self class toolbarHeight *0.8 .
	aColumn add: self lastCommand .
	aColumn add: #legal height: self class toolbarHeight * 0.8.
	height := height + 650 
! !

!GloConnMainUI methodsFor: 'accessing cf' stamp: 'hk 3/4/2015 10:15'!
context
	^context! !

!GloConnMainUI methodsFor: 'accessing cf' stamp: 'hk 3/4/2015 10:15'!
context: aCF
	context := aCF! !

!GloConnMainUI methodsFor: 'ui actions' stamp: 'hk 3/4/2015 11:10'!
dashboardAction
	 self action: (context views detect: [ :v | v aspect = #dashPane ] ) ! !

!GloConnMainUI methodsFor: 'accessing' stamp: 'hk 1/25/2015 15:11'!
fullWidth
	^ 1200 +4! !

!GloConnMainUI methodsFor: 'accessing' stamp: 'hk 1/24/2015 18:21'!
height
	^height ! !

!GloConnMainUI methodsFor: 'initialization' stamp: 'hk 1/25/2015 11:20'!
initialExtent
	^ self fullWidth  @ self height ! !

!GloConnMainUI methodsFor: 'initialization - layout' stamp: 'hk 2/21/2015 14:20'!
initializeLayout
	"(GloConnMainUI onM: (CF new: #bla) onP: ( (CFlist new: #bla) 
					asvo: ( (VO new: #pro) copy; yourself ) ; yourself ) ) openWithSpec"

	height := self singleHeight .
	self layout: (SpecLayout composed newColumn: [ :c | self buildColumn: c ] ).
	self needFullRebuild: false.! !

!GloConnMainUI methodsFor: 'initialization' stamp: 'hk 2/10/2015 16:57'!
initializeLogin
	(loginName := self newTextInput )
		autoAccept: true ;
		ghostText: 'login name'  .
	(password := self newTextInput )
		autoAccept: true ;
		ghostText: 'password' .
	(loginNameLabel := self newLabel )
		text: self loginName text .
! !

!GloConnMainUI methodsFor: 'initialization' stamp: 'hk 2/10/2015 13:10'!
initializeMainButtonMenu 	
	(menu := MenuModel new) addGroup: [ :g |
		self addProcessButtonGroup: g .
		self addMenuGap: g .
		self addTourButtonGroup: g .
		self addMenuGap: g .
		self addControllingButtonGroup: g .
		self addMenuGap: g .
		self addCommunicationButtonGroup: g .
		self addMenuGap: g .
		self addBizNetButtonGroup: g .
		self addMenuGap: g .
		self addMiscellaneousButtonGroup: g ].
	self ableMainButtonMenu: false .
! !

!GloConnMainUI methodsFor: 'initialization' stamp: 'hk 3/26/2015 19:20'!
initializePresenter
	"context views do: [  :v |  (widgets at: v aspect) whenChangedDo: [ self reOpen ] ]"
	
	self widgetsDo: [ :w | (w respondsTo: #whenChangedDo: ) ifTrue:  [w whenChangedDo: [ self reOpen ] ]]
	
! !

!GloConnMainUI methodsFor: 'initialization' stamp: 'hk 3/4/2015 11:37'!
initializeWidgets
	self assignHeader.
	self initializeLogin .
	self initializeMainButtonMenu .
	status := self newText enabled: false .
	self assign: GloConnEmptyUI new to: #emptyPane.	
	context views do: [ :v | self assign: v newUI to: v aspect] .
	self initializeLayout ! !

!GloConnMainUI methodsFor: 'accessing' stamp: 'hk 2/10/2015 12:56'!
lastCommand
	^ lastCommand ifNil: [ lastCommand := #emptyPane ]! !

!GloConnMainUI methodsFor: 'ui actions' stamp: 'hk 1/26/2015 10:57'!
login:  aString  password: anotherString 
	 ^aString isNotEmpty ! !

!GloConnMainUI methodsFor: 'ui actions' stamp: 'hk 1/26/2015 10:38'!
loginAction
	loginNameLabel text:  loginName text.
	(self login: loginName text password: password text)
		ifFalse: [ ^self logoutAction  ].
	self ableMainButtonMenu: true .
	self dashboardAction  ! !

!GloConnMainUI methodsFor: 'accessing' stamp: 'hk 2/10/2015 16:52'!
loginName
	^ loginName! !

!GloConnMainUI methodsFor: 'accessing' stamp: 'hk 1/24/2015 17:38'!
loginNameLabel
	^ loginNameLabel! !

!GloConnMainUI methodsFor: 'ui actions' stamp: 'hk 2/10/2015 13:01'!
logoutAction
	loginName text: '' .
	password text: '' .
	lastCommand := #emptyPane .
	self ableMainButtonMenu: false .
	self reOpen ! !

!GloConnMainUI methodsFor: 'accessing' stamp: 'hk 1/25/2015 15:41'!
menu
	^ menu! !

!GloConnMainUI methodsFor: 'ui actions' stamp: 'hk 3/4/2015 12:32'!
notify: aString
	"write the status line   -   tbd"
	self addStatus: aString! !

!GloConnMainUI methodsFor: 'accessing' stamp: 'hk 2/10/2015 16:52'!
password
	^ password! !

!GloConnMainUI methodsFor: 'private' stamp: 'hk 2/21/2015 13:25'!
reOpen
	self initializeLayout.
	(widgets at: (self lastCommand)) initializeLayout .
	self openWithSpec
! !

!GloConnMainUI methodsFor: 'accessing' stamp: 'hk 1/24/2015 18:18'!
singleHeight
	^self class toolbarHeight ! !

!GloConnMainUI methodsFor: 'accessing' stamp: 'hk 3/1/2015 14:39'!
status
	^status! !

DynamicComposableModel subclass: #GloConnProcessCustUI
	instanceVariableNames: 'context view mode editLocalButton chooseContactButton newContactButton empty refreshingBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-App'!

!GloConnProcessCustUI commentStamp: 'hk 3/28/2015 14:18' prior: 0!
A GloConnProcessCustUI is xxxxxxxxx.

Instance Variables
	context:			<CFplain>
	view:				<SvoView>										of the slot of my view
	mode: 				<#noContact | #contact | #newContact>  		a NewValueHolder
	newContactButton:	<ButtonModel>
	chooseContactButton:	<ButtonModel>
	editLocalButton:			<ButtonModel>
	empty: 			<LabelModel>
				refreshingBlock!

!GloConnProcessCustUI class methodsFor: 'instance creation' stamp: 'hk 3/31/2015 21:30'!
on: aContext
	^self basicNew context: aContext; setup; initialize! !

!GloConnProcessCustUI methodsFor: 'initialization' stamp: 'hk 4/3/2015 17:09'!
addViewFor: aVO
	
		view := (ViewSVO at: (context vo) 
			ifAbsent: [^ self notify: 'no view defined in ',  context pName ] ) .
		self view model: aVO ! !

!GloConnProcessCustUI methodsFor: 'ui actions' stamp: 'hk 3/27/2015 14:21'!
chooseContact
	mode value: #contact .

	! !

!GloConnProcessCustUI methodsFor: 'accessing' stamp: 'hk 3/27/2015 16:00'!
chooseContactButton
	^ chooseContactButton! !

!GloConnProcessCustUI methodsFor: 'accessing' stamp: 'hk 3/14/2015 18:41'!
context: aCFplain
	context := aCFplain! !

!GloConnProcessCustUI methodsFor: 'ui actions' stamp: 'hk 3/31/2015 21:26'!
editLocal
	mode value: #noContact! !

!GloConnProcessCustUI methodsFor: 'accessing' stamp: 'hk 3/27/2015 15:58'!
editLocalButton
	^ editLocalButton! !

!GloConnProcessCustUI methodsFor: 'accessing' stamp: 'hk 3/27/2015 16:10'!
empty
	^ empty! !

!GloConnProcessCustUI methodsFor: 'initialization' stamp: 'hk 4/8/2015 16:50'!
initializeLayout
	| h |    
	h := self class toolbarHeight .
	self withContactDo: 
		[self view projectors do: 
		[ :a | self assign: (LabelModel new label: ( self view perform: a key)) 
				to: a key ] ] .
	self layout: (SpecLayout composed newColumn: [ :c | 
		c newRow: [ :r | 
				r add: #editLocalButton width: 100. 
				r add: #chooseContactButton width: 100 .
				r add: #newContactButton width: 100 .
				r add: #empty ] height: h.
		self withContactDo: [c newRow: [ :r | self view projectors do: [ :a |r add: a key]  ] height: h] .
		self withNewContactDo: [ c add: #newContactWidget ] else: [ c add: #empty  ] . 
		] ) .  
	self needRebuild: false.
! !

!GloConnProcessCustUI methodsFor: 'initialization' stamp: 'hk 4/2/2015 17:36'!
initializePresenter
"	mode whenChangedDo: 
		[ self initializeLayout. 
		self buildWithSpec ]"! !

!GloConnProcessCustUI methodsFor: 'initialization' stamp: 'hk 4/2/2015 17:26'!
initializeWidgets
	editLocalButton := self newButton 
		label: #edit; 
		state: true; 
		action: [ self editLocal ]
		yourself .
	chooseContactButton := self newButton
		label: 'choose Contact'; 
		state: true; 
		action: [ self chooseContact  ] ;
		yourself.
	newContactButton := self newButton
		 label: 'new Contact'; 
		state: true; 
		action: [ self newContact ]
		yourself.
	empty := self newLabel .
	self initializeLayout.
! !

!GloConnProcessCustUI methodsFor: 'ui actions' stamp: 'hk 4/7/2015 13:07'!
newContact
	self assign: ( GcVoUI on: self newContactVo ) to: #newContactWidget .
	mode value: #newContact .
	self initializeLayout.
	self buildWithSpec

	! !

!GloConnProcessCustUI methodsFor: 'accessing' stamp: 'hk 3/27/2015 14:30'!
newContactButton
	^ newContactButton! !

!GloConnProcessCustUI methodsFor: 'initialization' stamp: 'hk 4/3/2015 17:07'!
newContactVo
	
	^( (DomainSVO at: context aspectType) 
		ifNil: [^ self notify: 'no aspectType in ',  context pName ] ) 
			copy
! !

!GloConnProcessCustUI methodsFor: 'accessing' stamp: 'hk 3/28/2015 14:18'!
refreshingBlock: aBlock
	refreshingBlock := aBlock! !

!GloConnProcessCustUI methodsFor: 'initialization' stamp: 'hk 4/3/2015 17:07'!
setup
	"check the context, the view and its model"
	
	| slot slotType |
	mode := #noContact asReactiveVariable .
	slot :=  context elder vo slotAt: context aspect.
	slotType := (DomainSVO at: context aspectType) 
		ifNil: [^ self notify: 'no aspectType in ',  context pName ]  .
	slot  ifNotNil: [mode value: #contact ] .
	self withContactDo: [ self addViewFor: slot svo ] .  
	super initialize
! !

!GloConnProcessCustUI methodsFor: 'accessing' stamp: 'hk 3/26/2015 14:39'!
view
	^view ! !

!GloConnProcessCustUI methodsFor: 'accessing' stamp: 'hk 3/26/2015 14:39'!
view: aView
	view := aView! !

!GloConnProcessCustUI methodsFor: 'language' stamp: 'hk 3/26/2015 15:09'!
withContactDo: aBlock
	(mode value = #contact) ifTrue: aBlock! !

!GloConnProcessCustUI methodsFor: 'language' stamp: 'hk 3/26/2015 15:09'!
withNewContactDo: aBlock
	(mode value = #newContact) ifTrue: aBlock! !

!GloConnProcessCustUI methodsFor: 'language' stamp: 'hk 4/8/2015 16:50'!
withNewContactDo: aBlock else: elseBlock 
	^(mode value = #newContact) ifTrue: aBlock ifFalse: elseBlock! !

DynamicComposableModel subclass: #GloConnProcessUI
	instanceVariableNames: 'context list selection subContext pLabel view tabManager tabs paneMenu selectedTab changeBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-App'!

!GloConnProcessUI commentStamp: 'hk 3/31/2015 20:23' prior: 0!
A GloProcessesUI is xxxxxxxxx.

Instance Variables
	context:		<CFlist>
	list: 			<TableListUI>					of only one item
	selection: 		<VO>							BizProcess selected
	pLabel:			<LabelModel>					label for the context icon
	tabs: 			<Dictionary of TabModel>
	tabManager: 	<TabManagerModel>
	selectedTab: 	<Tab>
	changeBlock: !

!GloConnProcessUI class methodsFor: 'instance creation' stamp: 'hk 2/8/2015 14:45'!
on: aContext
	^self basicNew context: aContext; initialize! !

!GloConnProcessUI methodsFor: 'initialization' stamp: 'hk 3/31/2015 18:12'!
InitializeTabs  

	self context views do: [ :v |  |key icon newTab oldTab |
		key := v displayName .
		icon := GloConnIcons  iconAt: key .
		(newTab := self newTab) 
				label: key ;
				icon: icon ;
				model: (self newModelFor: v refreshBy:  changeBlock )  .
		(oldTab := self tabs at: key ifAbsent: [] )
			ifNotNil: [tabManager tabs remove: oldTab] .
		self addTab: newTab . 
		tabManager addTab: newTab ].
! !

!GloConnProcessUI methodsFor: 'accessing' stamp: 'hk 2/22/2015 17:36'!
addTab: aTab
	self tabs add: aTab label -> aTab! !

!GloConnProcessUI methodsFor: 'ui actions' stamp: 'hk 3/31/2015 20:23'!
backToContext
	owner clearSubUI.	
	owner pLabel text: (owner context displayName) .
	owner resetList: context vo .
! !

!GloConnProcessUI methodsFor: 'accessing' stamp: 'hk 3/4/2015 12:56'!
context
	^context! !

!GloConnProcessUI methodsFor: 'accessing' stamp: 'hk 3/4/2015 13:07'!
context: aCF
	context := aCF ! !

!GloConnProcessUI methodsFor: 'initialization' stamp: 'hk 3/4/2015 12:43'!
initPaneMenu
	"build the pane contexts own menu with a little help by the ROs"
	paneMenu := MenuModel new addGroup: [ :g | 
			g addItem: [ :i |  i
					icon: Smalltalk ui icons backIcon ;
					action: [ self backToContext ] ].
			self context roles do:  
				[:r | r hasMenu ifTrue: 
					[g addMenuItem: (r menuFor: (Array with: context with: self ) 
									callBack: [ :s | self notify: s ] ) ] ] ] 
! !

!GloConnProcessUI methodsFor: 'initialization' stamp: 'hk 3/31/2015 22:51'!
initializeLayout
	self layout: (SpecLayout composed newColumn: [ :c | 
		c add: #paneMenu height: self singleHeight .
		c add: #list height: 2 * self singleHeight  .				
		c add: #tabManager ] ).
	self needFullRebuild: false .

! !

!GloConnProcessUI methodsFor: 'initialization' stamp: 'hk 3/27/2015 16:27'!
initializeWidgets
	"(GloConnProcessUI on: ( (CFlist new: #bla) 
					asvo: ( (VO new: #pro) copy; yourself ) ; yourself )  ) 
			openWithSpec"
	self initPaneMenu .
	(list := TableListUI new ) items: (Array with: context vo).
	tabManager := self newTabManager .
	self InitializeTabs  .

	self initializeLayout.
	
Transcript cr; show: 'initialize ProcessUI'! !

!GloConnProcessUI methodsFor: 'accessing' stamp: 'hk 2/9/2015 19:20'!
list
	^list! !

!GloConnProcessUI methodsFor: 'initialization' stamp: 'hk 3/31/2015 20:40'!
newModelFor: aView refreshBy: aBlock
	"create the UImodel for the view, fall back, if there is no UIclass
	- no 'instantiate' for the owner chain is used in the TabExamples -"
	
	| uiClass    |    
	uiClass := Smalltalk at: aView uiClass ifAbsent: [^LabelModel new text: aView displayName]  . 
	^aView newUI refreshingBlock: aBlock
! !

!GloConnProcessUI methodsFor: 'ui actions' stamp: 'hk 3/4/2015 12:33'!
notify: aString
	owner notify: aString! !

!GloConnProcessUI methodsFor: 'accessing' stamp: 'hk 2/20/2015 15:38'!
pLabel
	^pLabel! !

!GloConnProcessUI methodsFor: 'accessing' stamp: 'hk 3/4/2015 12:57'!
paneMenu
	^paneMenu! !

!GloConnProcessUI methodsFor: 'accessing' stamp: 'hk 2/13/2015 12:54'!
selection
	^selection ! !

!GloConnProcessUI methodsFor: 'accessing' stamp: 'hk 2/20/2015 20:42'!
singleHeight 
	^self class toolbarHeight! !

!GloConnProcessUI methodsFor: 'accessing' stamp: 'hk 2/22/2015 16:20'!
tabManager
	^ tabManager! !

!GloConnProcessUI methodsFor: 'accessing' stamp: 'hk 2/22/2015 17:31'!
tabs
	^tabs ifNil: [ tabs := Dictionary new ]! !

!GloConnProcessUI methodsFor: 'protocol - events' stamp: 'hk 4/2/2015 17:30'!
whenChangedDo: aBlock
	"tell on what change shall be redrawn"  
! !

DynamicComposableModel subclass: #SvoCalc
	instanceVariableNames: 'display button0 button1 button2 button3 button4 button5 button6 button7 button8 button9 buttonPlus buttonMinus buttonMult buttonDiv buttonEq buttonDot buttonSqr buttonLog buttonChange buttonClear previousNumber currentOperation operationPending'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Utilities'!

!SvoCalc commentStamp: 'hk 11/6/2014 18:58' prior: 0!
A SpoCalc is the Spec Demo Calculator enhanced.

Instance Variables
	display:				<TextInput>	the calculators input & display
	currentOperation:	<String>		the operation to be performed:  +  -  * / 
	operationPending:	<Bolean>		true after pressing +  -  * /  =
										means: new input expected
	previousNumber:	<Number | nil>	stores the first value entered
										no operation pending ifNil
			
	button0:			<Button>
	button1:			<Button>
	button2:			<Button>
	button3:			<Button>
	button4:			<Button>
	button5:			<Button>
	button6:			<Button>
	button7:			<Button>
	button8:			<Button>
	button9:			<Button>
	buttonChange:		<Button>
	buttonClear:		<Button>
	buttonDiv:			<Button>
	buttonDot:			<Button>
	buttonEq:			<Button>
	buttonLog:			<Button>
	buttonMinus:		<Button>
	buttonMult:			<Button>
	buttonPlus:			<Button>
	buttonSqr:			<Button>

!

!SvoCalc class methodsFor: 'specs' stamp: 'hk 1/21/2015 16:02'!
example
	"SvoCalc example"

	SvoCalc new openWithSpec! !

!SvoCalc class methodsFor: 'specs' stamp: 'hk 1/5/2015 14:43'!
title 
	^ 'SVO Calculator'! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/5/2014 17:01'!
addition
	buttonPlus
		label: '+';
		action: [ self operation: $+ ];
		state: true! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:37'!
button0
	^ button0! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:35'!
button1
	^ button1! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button2
	^ button2! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button3
	^ button3! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button4
	^ button4! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button5
	^ button5! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button6
	^ button6! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button7
	^ button7! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button8
	^ button8! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
button9
	^ button9! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:35'!
buttonChange
	^ buttonChange! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:35'!
buttonClear
	^ buttonClear! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
buttonDiv
	^ buttonDiv! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:37'!
buttonDot
	^ buttonDot! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:37'!
buttonEq
	^ buttonEq! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:35'!
buttonLog
	^ buttonLog! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:37'!
buttonMinus
	^ buttonMinus! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:36'!
buttonMult
	^ buttonMult! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:37'!
buttonPlus
	^ buttonPlus! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:35'!
buttonSqr
	^ buttonSqr! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/5/2014 18:02'!
changeSign
	buttonChange
		label: '+/ -';
		action: [ display label: display label asNumber negated asString ];
		state: true! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/6/2014 16:13'!
clearDisplay
	buttonClear
		label: 'C';
		action: [ display label: '0' ];
		state: true! !

!SvoCalc methodsFor: 'private' stamp: 'hk 11/6/2014 14:56'!
defineDigitButton: aButton label: aString
	aButton
		label: aString;
		action: [ display label: (self newDisplayLabelFor: aString) asNumber asString  ];
		state: true! !

!SvoCalc methodsFor: 'button definition' stamp: 'hk 11/6/2014 14:57'!
defineDigitButtons
	button0
		label: '0' ;
		action: [ display label: (self newDisplayLabelFor: '0' )  ];
		state: true.
	self defineDigitButton: button1 label: '1'.
	self defineDigitButton: button2 label: '2'.
	self defineDigitButton: button3 label: '3'.
	self defineDigitButton: button4 label: '4'.
	self defineDigitButton: button5 label: '5'.
	self defineDigitButton: button6 label: '6'.
	self defineDigitButton: button7 label: '7'.
	self defineDigitButton: button8 label: '8'.
	self defineDigitButton: button9 label: '9'.
! !

!SvoCalc methodsFor: 'button definition' stamp: 'hk 11/5/2014 14:45'!
defineOtherButtons
	"basic arithmetic operations"
	self addition.
	self subtraction.
	self multiplication.
	self division.	
		
	"other arithmetic opertions"
	self squareRoot.
	self logarithm.
	self changeSign.	
		
	"remaining buttons"
	self clearDisplay.
	self enterDot.
	self equals! !

!SvoCalc methodsFor: 'accessing' stamp: 'hk 11/5/2014 17:34'!
display
	^ display! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/5/2014 17:06'!
division
	buttonDiv
		label: '/';
		action: [ self operation: $/ ];
		state: true! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/6/2014 15:56'!
enterDot
	buttonDot
		label: '.';
		action: [display label: (self newDisplayLabelForDot )  ];
		state: true! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/6/2014 16:12'!
equals
	buttonEq
		label: '=';
		action: [ operationPending := true. 
				previousNumber ifNotNil: 
					[display label: (previousNumber perform: currentOperation asSymbol with:  display label asNumber ) asString].
				previousNumber := nil ];
		state: true! !

!SvoCalc methodsFor: 'initialization' stamp: 'hk 1/25/2015 20:39'!
height
	"(4@4) is the size of the border"

	^ 187 + (4 @ 4)! !

!SvoCalc methodsFor: 'initialization' stamp: 'hk 1/25/2015 20:39'!
initialExtent
	"(4@4) is the size of the border"

	^ 247 @ self height! !

!SvoCalc methodsFor: 'initialization' stamp: 'hk 11/6/2014 15:36'!
initialize
	operationPending  := false.
	super initialize! !

!SvoCalc methodsFor: 'initialization' stamp: 'hk 11/5/2014 14:33'!
initializeDigitButtons
	button0 := self newButton.
	button1 := self newButton.
	button2 := self newButton.
	button3 := self newButton.
	button4 := self newButton.
	button5 := self newButton.
	button6 := self newButton.
	button7 := self newButton.
	button8 := self newButton.
	button9 := self newButton.
	self defineDigitButtons! !

!SvoCalc methodsFor: 'initialization' stamp: 'hk 1/25/2015 20:49'!
initializeLayout
	self layout: (SpecLayout composed
		newColumn: [ :column | column
						add: #display ;
						newRow: [ :row1 | row1
										add: #buttonClear;
										add: #buttonLog;
										add: #buttonChange;
										add: #buttonSqr ] height: 26;
						newRow: [ :row2 | row2
										add: #button1;
										add: #button2;
										add: #button3;
										add: #buttonDiv ] height: 26;
						newRow: [ :row3 | row3
										add: #button4;
										add: #button5;
										add: #button6;
										add: #buttonMult ] height: 26;
						newRow: [ :row4 | row4
										add: #button7;
										add: #button8;
										add: #button9;
										add: #buttonMinus ] height: 26;
						newRow: [ :row5 | row5
										add: #buttonDot;
										add: #button0;
										add: #buttonEq;
										add: #buttonPlus ] height: 26 ];
		yourself)! !

!SvoCalc methodsFor: 'initialization' stamp: 'hk 11/5/2014 14:46'!
initializeOtherButtons
	"instantiate the basic arithmetic buttons"

	buttonPlus := self newButton.
	buttonMinus := self newButton.
	buttonMult := self newButton.
	buttonDiv := self newButton.
	buttonEq := self newButton.	
		
	"instantiate the remaining buttons"
	buttonDot := self newButton.
	buttonSqr := self newButton.
	buttonLog := self newButton.
	buttonChange := self newButton.
	buttonClear := self newButton.
	
	self defineOtherButtons! !

!SvoCalc methodsFor: 'initialization' stamp: 'hk 1/25/2015 19:58'!
initializeWidgets 
	self initializeDigitButtons. 
	self initializeOtherButtons. 
	display := self newLabel.
	self initializeLayout ! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/5/2014 17:17'!
logarithm
	buttonLog
		label: 'Log';
		action: [ display label: display label asNumber log asString ];
		state: true! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/5/2014 18:26'!
multiplication
	buttonMult
		label: 'x';
		action: [ self operation: $* ];
		state: true! !

!SvoCalc methodsFor: 'private' stamp: 'hk 11/6/2014 15:31'!
newDisplayLabelFor: aString
	^operationPending ifTrue: [operationPending  := false. aString ]  ifFalse: [ display label , aString ] ! !

!SvoCalc methodsFor: 'private' stamp: 'hk 11/6/2014 16:06'!
newDisplayLabelForDot
	^ (operationPending or: [display label isEmpty])
		ifTrue: [ operationPending := false.  '0.' ]
		ifFalse: [  (display label includes: $.) 
						ifTrue: [ display label ] 
						ifFalse:  [ display label,  '.' ] ]! !

!SvoCalc methodsFor: 'private' stamp: 'hk 11/6/2014 16:16'!
operation: aCharacter
	"Defines which operation will be performed: it can be a + / - x"

	previousNumber := display label asNumber.	
	currentOperation := aCharacter.				
	operationPending  := true.! !

!SvoCalc methodsFor: 'private' stamp: 'hk 11/5/2014 17:08'!
sqrCheck
	"checks whether we are attempting to calculate the square root of a negative
number"

	display label asNumber < 0
		ifTrue: [ display label: 'Error' ]
		ifFalse: [ display label: display label asNumber sqrt asString ]! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/5/2014 17:07'!
squareRoot
	buttonSqr
		label: 'Sqr';
		action: [ self sqrCheck ];
		state: true! !

!SvoCalc methodsFor: 'operations' stamp: 'hk 11/5/2014 17:05'!
subtraction
	buttonMinus
		label: '-';
		action: [ self operation: $- ];
		state: true! !

DynamicComposableModel subclass: #SvoListUI
	instanceVariableNames: 'list listHeight model emptyLabel editBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-SVO'!

!SvoListUI commentStamp: 'hk 2/5/2015 13:01' prior: 0!
A SpoListUI is an abstract superclass for a list slot UI

Instance Variables
	list:			<ListModel>
	listHeight:
	model:
	emptyLabel: 
	editBlock:
!

SvoListUI subclass: #SvoDynamicListUI
	instanceVariableNames: 'source button'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-SVO'!

!SvoDynamicListUI commentStamp: 'hk 12/14/2014 11:41' prior: 0!
I am a UI for a DSL generated list

Instance Variables
	button:		<ButtonModel>			the exec button of the DSL
	source:		<TextInputFieldModel>	the DSL source !

!SvoDynamicListUI methodsFor: 'accessing' stamp: 'hk 12/14/2014 11:32'!
button
	^ button! !

!SvoDynamicListUI methodsFor: 'ui-actions' stamp: 'hk 1/14/2015 13:29'!
exec
	| res |
	model source: source text.
	(res := model exec) isString ifTrue: [ SvoSpecUI alert: res ] .
	list items: model list 
	! !

!SvoDynamicListUI methodsFor: 'as yet unclassified' stamp: 'hk 1/21/2015 16:15'!
height
	^ super height + self singleHeight ! !

!SvoDynamicListUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 21:33'!
initializeLayout
	"(SpoDynamicListUI on: SpoDynamicList new) openWithSpec"

	self layout: (SpecLayout composed
		newColumn: [ :c |  
			c newRow:  [ :r |  r 
				add: #source ; add: #button width: 80] 
				height: self singleHeight .
			c add: #list  ]  )! !

!SvoDynamicListUI methodsFor: 'initialization' stamp: 'hk 1/19/2015 15:09'!
initializeWidgets
	"(SpoDynamicListUI on: SvoDynamicList new) openWithSpec"
	source := (self newTextInput)
						autoAccept: true;
						ghostText: 'undefined'.
	source text: model source.
	(button := self newButton)
		label: 'exec';
		action: [ self exec ];
		state: true.
	listHeight :=  self singleHeight * 3 .
	super initializeWidgets ! !

!SvoDynamicListUI methodsFor: 'accessing' stamp: 'hk 12/14/2014 11:28'!
save
	model source: source text! !

!SvoDynamicListUI methodsFor: 'accessing' stamp: 'hk 12/14/2014 11:28'!
source
	^ source! !

!SvoListUI class methodsFor: 'instance creation' stamp: 'hk 2/2/2015 17:48'!
on: aSlot
	^self basicNew model: aSlot; initialize! !

!SvoListUI methodsFor: 'protocol' stamp: 'hk 2/9/2015 13:31'!
displayBlock: aBlock
	list displayBlock: aBlock! !

!SvoListUI methodsFor: 'private' stamp: 'hk 2/5/2015 19:12'!
displayItem: anItem
	"also adjust list spacings to list head spacings"
	| str |
	str := ''.
	(anItem displayArray do: [ :s | str := str, (s padRightTo: (self paddingFor: s)) ]) .
	^str
	
	! !

!SvoListUI methodsFor: 'accessing' stamp: 'hk 2/5/2015 13:01'!
editBlock: aBlock 
		editBlock := aBlock

! !

!SvoListUI methodsFor: 'accessing' stamp: 'hk 2/5/2015 13:02'!
editSvo
	editBlock 
		ifNil: [ self selectedItem edit ] 
		ifNotNil: [ editBlock value: self selectedItem ]

! !

!SvoListUI methodsFor: 'accessing' stamp: 'hk 2/3/2015 15:34'!
emptyLabel
	^ emptyLabel ! !

!SvoListUI methodsFor: 'ui-helpers' stamp: 'hk 2/3/2015 14:23'!
height
	^listHeight + self singleHeight 
	! !

!SvoListUI methodsFor: 'initialization' stamp: 'hk 2/10/2015 21:11'!
initializeLayout
	"(SvoListUI on: (SvoList new add: ((VO new: #root) addValue: #bla1 at: #bla2 forDisplay: true; yourself); key: #bla) ) openWithSpec "
	"(CommonSlotUI on: (SvoList new add: ((VO new: #root) addValue: #bla1 at: #bla2 forDisplay: true; yourself); key: #bla) type: SvoListUI) openWithSpec"

	self layout: (SpecLayout composed
		newColumn: [ :c | 
			c newRow: [ :r | 
				list listItems ifNotEmpty: [(list listItems first displayLabelArray: #id) do: 
					[ :l | r add: l width: 130 ] ].
					 r add: #emptyLabel ] height: self singleHeight .
			c  add: #list ] )! !

!SvoListUI methodsFor: 'initialization' stamp: 'hk 2/6/2015 14:49'!
initializeWidgets
	list := self newList  .
	list items: model list.  
	list displayBlock: [ :item | self displayItem: item  ] .
	list 	menu: [ :menu | menu 	target: self;
								add: 'edit'  action: #editSvo ].
	listHeight :=  self singleHeight  * ( (list listSize /2 max: 2) min: 4 ).  
	"need a trick for the column titles"
	list listItems ifNotEmpty: [ (list listItems first displayLabelArray: #id ) do: 
		[ :l | self assign: (LabelModel new text: l) to: l asSymbol ] ].
	emptyLabel := LabelModel new .	"fills up the space"
	self needRebuild: true . 
	self initializeLayout! !

!SvoListUI methodsFor: 'protocol' stamp: 'hk 2/9/2015 13:31'!
items: aCollection
	list items: aCollection! !

!SvoListUI methodsFor: 'accessing' stamp: 'hk 11/27/2014 18:53'!
list
	^ list! !

!SvoListUI methodsFor: 'accessing' stamp: 'hk 2/2/2015 17:49'!
model 
	^model ifNil: [ self error: 'no model' ]! !

!SvoListUI methodsFor: 'accessing' stamp: 'hk 2/2/2015 17:49'!
model: aSlot
	model := aSlot! !

!SvoListUI methodsFor: 'private' stamp: 'hk 2/5/2015 19:40'!
paddingFor: aString

	^30 - ((aString size /3 ) rounded)
	
	! !

!SvoListUI methodsFor: 'protocol' stamp: 'hk 2/9/2015 17:54'!
refreshItems
		list items: model list.  ! !

!SvoListUI methodsFor: 'protocol' stamp: 'hk 2/9/2015 13:32'!
resetSelection
	list resetSelection! !

!SvoListUI methodsFor: 'ui-helpers' stamp: 'hk 2/2/2015 21:49'!
save
	
! !

!SvoListUI methodsFor: 'protocol' stamp: 'hk 2/24/2015 12:44'!
selectedItem  
	^list selectedItem! !

!SvoListUI methodsFor: 'ui-helpers' stamp: 'hk 2/2/2015 17:54'!
singleHeight
	^self class toolbarHeight 
	! !

!SvoListUI methodsFor: 'protocol' stamp: 'hk 2/9/2015 15:43'!
whenChangedDo: aBlock ! !

!SvoListUI methodsFor: 'protocol' stamp: 'hk 2/9/2015 13:32'!
whenSelectedItemChanged: aBlock
	list whenSelectedItemChanged: aBlock! !

SvoListUI subclass: #SvoStaticListUI
	instanceVariableNames: 'accuFields template addAccuButton addNewButton addShowButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-SVO'!

!SvoStaticListUI commentStamp: 'hk 2/2/2015 19:14' prior: 0!
I am a UI for a static spo list slot

Instance Variables
	addAccuButton:	<ButtonModel >
	addShowButton:	<ButtonModel >
	addNewButton:		<ButtonModel>
	template:			<TextInputFieldModel >
	accuFields:			<Coll of Array:2>			widget labels
!

!SvoStaticListUI methodsFor: 'ui actions' stamp: 'hk 4/3/2015 17:07'!
addAccu
	| res1 |
	(res1 := DomainSVO chooseValueFrom: model templateValueSlotKeys mess: 'which field to accumulate?' ) ifNil: [ ^self ] .
	model addAccumulator: res1 asSymbol.
	accuFields value: nil

! !

!SvoStaticListUI methodsFor: 'accessing' stamp: 'hk 12/14/2014 15:11'!
addAccuButton
	^ addAccuButton! !

!SvoStaticListUI methodsFor: 'accessing' stamp: 'hk 12/14/2014 15:20'!
addNewButton
	^ addNewButton! !

!SvoStaticListUI methodsFor: 'accessing' stamp: 'hk 12/14/2014 15:59'!
addShowButton
	^ addShowButton! !

!SvoStaticListUI methodsFor: 'ui actions' stamp: 'hk 2/9/2015 13:33'!
addSvo
	model templateName: template text.
	model addExemplar.
	self items: model list 
! !

!SvoStaticListUI methodsFor: 'accessing' stamp: 'hk 1/19/2015 17:28'!
height
	^self singleHeight * (accuFields size * 0.7 +1) + super height 
	! !

!SvoStaticListUI methodsFor: 'initialization' stamp: 'hk 2/10/2015 21:24'!
initializeAccuFields	  
	accuFields := OrderedCollection new asReactiveVariable .
	model accumulatorsWithSums pairsDo: [ :m :s |   | mv | 
		mv := (m, 'Value' ) asSymbol.
		accuFields add: (Array with: m with: mv) .
		self assign: (LabelModel new label: 'sum of ', m) to: m; assign: (LabelModel new label: s printString) to: mv ]
! !

!SvoStaticListUI methodsFor: 'initialization' stamp: 'hk 2/4/2015 17:33'!
initializeLayout
	"(SvoStaticListUI on: SvoStaticList new) openWithSpec"
	"|t| (SvoStaticListUI on: ((t := VO new: #Bla ) addSvoStaticList: t at: #bla ) ) openWithSpec"

	self layout: (SpecLayout composed newColumn: [ :c | 
		c newRow:  [ :r |  r add: #template ; 
			add: #addShowButton width: 80;
			add: #addNewButton width: 80; 
			add: #addAccuButton width: 80] height: self singleHeight  .
		c add: #list .
		accuFields do: 
			[ :a | c newRow: [ :r | r add: (a at: 1); add: (a at: 2) ] 
			height: self singleHeight * 0.7] ]  )! !

!SvoStaticListUI methodsFor: 'initialization' stamp: 'hk 2/9/2015 16:08'!
initializeWidgets	
	template := (self newTextInput)
						autoAccept: true;
						ghostText: 'undefined'.    
	template text: model templateName.
	(addShowButton := self newButton)
		label: 'show' ;
		action: [ self showSvos ];
		state: true .
	(addNewButton := self newButton)
		label: 'new' ;
		action: [ self addSvo ];
		state: true .
	(addAccuButton := self newButton)
		label: 'add accu';
		action: [ self addAccu ];
		state: true.
	self initializeAccuFields .
	super initializeWidgets ! !

!SvoStaticListUI methodsFor: 'ui actions' stamp: 'hk 2/2/2015 21:50'!
save
	model templateName: template text.

! !

!SvoStaticListUI methodsFor: 'ui actions' stamp: 'hk 2/9/2015 13:33'!
showSvos
	model templateName: template text.
	self items: model list

! !

!SvoStaticListUI methodsFor: 'accessing' stamp: 'hk 1/17/2015 18:33'!
template
	^ template! !

!SvoStaticListUI methodsFor: 'protocol' stamp: 'hk 2/9/2015 16:11'!
whenAkkuChangedDo: aBlock  
	accuFields whenChangedDo: aBlock . ! !

DynamicComposableModel subclass: #SvoSpecUI
	instanceVariableNames: 'fullName version addValue addMethod model height isListEditor fields refresh addValueDsl insp elderName addSvo addSvoDynamicList addSvoInList addSvoStaticList addDropList menu'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-SVO'!

!SvoSpecUI commentStamp: 'hk 12/31/2014 17:35' prior: 0!
A SpoSpecUI is the generic UI for SPO

Instance Variables
	addMethod:		<Object>
	addSpo:		<Object>
	addSpoDynamicList:		<Object>
	addSpoInList:		<Object>
	addSpoList:		<Object>
	addSpoStaticList:		<Object>
	addSubSpo:		<Object>
	addValue:		<Object>
	addValueDsl:		<Object>
	addValueList:		<Object>
	editList:		<Object>
	editStraight:		<Object>
	entityElderName:		<Object>
	fields:		<Object>
	fullName:		<Object>
	height:		<Object>
	insp:		<Object>
	isListEditor:		<Object>
	model:		<Object>
	newType:		<Object>
	redo:		<Object>
	refresh:		<Object>
	reset:		<Object>
	save:		<Object>
	spoAnnouncer:		<Object>
	undo:		<Object>
	version:		<Object>

addMethod
	- xxxxx

addSpo
	- xxxxx

addSpoDynamicList
	- xxxxx

addSpoInList
	- xxxxx

addSpoList
	- xxxxx

addSpoStaticList
	- xxxxx

addSubSpo
	- xxxxx

addValue
	- xxxxx

addValueDsl
	- xxxxx

addValueList
	- xxxxx

editList
	- xxxxx

editStraight
	- xxxxx

entityElderName
	- xxxxx

fields
	- xxxxx

fullName
	- xxxxx

height
	- xxxxx

insp
	- xxxxx

isListEditor
	- xxxxx

model
	- xxxxx

newType
	- xxxxx

redo
	- xxxxx

refresh
	- xxxxx

reset
	- xxxxx

save
	- xxxxx

spoAnnouncer
	- xxxxx

undo
	- xxxxx

version
	- xxxxx
!

!SvoSpecUI class methodsFor: 'ui-helpers' stamp: 'hk 12/3/2014 12:58'!
alert: errorString
	"the system wide alert dialog"

	WidgetExamples new exampleBuilder alert: errorString! !

!SvoSpecUI class methodsFor: 'specs' stamp: 'hk 1/27/2015 13:05'!
asListOn: aSPO
	^ self basicNew
		model: aSPO;
		isListEditor: true;
		initialize;
		yourself! !

!SvoSpecUI class methodsFor: 'specs' stamp: 'hk 2/24/2015 15:16'!
on: aSVO
	^ self basicNew
		model: aSVO;
		isListEditor: false;
		initialize;
		setModelAnnouncer ;
		yourself! !

!SvoSpecUI class methodsFor: 'ui-helpers' stamp: 'hk 11/19/2014 12:43'!
request: aString
	"self request: 'test'  "
	^UIManager default request: aString initialAnswer: 'undefined'.
! !

!SvoSpecUI class methodsFor: 'ui-helpers' stamp: 'hk 2/2/2015 21:17'!
requestString: aString
	"self request: 'test'  "
	| res |
	res := (UIManager default request: aString initialAnswer: 'undefined' ).
	res ifNil: [ ^res ] .
	^res substrings first
! !

!SvoSpecUI class methodsFor: 'specs' stamp: 'hk 11/11/2014 16:22'!
title
	^ 'SPO Generic Editor'! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 1/19/2015 17:48'!
addDropList
	^ addDropList! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 2/9/2015 16:34'!
addDropListAction
	| res res2 |
	(res := self askForSlotName ) ifNil: [ ^self ] .
	res2 := self class request: 'enter blank separated list items'.
	model exec: (AddListOfStrings named: res list: res2 substrings ) .
	self reOpen ! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 11/9/2014 15:09'!
addMethod
	^ addMethod! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 2/9/2015 16:34'!
addMethodAction
	| res |
	(res := self askForSlotName ) ifNil: [ ^self ] .
	model exec: (AddAction named: res source: '' ) .
	self reOpen ! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 1/15/2015 14:12'!
addSvo
	^ addSvo! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 4/3/2015 17:07'!
addSvoAction
	| res1  coll  res2 |
	(res1 := self askForSlotName ) ifNil: [ ^self ] .
	coll := DomainSVO allSvoNames.
	(res2 := DomainSVO chooseValueFrom: coll mess:  'from which SPO?' ) ifNil: [ ^self ] .
	model exec: (AddSvoCopy named: res1 on: (DomainSVO at: res2) ) .
	self reOpen 
	! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 1/19/2015 17:50'!
addSvoDynamicList
	^ addSvoDynamicList ! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 2/9/2015 16:34'!
addSvoDynamicListAction
	| res1 |
	(res1 := self askForSlotName ) ifNil: [ ^self ] .
	model exec: (AddSpoDynamicList named: res1 ) .
	self reOpen 
	! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 1/19/2015 17:51'!
addSvoInList
	^ addSvoInList! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 1/19/2015 17:51'!
addSvoStaticList
	^ addSvoStaticList ! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 2/9/2015 16:34'!
addSvoStaticListAction
	| res1   |
	(res1 := self askForSlotName ) ifNil: [ ^self ] .
	model exec: (AddSpoStaticList named: res1 ) .
	self reOpen 
! !

!SvoSpecUI methodsFor: 'layout' stamp: 'hk 1/21/2015 15:02'!
addToListMenu    
	menu  addGroup: [ :group |
			group addItem: [ :item | item
				 	name: 'edit frame' ;
					description: 'switch to frame editor';
					action: [ self editAction ] ]  ] 
	! !

!SvoSpecUI methodsFor: 'layout' stamp: 'hk 1/21/2015 15:02'!
addToNonListMenu    
	menu  addGroup: [ :group |
			group addItem: [ :item | item
				 	name: 'new type' ;
					description: 'create an ASVO';
					action: [ self newTypeAction ] ].
			group addItem: [ :item | item
				 	name: 'edit list' ;
					description: 'switch to list editor';
					action: [ self editListAction ] ]  ]  

	! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 11/9/2014 15:09'!
addValue
	^ addValue! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 2/9/2015 16:33'!
addValueAction
	| res |
	(res := self askForSlotName ) ifNil: [ ^self ] .
	model exec: (AddValue named: res).
	self reOpen ! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 12/2/2014 19:14'!
addValueDsl
	^ addValueDsl! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 2/9/2015 16:33'!
addValueDslAction
	| res |
	(res := self askForSlotName ) ifNil: [ ^self ] .
	model exec: (AddDslValue named: res ) .
	self reOpen ! !

!SvoSpecUI methodsFor: 'private' stamp: 'hk 12/3/2014 12:59'!
alert: errorString
	"the system wide alert dialog"

	self class alert: errorString! !

!SvoSpecUI methodsFor: 'private' stamp: 'hk 2/2/2015 13:39'!
askForSlotName
	| res |
	res := self class requestString: 'new slot name ?'  .
	(model slots keys includes: res) 
		ifTrue: [ self alert: 'slot name exists' . ^nil] 
		ifFalse: [ ^res ]
! !

!SvoSpecUI methodsFor: 'private' stamp: 'hk 4/3/2015 17:07'!
askForSvoName
	| res |
	(res := self class requestString: 'new ASPO name?' ) ifNil: [ ^self ] .
	(DomainSVO svos includesKey: res)
		ifTrue: [ self alert: 'ASPO name already exists' . ^nil] 
		ifFalse: [ ^res ]! !

!SvoSpecUI methodsFor: 'layout' stamp: 'hk 11/15/2014 18:45'!
basicHeight
	^ self class toolbarHeight   ! !

!SvoSpecUI methodsFor: 'layout' stamp: 'hk 1/19/2015 17:51'!
buttonLayout: column
	column
		newRow: [ :r |  r
				add: #addValue;
				add: #addValueDsl;
				add: #addDropList ;
				add: #addSvo;
				add: #addSvoStaticList;
				add: #addSvoDynamicList;
				add: #addMethod ]
		height: self class toolbarHeight! !

!SvoSpecUI methodsFor: 'private' stamp: 'hk 2/9/2015 17:43'!
close
	[self window close] ifError: [  self inform: 'window already closed' ]! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 1/26/2015 22:17'!
copyAsvoAction
	model exec: (CopyAsvo on: model)  .
	self reOpen! !

!SvoSpecUI methodsFor: 'initialization' stamp: 'hk 1/8/2015 15:13'!
defineHeader
	fullName label: model qualifiedName .
	version label: 'version: ', model version .
	elderName label:  'elder: ', model elderName.
	insp label: 'inspect ', model pName ;
		action: [ model inspect ];
		state: true.  ! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 1/21/2015 12:41'!
editAction
	isListEditor := false. 
	self reOpen! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 1/21/2015 12:42'!
editListAction
	isListEditor := true. 
	self reOpen! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 12/31/2014 18:45'!
elderName
	^ elderName! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 11/9/2014 15:09'!
fullName
	^ fullName! !

!SvoSpecUI methodsFor: 'layout' stamp: 'hk 12/31/2014 18:43'!
headerLayout: column
	column
		newRow: [ :r |  r
				add: #fullName;
				add: #elderName ]
			height: self class toolbarHeight;
		newRow: [ :r |  r
				add: #version;
				add: #insp ]
			height: self class toolbarHeight
		! !

!SvoSpecUI methodsFor: 'layout' stamp: 'hk 11/15/2014 18:44'!
height
	^ self class toolbarHeight   ! !

!SvoSpecUI methodsFor: 'layout' stamp: 'hk 12/14/2014 13:09'!
initialExtent
	^ 750 @ height ! !

!SvoSpecUI methodsFor: 'initialization' stamp: 'hk 1/26/2015 22:37'!
initializeActionButtons 
	(addValue := self newButton) label: 'add value' ;
		action: [self addValueAction];
		state: true.
	(addValueDsl := self newButton) label: 'add value(DSL)' ;
		action: [self addValueDslAction];
		state: true.
	(addDropList := self newButton) label: 'add drop list' ;
		action: [self addDropListAction];
		state: true.
	(addSvo := self newButton) label: 'add SVO' ;
		action: [self addSvoAction ];
		state: true.
	(addSvoInList := self newButton) label: 'add ASVO copy' ;
		action: [self copyAsvoAction ];
		state: true.
	(addSvoStaticList := self newButton ) label: 'add SVO list' ;
		action: [self addSvoStaticListAction ];
		state: true.
	(addSvoDynamicList := self newButton) label: 'add SVO list(DSL)' ;
		action: [self addSvoDynamicListAction ];
		state: true.
	(addMethod := self newButton ) label: 'add action' ;
		action: [self addMethodAction ];
		state: true! !

!SvoSpecUI methodsFor: 'initialization' stamp: 'hk 12/31/2014 18:45'!
initializeHeader
	fullName := self newLabel.
	version := self newLabel.
	elderName := self newLabel.
	insp := self newButton .
	self defineHeader
! !

!SvoSpecUI methodsFor: 'layout' stamp: 'hk 1/26/2015 22:10'!
initializeLayout
	self initializeMenu .
	height := 6 * self basicHeight.
		isListEditor 
		ifTrue: [self initializeListLayout   ]  
		ifFalse:  [self initializeNonListLayout ].
	self needFullRebuild: false.! !

!SvoSpecUI methodsFor: 'layout' stamp: 'hk 1/26/2015 19:46'!
initializeListLayout

	| models  |		"dynamic widgets"
	models := model exemplarsAsCollOfPairs.
	fields := OrderedCollection new.
	models pairsDo: [ :k :v | fields add: k  . self assign: v to: k ].
	self addToListMenu .
	"layout"
	self layout: (SpecLayout composed
		newColumn: [ :column | 
			column 	add: #menu height: self height.
			self headerLayout: column.
			column newRow: [:r | r add: #addSvoInList] height: self basicHeight. 				
			fields do: [ :f |  | h |
						h := (self widgets at: f)  height.
						height := height + h.
						column add: f height: h ] .
			column addSplitter ])! !

!SvoSpecUI methodsFor: 'layout' stamp: 'hk 1/25/2015 15:45'!
initializeMenu 	
	menu := MenuModel new 
		addGroup: [ :g |
			g addItem: [ :i |  i
				name: 'SVO';
				icon: Smalltalk ui icons openIcon;
				subMenu: self svoMenu ] .
			g addItem: [  :i | i
				name: 'refresh' ;
				description: 'get data from model' ;
				action: [ self refreshAction ] ] .
			g addItem: [  :i | i
				name: 'reset' ;
				description: 'undo gui changes' ;
				action: [ self resetAction ] ] .
			g addItem: [  :i | i
				description: 'save to file' ;
				icon: Smalltalk ui icons smallSaveIcon;
				action: [ self saveAction ] ]    ] ;
		addGroup: [ :group |
			group addItem: [ :item | item
					description: 'undo';
					icon: Smalltalk ui icons smallUndoIcon;
					action: [ self undoAction ] ].
			group addItem: [ :item | item
					description: 'redo';
					icon: Smalltalk ui icons smallRedoIcon;
					action: [ self redoAction ] ] ]
! !

!SvoSpecUI methodsFor: 'layout' stamp: 'hk 2/9/2015 16:11'!
initializeNonListLayout

	| models  |		"dynamic widgets"
	models := model slotsAsCollOfPairs.
	fields := OrderedCollection new.
	models pairsDo: [ :k :v | fields add: k . self assign: v to: k ].
	self addToNonListMenu .
	"layout"
	self layout: (SpecLayout composed
		newColumn: [ :column | 
			column 	add: #menu height: self height.
			self headerLayout: column.
			self buttonLayout: column.
			fields do: [ :f |  | h  w |
				h := (w := self widgets at: f)  height.
				height := height + h.
				column add: f height: h .
				w whenAkkuChangedDo: [ self reOpen ] ] .
			column addSplitter ])! !

!SvoSpecUI methodsFor: 'initialization' stamp: 'hk 2/9/2015 17:39'!
initializePresenter
	self announcer on: CloseFrame do: [ :a | self close] .
	self announcer on: SlotsChanged do: [ :a | self reOpen ] .
	self announcer on: ReOpenFrame do: [ :a | self reOpen ] ! !

!SvoSpecUI methodsFor: 'initialization' stamp: 'hk 1/25/2015 20:06'!
initializeWidgets
	self initializeHeader .
	self initializeActionButtons .
	self initializeLayout ! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 12/14/2014 13:45'!
insp
	^ insp! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 11/13/2014 18:51'!
isListEditor
	^ isListEditor! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 1/19/2015 14:01'!
isListEditor: aBoolean
	isListEditor := aBoolean! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 1/21/2015 15:03'!
menu    
	^ menu
	! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 11/10/2014 12:00'!
model
	^ model! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 2/9/2015 17:09'!
model: aSVO
 	model := aSVO ! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 1/19/2015 17:52'!
newTypeAction
	| res |
	(res := self askForSvoName  ) ifNil: [ ^self ] .
	(model clone: res ) edit! !

!SvoSpecUI methodsFor: 'private' stamp: 'hk 1/21/2015 13:06'!
reOpen
	self initializeLayout; openWithSpec
! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 11/18/2014 12:16'!
redoAction
	model redo ! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 11/20/2014 12:09'!
refreshAction
	self reOpen! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 3/28/2015 14:25'!
refreshingBlock: aBlock    

	! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 11/24/2014 20:54'!
resetAction
	model rollBack! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 11/20/2014 14:40'!
saveAction
	fields do: [ :f | (widgets at: f) save ].
	model save.
	self reOpen.! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 2/9/2015 17:09'!
setModelAnnouncer
 	model announcer: self announcer! !

!SvoSpecUI methodsFor: 'layout' stamp: 'hk 1/21/2015 14:12'!
svoMenu
	^ MenuModel new addGroup: [ :group |
			group addItem: [ :item | item
					name: 'refresh';
					shortcut: $f command;
					action: [ self refreshAction ] ].
			group addItem: [ :item | item 
					name: 'reset';
					shortcut: $r command;
					action: [ self resetAction ] ].
			group addItem: [ :item | item 
					name: 'save';
					icon: Smalltalk ui icons smallSaveIcon;
					shortcut: $s command;
					action: [ self saveAction ] ] ]! !

!SvoSpecUI methodsFor: 'ui-actions' stamp: 'hk 11/18/2014 12:16'!
undoAction
	model undo ! !

!SvoSpecUI methodsFor: 'accessing' stamp: 'hk 11/9/2014 15:09'!
version
	^ version! !

!SvoSpecUI methodsFor: 'as yet unclassified' stamp: 'hk 3/31/2015 21:23'!
whenChangedDo: aBlock
 	"dummy"! !

DynamicComposableModel subclass: #SvoUI
	instanceVariableNames: 'editButton model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-SVO'!

!SvoUI commentStamp: 'hk 2/2/2015 21:48' prior: 0!
I am used in the VO list editor. I exhibit an edit button for the VO.

Instance Variables
	editButton:		<ButtonModel >
	model:!

SvoUI subclass: #SvoEmbeddedUI
	instanceVariableNames: 'slotKeysAndValues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-SVO'!

!SvoEmbeddedUI commentStamp: 'hk 1/6/2015 12:50' prior: 0!
I am used in the VO editor to display the values of an embedded VO

Instance Variables
	slotKeysAndValues:		<Coll of Pairs>

!

!SvoEmbeddedUI methodsFor: 'ui-helpers' stamp: 'hk 2/2/2015 18:48'!
height 
	^(slotKeysAndValues size * 0.9 max: 1) * self singleHeight ! !

!SvoEmbeddedUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 21:12'!
initializeLayout
	"(SvoEmbeddedUI on: (SvoSlot new svo: ((VO new: #root) addValue: #bla1 at: #bla2 forDisplay: true; yourself) ; key: #bla)) openWithSpec"
	"(CommonSlotUI on: (SvoSlot new svo: ((VO new: #root) addValue: #bla1 at: #bla2 forDisplay: true; yourself); key: #bla) type: SvoEmbeddedUI) openWithSpec"

	self layout: (SpecLayout composed
		newRow: [ :row | row	
			add: #k0 ;
			newColumn: [ :c | slotKeysAndValues do: 
				[ :kv |  c newRow:  [ :r | 
					r add: (kv at: 1) ; 
					  add: (kv at: 2)  ] height: self singleHeight * 0.8] ]  ;
			add: #editButton width: self class buttonWidth ] )
! !

!SvoEmbeddedUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 17:39'!
initializeWidgets
	"(SvoEmbeddedUI on: (SvoSlot new spo: (VO new: #root) ; key: #bla)) openWithSpec"
	
	| k |
	k := 1 .
	slotKeysAndValues := OrderedCollection new.
	self assign: (LabelModel new label: model pName ) to: #k0.
	model svoDisplayValues do: [ :e |  | k1 k2  v1 v2 |
					v1 := e key asSymbol.
					v2 := e displayString asSymbol.
					k1 := ('Key', (k := k +1) asString) asSymbol.
					k2 := ('Key', (k := k +1) asString) asSymbol.
					slotKeysAndValues add: (Array with: k1 with: k2) .
					self assign: (LabelModel new label: v1) to: k1.
					self assign: (LabelModel new label: v2) to: k2].
	(editButton := self newButton) 
		label: 'edit' ;
		action:  [self editAction] ;
		state: true .
	self initializeLayout 



! !

!SvoEmbeddedUI methodsFor: 'accessing' stamp: 'hk 2/2/2015 18:58'!
singleHeight 
 	^self class toolbarHeight ! !

!SvoUI class methodsFor: 'instance creation' stamp: 'hk 2/2/2015 17:32'!
on: aSlot
	^self basicNew model: aSlot; initialize! !

!SvoUI methodsFor: 'ui-actions' stamp: 'hk 1/21/2015 15:33'!
editAction
	model svo edit! !

!SvoUI methodsFor: 'accessing' stamp: 'hk 11/16/2014 20:39'!
editButton
	^editButton 
	
! !

!SvoUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 21:12'!
initializeLayout
	"(SvoUI on: (SvoSlot new svo: (VO new: #root); key: #bla) ) openWithSpec"
	"(CommonSlotUI on: (SvoSlot new svo: (VO new: #root); key: #bla) type: SvoUI) openWithSpec"

	self layout: (SpecLayout composed
		newRow: [ :row | row  add: #editButton ] )! !

!SvoUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 17:43'!
initializeWidgets
	editButton := self newButton .
	editButton 
		label: model  displayString ;
		action:  [self editAction] ;
		state: true .
	self initializeLayout! !

!SvoUI methodsFor: 'accessing' stamp: 'hk 2/2/2015 17:37'!
model 
	^model ifNil: [ self error: 'no model' ]! !

!SvoUI methodsFor: 'accessing' stamp: 'hk 2/2/2015 17:37'!
model: aSlot
	model := aSlot! !

!SvoUI methodsFor: 'ui-helpers' stamp: 'hk 2/2/2015 21:44'!
save! !

!SvoUI methodsFor: 'as yet unclassified' stamp: 'hk 2/9/2015 15:42'!
whenChangedDo: aBlock ! !

DynamicComposableModel subclass: #TableListUI
	instanceVariableNames: 'list emptyLabel header'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-App'!

!TableListUI commentStamp: 'hk 2/18/2015 20:03' prior: 0!
A TableListUI is a list widget with row titles 
(may be replaced by a more sophisticated widget).

Hence the list items must respond to: 			This dependence can be weakened
-  displayArray and 								by introducing two inst vars:
-  displayLabelArray 							- one for the displayBlock of the list 
and it must carry an automatic id !!!!!!				- one for the header text (asReactiveVar))

Instance Variables
	emptyLabel:		<LabelModel> 	needed for fill in the blanks
	list:					<ListModel>	
	header: 			<LabelModel>

filteringBlock is not applied yet!

!TableListUI methodsFor: 'display' stamp: 'hk 2/16/2015 11:11'!
displayItem: anArray
	"construct the displayString by adjusting list spacings to list head spacings in points"
	| str |
	str := ''.
	(anArray do: [ :s | str := str, (s padRightTo: (self paddingFor: s)) ]) .
	^str
	
	! !

!TableListUI methodsFor: 'accessing' stamp: 'hk 2/14/2015 18:08'!
emptyLabel
	^ emptyLabel! !

!TableListUI methodsFor: 'accessing' stamp: 'hk 2/15/2015 17:00'!
header
	^ header ! !

!TableListUI methodsFor: 'accessing' stamp: 'hk 3/23/2015 12:21'!
height
	^(self list listSize max: 3)* self class toolbarHeight! !

!TableListUI methodsFor: 'initialization' stamp: 'hk 3/23/2015 11:55'!
initializeLayout
	"(TableListUI new items: SvoTests makeKontakte copies asOrderedCollection ) openWithSpec"
	self layout: (SpecLayout composed
		newColumn: [ :c | 
			c add: #header height: self class toolbarHeight .  
			c  add: #list  ] )! !

!TableListUI methodsFor: 'initialization' stamp: 'hk 2/16/2015 11:19'!
initializePresenter
	list whenListChanged: [ header label: (list listItems isEmpty
			ifTrue: ['']
			ifFalse: [self displayItem: (list listItems first displayLabelArray: #'id') ] ) ]! !

!TableListUI methodsFor: 'initialization' stamp: 'hk 2/16/2015 11:16'!
initializeWidgets
	emptyLabel := self newLabel  .
	list := self newList  .
	header := self newLabel .
	list displayBlock: [ :item | self displayItem: item displayArray  ] .
	self needFullRebuild: false . 
	self initializeLayout! !

!TableListUI methodsFor: 'protocol' stamp: 'hk 2/14/2015 17:15'!
items: aCollection
	list items: aCollection! !

!TableListUI methodsFor: 'accessing' stamp: 'hk 2/14/2015 18:08'!
list
	^ list! !

!TableListUI methodsFor: 'protocol' stamp: 'hk 2/21/2015 14:38'!
listItems
	^list listItems! !

!TableListUI methodsFor: 'protocol' stamp: 'hk 2/14/2015 18:02'!
menu:  aBlock
	" [ :menu :shifted | nil ] "
	list menu: aBlock  ! !

!TableListUI methodsFor: 'private' stamp: 'hk 2/16/2015 11:15'!
paddingFor: aString
	"shall mimick equal distance"
	^30 - ((aString size /3 ) rounded)
	
	! !

!TableListUI methodsFor: 'protocol' stamp: 'hk 3/27/2015 16:46'!
resetSelection
	list resetSelection! !

!TableListUI methodsFor: 'protocol' stamp: 'hk 2/21/2015 14:42'!
setSelectedItem: anItem
	list setSelectedItem: anItem! !

!TableListUI methodsFor: 'accessing' stamp: 'hk 3/23/2015 12:09'!
size
	^self list listSize ! !

!TableListUI methodsFor: 'protocol' stamp: 'hk 2/15/2015 17:09'!
title

	^ 'TableList'! !

!TableListUI methodsFor: 'protocol-events' stamp: 'hk 2/14/2015 17:18'!
whenSelectedItemChanged: aBlock
	list whenSelectedItemChanged: aBlock! !

DynamicComposableModel subclass: #ValueUI
	instanceVariableNames: 'slotValue model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-UI-SVO'!

!ValueUI commentStamp: 'hk 2/2/2015 17:23' prior: 0!
I am the UI component for a slot value , i.e. string

Instance Variables
	slotValue:		<TextInputFieldModel >
	model: 			<ValueSlot>!

!ValueUI class methodsFor: 'instance creation' stamp: 'hk 2/2/2015 15:36'!
on: aSlot
	^self basicNew model: aSlot; initialize! !

!ValueUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 21:12'!
initializeLayout
	"(CommonSlotUI on: ValueSlot new type: ValueUI) openWithSpec"
	"(ValueUI on: ValueSlot new) openWithSpec"

	self layout: (SpecLayout composed
		newRow: [ :row | row add: #slotValue ] )! !

!ValueUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 17:30'!
initializeWidgets
	(slotValue := self newTextInput
						autoAccept: true;
						ghostText: 'undefined')
				  text: model value.
	self initializeLayout ! !

!ValueUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 15:30'!
model 
	^model ifNil: [ self error: 'no model' ]! !

!ValueUI methodsFor: 'initialization' stamp: 'hk 2/2/2015 15:37'!
model: aSlot
	model := aSlot! !

!ValueUI methodsFor: 'ui-actions' stamp: 'hk 2/2/2015 15:37'!
save
	model value: slotValue text! !

!ValueUI methodsFor: 'accessing' stamp: 'hk 11/16/2014 19:48'!
slotValue
	^ slotValue! !

!ValueUI methodsFor: 'as yet unclassified' stamp: 'hk 2/9/2015 15:42'!
whenChangedDo: aBlock ! !

Announcement subclass: #CloseFrame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Announcements'!

!CloseFrame commentStamp: 'hk 12/3/2014 15:59' prior: 0!
A CloseFrame is an Announcement to close the UI 
!

Announcement subclass: #ReOpenFrame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Announcements'!

!ReOpenFrame commentStamp: 'hk 11/18/2014 15:04' prior: 0!
A ReOpenFrame is an Announcement to reOpen the UI !

Announcement subclass: #SlotsChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Announcements'!

!SlotsChanged commentStamp: 'hk 11/18/2014 12:02' prior: 0!
A SposChanged is an Announcement for thr UI to refresh
!

TestCase subclass: #SvoTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Tests'!

SvoTests class
	instanceVariableNames: 'firma vorgang angebot auftrag kalkulation transport tour rechnung kunde adresse position 
	 gcMainContext address personIdentity person date gcBizProcessContext process gcProcessesContext ct bizProcessCustView'!

!SvoTests commentStamp: 'hk 12/3/2014 15:24' prior: 0!
The SpoTests class

for manual experience evaluate <SpoTests new openSample >.

You can play around manually. DSL comes into play with 
- DSL add value
- DSL add SPO
- add action 

Try the following DSL fragments in the (undefined) source fields:
- strasse @ Adresse (Frankfurt)
- Kontakt (Krasemann)
- email an Kontakt(Fritz)
!

SvoTests class
	instanceVariableNames: 'firma vorgang angebot auftrag kalkulation transport tour rechnung kunde adresse position 
	 gcMainContext address personIdentity person date gcBizProcessContext process gcProcessesContext ct bizProcessCustView'!

SvoTests subclass: #SvoTestSuiteCommands
	instanceVariableNames: 'adr kontakt'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Tests'!

!SvoTestSuiteCommands commentStamp: 'hk 12/1/2014 17:41' prior: 0!
A SpoTestSuiteCommands is xxxxxxxxx.

Instance Variables
	adr:		<SPO>
	kontakt:	<SPO>



!

!SvoTestSuiteCommands methodsFor: 'running' stamp: 'hk 12/4/2014 16:48'!
setUp
	super setUp.
	adr := self class makeAdresse.
	kontakt := self class makeKontakte 
! !

!SvoTestSuiteCommands methodsFor: 'running' stamp: 'hk 12/10/2014 17:51'!
testAddMethod
	kontakt exec: ( AddAction named: 'bla' source: '' ).	
	self should: [ kontakt dslSlots size = 1 ].
	self should: [ kontakt slots size = 4 ].
! !

!SvoTestSuiteCommands methodsFor: 'running' stamp: 'hk 4/3/2015 17:07'!
testAddSvo
	|  child cmd |
	kontakt exec: (cmd := AddSvoCopy named: adr pName on: adr ).	
	child := (kontakt svoSlots detect: [ :a | (adr pName, '*' ) match:  a svo pName ]) svo.
	
	self should: [ (adr pName, '_1' ) = child pName ].
	self should: [ adr copiesColl includes: child  ].
	self should: [ (DomainSVO at: child pName) elder = kontakt ].
	self should: [ ((DomainSVO at: child pName) elderVersion ) = kontakt version].
	self should: [ kontakt slots size = 4 ].
	self should: [ (DomainSVO at: child pName) template = adr ].
	self should: [ ((DomainSVO at: child pName) templateVersion ) = adr version].
	^child
! !

!SvoTestSuiteCommands methodsFor: 'helpers' stamp: 'hk 1/21/2015 15:38'!
testAddSvoList
	kontakt exec: ( AddSpoDynamicList named: #freunde source: '').	
	self should: [kontakt svoDynamicListSlots size = 1] .
! !

!SvoTestSuiteCommands methodsFor: 'running' stamp: 'hk 12/10/2014 17:52'!
testAddValue
	kontakt exec: ( AddValue named: 'bla' value: '' ).	
	self should: [ kontakt valueSlots size = 4 ].
	self should: [ kontakt slots size = 4 ].
! !

!SvoTestSuiteCommands methodsFor: 'running' stamp: 'hk 1/26/2015 22:17'!
testCreateSvo
	|  child cmd |
	kontakt exec: (cmd := CopyAsvo on: adr).	
	child := (adr copiesColl detect: [ :a | (adr pName, '*' ) match:  a pName ]) value.
	
	self should: [ (adr pName, '_1' ) = child pName ].
	self should: [ child template  = adr ].
	self should: [ child templateVersion  = adr version].
	self should: [ adr copies size = 1 ]
! !

!SvoTestSuiteCommands methodsFor: 'running' stamp: 'hk 12/10/2014 17:49'!
testMoveUpDown
	self should: [ (kontakt slotSequence at: 2) = #vorname  ].
	kontakt exec: ( MoveUp named: #vorname ).	"first MoveUp"
	self should: [ (kontakt slotSequence at: 1) = #vorname  ].
	kontakt exec: ( MoveUp named: #vorname).	"second MoveUp"
	self should: [ (kontakt slotSequence at: 1) = #vorname  ].
	kontakt exec: ( MoveDown named: #vorname ).	
	kontakt exec: ( MoveDown named: #vorname ).	"2 * MoveDown"
	self should: [ (kontakt slotSequence at: 3) = #vorname  ].
	kontakt exec: ( MoveDown named: #vorname ).	" MoveDown"
	self should: [ (kontakt slotSequence at: 3) = #vorname  ].
! !

!SvoTestSuiteCommands methodsFor: 'running' stamp: 'hk 12/10/2014 17:50'!
testMoveUpUndo
	self should: [ (kontakt slotSequence at: 2) = #vorname  ].
	kontakt exec: ( MoveUp named: #vorname ).	"first MoveUp"
	self should: [ (kontakt slotSequence at: 1) = #vorname  ].
	kontakt undo.
	self should: [ (kontakt slotSequence at: 2) = #vorname  ].
! !

!SvoTestSuiteCommands methodsFor: 'running' stamp: 'hk 4/3/2015 17:07'!
testRedo
	|  child  |
	child := self testAddSvo.
	kontakt undo.
	kontakt redo.
	self should: [ kontakt slots size = 4 ].	
	self should: [ (adr pName, '_1' ) = child pName ].
	self should: [ adr copiesColl includes: child  ].
	self should: [ (DomainSVO at: child pName) elderName  = kontakt pName].
	self should: [ (DomainSVO at: child pName) elderVersion   = kontakt version].
! !

!SvoTestSuiteCommands methodsFor: 'running' stamp: 'hk 12/10/2014 17:50'!
testRemoveSlot
	kontakt exec: ( RemoveSlot named: 'vorname' ).	
	self should: [ kontakt valueSlots size = 2 ].
	kontakt undo.
	self should: [ kontakt valueSlots size = 3 ].
	self should: [ (kontakt slots at: #vorname) value = 'Hartmut' ].

! !

!SvoTestSuiteCommands methodsFor: 'running' stamp: 'hk 1/26/2015 22:28'!
testUndo
	kontakt exec: (AddSvoCopy named: adr pName on: adr ).	
	self should: [ kontakt slots size = 4 ].
	kontakt undo.
	self should: [ kontakt slots size = 3 ].
	kontakt undo.							"undo stack isEmpty"
	self should: [ kontakt slots size = 3 ].
! !

SvoTests subclass: #SvoTestSuiteCompiler
	instanceVariableNames: 'adr kontakt email'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Tests'!

!SvoTestSuiteCompiler commentStamp: 'hk 12/1/2014 17:40' prior: 0!
A SpoTestSuiteCompiler is 

Instance Variables
	adr:		<SPO>
	kontakt:	<SPO>
	email:		<SPO>


!

!SvoTestSuiteCompiler methodsFor: 'running' stamp: 'hk 12/4/2014 16:49'!
setUp
	super setUp.
	adr := self class makeAdresse.
	kontakt := self class makeKontakte .
	email := self class makeEmail
! !

!SvoTestSuiteCompiler methodsFor: 'running' stamp: 'hk 4/3/2015 17:07'!
testDslMethod
	kontakt exec: ( AddAction named: 'bla' source: 'email an Kontakt(Fritz)' ).	
	(kontakt slots at: #bla) exec .  
	(DomainSVO at: #Email_1) closeWindow .
	self should: [ DomainSVO svos includesKey:  #Email_1 ]  
! !

!SvoTestSuiteCompiler methodsFor: 'helpers' stamp: 'hk 4/3/2015 17:07'!
testDslPathSearch1

	| adr1 |
	kontakt exec: (AddSvoCopy named: adr pName on: adr ).	
	self should: [(adr1 := DomainSVO at: #Adresse_1) valueSlots size  = 3 ].
	adr1 exec: ( AddDslValue named: #item source: 'vorname @ parent' ).	
	(adr1 valueSlots at: #item) exec.
	self should: [adr1 valueSlots size  = 4].
	self should: [(adr1 valueSlots at: #item ifAbsent: [ '' ]) value = 'Hartmut' ].
	
! !

!SvoTestSuiteCompiler methodsFor: 'helpers' stamp: 'hk 4/3/2015 17:07'!
testDslPathSearch2

	| adr1 |
	kontakt exec: (AddSvoCopy named: #adr on: adr ).	
	self should: [(adr1 := DomainSVO at: #Adresse_1) valueSlots size  = 3 ].
	adr1 exec: ( AddDslValue named: #item source: 'strasse @ adr @ parent' ).	
	(adr1 valueSlots at: #item) exec.
	self should: [adr1 valueSlots size  = 4].
	self should: [(adr1 valueSlots at: #item ifAbsent: [ '' ]) value = 'Rheinstr. 7' ].
	
! !

!SvoTestSuiteCompiler methodsFor: 'helpers' stamp: 'hk 4/3/2015 17:07'!
testDslPathSearch3

	| adr1 |
	kontakt exec: (AddSvoCopy named: #adr on: adr ).	
	self should: [(adr1 := DomainSVO at: #Adresse_1) valueSlots size  = 3 ].
	kontakt exec: ( AddDslValue named: #item source: 'strasse @ adr' ).	
	(kontakt valueSlots at: #item) exec.
	self should: [kontakt valueSlots size  = 4].
	self should: [(kontakt valueSlots at: #item ifAbsent: [ '' ]) value = 'Rheinstr. 7' ].
	
! !

!SvoTestSuiteCompiler methodsFor: 'helpers' stamp: 'hk 4/3/2015 17:07'!
testDslPathSearch4
	"like testDslPathSearch2 on a copy"
	| adr1 adr2 k2 |
	kontakt exec: (AddSvoCopy named: #adr on: adr ).	
	self should: [(adr1 := DomainSVO at: #Adresse_1) valueSlots size  = 3 ].
	adr1 exec: ( AddDslValue named: #item source: 'strasse @ adr @ parent' ).	
	k2 := kontakt copy.
	adr2 := (k2 slots at: #adr) svo.
	(adr2 valueSlots at: #item) exec.
	self should: [(adr2 valueSlots at: #item ifAbsent: [ '' ]) value = 'Rheinstr. 7' ].
	
! !

!SvoTestSuiteCompiler methodsFor: 'helpers' stamp: 'hk 4/3/2015 17:07'!
testDslSlotSearch
	self should: [kontakt valueSlots size = 3 ].
	(DomainSVO at: #Adresse) copy.   "the DSL only searches exemplars"
	kontakt exec: ( AddDslValue named: #item source: 'strasse @ Adresse (Frankfurt)' ).	
	(kontakt valueSlots at: #item) exec.
	self should: [kontakt valueSlots size = 4 ].
	self should: [(kontakt valueSlots at: #item) value = 'Rheinstr. 7' ].
	
	(kontakt valueSlots at: #item) source: 'strasse @ Adresse (F)'.
	(kontakt valueSlots at: #item) exec.
	self should: [(kontakt valueSlots at: #item) value = 'error: #(''F'') not found' ].
	
	(kontakt valueSlots at: #item) source: 'strasse @ A (F)'.
	(kontakt valueSlots at: #item) exec.
	self should: [(kontakt valueSlots at: #item) value = 'error: A not found' ].
	
	(kontakt valueSlots at: #item) source: 'strass @ Adresse (Frankfurt)'.
	(kontakt valueSlots at: #item) exec.
	self should: [(kontakt valueSlots at: #item) value = 'error: strass' ].

! !

!SvoTestSuiteCompiler methodsFor: 'helpers' stamp: 'hk 4/3/2015 17:07'!
testDslSlotSearch2
	self should: [kontakt valueSlots size = 3 ].
	(DomainSVO at: #Adresse) copy.   "the DSL only searches exemplars"
	kontakt exec: ( AddDslValue named: #item source: 'strasse @ Adresse (Frankfurt D22869)' ).	
	(kontakt valueSlots at: #item) exec.
	self should: [kontakt valueSlots size = 4 ].
	self should: [(kontakt valueSlots at: #item) value = 'Rheinstr. 7' ].
	
	! !

!SvoTestSuiteCompiler methodsFor: 'helpers' stamp: 'hk 1/21/2015 15:38'!
testDslSvoList
	kontakt exec: ( AddSpoDynamicList named: #freunde source: 'Kontakt (Krasemann)' ).	
	(kontakt svoDynamicListSlots at: #freunde) exec.
	self should: [(kontakt svoDynamicListSlots at: #freunde) list size = 4 ].
	(kontakt svoDynamicListSlots at: #freunde) source: 'Kontakt ( Karl)'.
	(kontakt svoDynamicListSlots at: #freunde) exec.
	self should: [(kontakt svoDynamicListSlots at: #freunde) list size = 1 ].
	(kontakt svoDynamicListSlots at: #freunde) source: 'Kontakt ( XX )'.
	(kontakt svoDynamicListSlots at: #freunde) exec.
	self should: [(kontakt svoDynamicListSlots at: #freunde) list isEmpty ].

! !

SvoTests subclass: #SvoTestSuiteCopyClone
	instanceVariableNames: 'adr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Tests'!

!SvoTestSuiteCopyClone commentStamp: 'hk 11/19/2014 16:47' prior: 0!
A SpoTestSuiteCopyClone is xxxxxxxxx.

Instance Variables
	adr:		<SPO>

!

!SvoTestSuiteCopyClone methodsFor: 'helpers' stamp: 'hk 12/4/2014 16:49'!
setUp
	super setUp.
	adr := self class makeAdresse
! !

!SvoTestSuiteCopyClone methodsFor: 'running' stamp: 'hk 1/21/2015 15:36'!
testAsvoCloning
	"chain  testRoot - testValues - testASPOcloning"
	| adr2 |
	adr2 := adr clone: 'MyAdresse' .

	self should: [ #MyAdresse =  adr2 pName ].	
	self should: [  adr2 version  = '1' ].	
	self should: [ (adr slots at:  'city' ) value = (adr2 slots at:  'city' ) value].
	self should: [ (adr slots at:  #strasse) value = (adr2 slots at:  #strasse) value ].
	self should: [ (adr slots at:  #PLZ) value = (adr2 slots at:  #PLZ) value ].

! !

!SvoTestSuiteCopyClone methodsFor: 'running' stamp: 'hk 1/21/2015 15:37'!
testAsvoCloningWrongName
	self should: [ adr clone: 'Adresse' ] raise: Error
! !

!SvoTestSuiteCopyClone methodsFor: 'helpers' stamp: 'hk 1/8/2015 15:07'!
testStoreVersion
	|  oldV |
	oldV := adr version.
	adr save  .
	self should: [ oldV asInteger + 1 = adr version asInteger]
! !

!SvoTestSuiteCopyClone methodsFor: 'running' stamp: 'hk 4/3/2015 17:07'!
testSvoCopy1
	|   kontakt k2 k4  |
	kontakt := self class makeKontakte .
	k2 := DomainSVO at: 'Kontakt_2'.
	k4 := DomainSVO at: 'Kontakt_4'.

	self should: [kontakt copies size = 4 ].
	self should: [( kontakt slots at: 'vorname') value = 'Hartmut' ].
	self should: [( k2 slots at: 'vorname') value = 'Karl' ].
	self should: [( k4 slots at: 'vorname') value = 'Fritz' ].
! !

!SvoTestSuiteCopyClone methodsFor: 'running' stamp: 'hk 1/21/2015 15:37'!
testSvoCopy2
	|   kontakt    k2 adr2 |
	kontakt := self class makeKontakt .
	adr2 := (kontakt addSvo: adr at: #adr) svo .
	self should: [kontakt slots size = 4].
	self should: [( kontakt slots at: #adr) pName = adr pName].
	self should: [( kontakt slots at: #adr) frame pName = kontakt pName].	
	k2 := kontakt copy.
	self should: [( k2 slots at: #adr) pName = (adr pName, '_1')].
	self should: [( k2 slots at: #adr) frame pName = (kontakt pName, '_1')].	
! !

!SvoTestSuiteCopyClone methodsFor: 'running' stamp: 'hk 2/20/2015 14:31'!
testSvoCopyUniqueNo
	|   adr2 adr3 rn |

	rn := adr runningNo .
	adr2 := adr copy.
	adr3 := adr copy.
	self should: [adr runningNo = (rn + 2) ].
	self should: [adr3 uniqueNo  - adr2 uniqueNo = 10 ].
! !

!SvoTestSuiteCopyClone methodsFor: 'running' stamp: 'hk 2/6/2015 13:54'!
testSvoCopyView
	|   adr2  |
	(adr slotAt: #city) addToView: #short .
	(adr slotAt: #PLZ) addToView: #short .
	adr2 := adr copy: #short .

	self should: [adr copies size = 1 ].
	self should: [adr2 slots size = 2 ].
	self should: [( adr2 slots at: #city) value = 'Frankfurt' ].
	self should: [ adr2 slotSequence first = #PLZ ]
! !

!SvoTestSuiteCopyClone methodsFor: 'running' stamp: 'hk 2/6/2015 13:58'!
testSvoCopyView1
	|   adr2  |
	(adr slotAt: #city) addToView: #short .
	(adr slotAt: #PLZ) addToView: #short .
	adr2 := adr copy: nil .

	self should: [adr copies size = 1 ].
	self should: [adr2 slots size = 3 ].
	self should: [( adr2 slots at: #city) value = 'Frankfurt' ].
	self should: [ adr2 slotSequence first = #strasse ]
! !

!SvoTestSuiteCopyClone methodsFor: 'running' stamp: 'hk 2/6/2015 13:56'!
testSvoCopyView2
	|   adr2  |
	adr2 := adr copy: #short .

	self should: [adr copies size = 1 ].
	self should: [adr2 slots size = 0 ].
	self should: [ adr2 slotSequence isEmpty ]
! !

!SvoTestSuiteCopyClone methodsFor: 'helpers' stamp: 'hk 1/21/2015 15:47'!
xtestDelete
	| fn  new |
	adr delete  .
	fn := adr fileName.
	new := SvoStorage readDsvo:  fn. 
	self should: [ new deleted  ].
	self should: [ adr deleted ].
	self should: [ new version = adr version ].
	self should: [ new pName = adr pName ]! !

!SvoTestSuiteCopyClone methodsFor: 'helpers' stamp: 'hk 1/21/2015 15:47'!
xtestStore
	| fn vers new |
	vers := adr version . 
	adr save.
	fn := adr fileName.
	new := SvoStorage readDsvo:  fn. 
	self should: [ new deleted not ].
	self should: [ adr deleted not ].
	self should: [ new version = (vers + 1) ].
	self should: [ new pName = adr pName ].
	self should: [ new slots size = adr slots size ].
	
	
	
"	hier fehlennoch viele weitere Checks
"! !

SvoTests subclass: #SvoTestSuiteServices
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Tests'!

!SvoTestSuiteServices methodsFor: 'as yet unclassified' stamp: 'hk 12/4/2014 16:49'!
setUp
	super setUp.
	self class makeAdresse.
	self class makeKontakte
! !

!SvoTestSuiteServices methodsFor: 'running' stamp: 'hk 4/3/2015 17:07'!
testAllSvoNames
	| res |
	res := DomainSVO allSvoNames .
	self should: [ res size = 6 ].
	self should: [ res first isString ].
! !

!SvoTestSuiteServices methodsFor: 'running' stamp: 'hk 4/3/2015 17:07'!
testSearch
	"test spoNameFrom:wirh: is missing - requires UI interaction"
	| res |
	res := DomainSVO svoNamesFrom: #Kontakt with: #(#Fritz).
	self should: [ res size = 1 ].
	self should: [ res first isString ].
	res := DomainSVO svoNamesFrom: #Kontakt with: #(#Krasemann  #Hartmut).
	self should: [ res first isString ].
	self should: [ res size = 2 ] ! !

!SvoTestSuiteServices methodsFor: 'running' stamp: 'hk 4/3/2015 17:07'!
testSelection
	"test with aColl of size > 1 missing - requires UI interaction"
	| res |
	res := DomainSVO svoNamesFrom: #Kontakt with: #Fritz.
	res := DomainSVO selectFrom: res .
	self should: [ res isString ] ! !

!SvoTestSuiteServices methodsFor: 'running' stamp: 'hk 4/3/2015 17:07'!
testValueLookup
	"test with missing key is missing - requires UI interaction"
	| res |
	res := DomainSVO valueNamed: #email of:  #Kontakt_4.
	self should: [ res value = 'Fritz@Krasemann.de' ] ! !

SvoTests subclass: #SvoTestSuiteSlotBasics
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Tests'!

!SvoTestSuiteSlotBasics methodsFor: 'running' stamp: 'hk 4/3/2015 17:07'!
testAddSlotWrongName
	| svo |
	svo := DomainSVO new: 'root' .
	svo addValue: 'something' at: #bla .
	self should: [svo addValue: 'more' at: #bla ] raise: Error 
! !

!SvoTestSuiteSlotBasics methodsFor: 'running' stamp: 'hk 4/3/2015 17:07'!
testAddSlots
	| svo |
	svo := DomainSVO new: 'root' .
	svo addMethod:   'something' at: #bla .
	svo addSvo: self class makeAdresse at: #bla2.
	svo addValue: 'something else' at: #bla3 .
	svo addValueList: #( #a #b#c) at: #bla4 .
	svo addSvoDynamicList: 'Adresse (Frankfurt)' at: #freunde.
	self should: [ svo slots size = 5 ].  
! !

!SvoTestSuiteSlotBasics methodsFor: 'running' stamp: 'hk 2/28/2015 14:08'!
testAddValues
	| svo |
	svo := self class makeAdresse.
	self should: [ 'Frankfurt' = (svo slots at: #city) value ].
	self should: [ 'Rheinstr. 7' = (svo slots at: #strasse) value ].
	self should: [ 'D22869' = (svo slots at: #PLZ) value ].
	^svo! !

!SvoTestSuiteSlotBasics methodsFor: 'running' stamp: 'hk 2/28/2015 14:10'!
testDisplayValues
	| svo |
	svo := self class makeAdresse.
	svo removeSlot: #city.
	svo addValue: 'Bonn' at: #city forDisplay: true.
	self should: [ 'Bonn' = (svo slots at: #city) value ].
	self should: [ '*Bonn*' match: svo displayString  ].
	self should: [ ('*286*' match: svo displayString ) not ].
! !

!SvoTestSuiteSlotBasics methodsFor: 'running' stamp: 'hk 4/3/2015 17:07'!
testEntityElder
	| svo |
	svo := DomainSVO new: 'root' .
	svo addSvo: self class makeAdresse at: #bla.
	self should: [ (DomainSVO at: #Adresse) elder notNil ].  
	self should: [ (DomainSVO at: #Adresse) elder pName = svo pName ].  
! !

!SvoTestSuiteSlotBasics methodsFor: 'running' stamp: 'hk 2/28/2015 14:11'!
testRemoveValues
	| svo |
	svo := self testAddValues.
	svo  removeSlot: 'city' .
	svo removeSlot: 'strasse' .
	svo removeSlot: 'PLZ' .
	self should: [ svo slots isEmpty  ].
! !

!SvoTestSuiteSlotBasics methodsFor: 'running' stamp: 'hk 4/3/2015 17:07'!
testRetrieve
	DomainSVO new: 'root' .
	self should: [ #root =  (DomainSVO at: 'root') pName ].  "explicit retrieve"
! !

SvoTests subclass: #SvoTestSuiteViews
	instanceVariableNames: 'kontakt'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Tests'!

!SvoTestSuiteViews commentStamp: 'hk 2/28/2015 14:47' prior: 0!
A SvoTestSuiteViews is xxxxxxxxx.

Instance Variables
	kontakt:		<Object>
!

!SvoTestSuiteViews methodsFor: 'as yet unclassified' stamp: 'hk 2/28/2015 14:12'!
setUp
	| adr  email |
	super setUp.
	adr := self class makeAdresse.
	kontakt := self class makeKontakt .
	email := self class makeEmail .
	adr addSvo: email at: #email .
	kontakt addSvo: adr at: #adresse .
! !

!SvoTestSuiteViews methodsFor: 'as yet unclassified' stamp: 'hk 2/28/2015 14:48'!
testaccessView
	| svo |
	svo := self testcreateView.
	self should: [ (svo adr) = 'Hartmut@Krasemann' ].  
	self should: [ (svo stadt) = 'Frankfurt' ].  
	self should: [ (svo content) = '' ].  
! !

!SvoTestSuiteViews methodsFor: 'as yet unclassified' stamp: 'hk 2/28/2015 14:48'!
testchangeThruView
	| svo |
	svo := self testcreateView.
	svo adr: 'fritz'.
	svo stadt: 'Mainz'.
	svo content: 'blabla' .
	self should: [ (svo adr) = 'fritz' ].  
	self should: [ (svo stadt) = 'Mainz' ].  
	self should: [ (svo content) = 'blabla' ].  
! !

!SvoTestSuiteViews methodsFor: 'as yet unclassified' stamp: 'hk 2/28/2015 18:22'!
testcopyView
	| svo copy |
	svo := self testcreateView.
	copy := svo copyView .
	self should: [copy slotSize = 3] .
	self should: [svo copies size = 1] .
	self should: [copy isAsvo not ] .
	self should: [(copy pName subStrings: '-' ) includes: svo pName] .
	self should: [(copy pName subStrings: '-' ) includes: svo model pName] .
	self should: [(copy pName subStrings: '-' ) includes: svo model runningNo asString] .
! !

!SvoTestSuiteViews methodsFor: 'as yet unclassified' stamp: 'hk 4/3/2015 17:09'!
testcreateView
	| svo |
	(svo := ViewSVO new: #myView) model: kontakt copy.
	svo shortcut: #content for: 'adresse.email.text' .
	svo shortcut: #stadt for: 'adresse.city' .
	svo shortcut: #adr for: 'email' .
	^svo! !

!SvoTestSuiteViews methodsFor: 'as yet unclassified' stamp: 'hk 2/28/2015 14:53'!
testmissingView
	| svo |
	svo := self testcreateView.
	self should: [svo adrx: 'fritz'] raise: Error .
	self should: [svo contentx] raise: Error
! !

!SvoTests class methodsFor: 'newScripts' stamp: 'hk 1/26/2015 17:29'!
authorGloConn
	"self authorGloConn"
	
	self createUC1 .	
	self populateUC1 .

	(SvoSpecUI on: gcProcessesContext ) openWithSpec 	.
	(SvoSpecUI on: gcBizProcessContext ) openWithSpec 	.
	^(SvoSpecUI on: gcMainContext ) openWithSpec ! !

!SvoTests class methodsFor: 'scripts' stamp: 'hk 1/14/2015 11:17'!
createCompany
	"self createCompany"
	
	self createCompanyStaticSPO ; 
		createCompanyDslSlots .
	
	firma addSvoDynamicList: 'GloConnVorgang (V4711)' at: #vorgaenge .
	vorgang addSvo: angebot at: #angebot.
	vorgang addSvo: auftrag at: #auftrag.
	vorgang addSvo: kalkulation at: #kalkulation.
	vorgang addSvo: transport at: #transport.
	vorgang addSvo: rechnung at: #bill.
	vorgang addSvo: kunde at: #kunde .

	auftrag addSvoStaticList: position at: #positionen . 

	kunde addSvo: adresse at: #adresse .

	position addSvo: tour at: #tour .
		
	firma edit.
	vorgang copy.
	vorgang copy.
	vorgang edit.
! !

!SvoTests class methodsFor: 'scripts' stamp: 'hk 1/14/2015 11:17'!
createCompanyDslSlots
	"self createCompany"
	
	vorgang addMethod: 'aktualisiereRechnung' at: #updateBill . 

	auftrag addValueDsl: 'preis@position' at: #wert .

	transport addSvoDynamicList: 'GloConnTour (V4711)' at: #touren .
	transport addMethod: 'neueTour an GloConnVorgang (V4711)' at: #neueTour .

	kalkulation addValueDsl: 'kosten @ GloConnTransport ( V4711 )' at: #kosten .
	kalkulation addMethod: 'neueTour an GloConnVorgang (V4711)' at: #neueTour .
	
	position addValueDsl: 'kosten@tour' at: #preis .
	
	rechnung addValueDsl: 'Name@kunde@parent' at: 'kundenName' .
	rechnung addValueDsl: 'wert@auftrag@parent' at: 'preis' .
	rechnung addValueDsl: 'preis@position@auftrag@parent' at: 'positionsPreis' .
! !

!SvoTests class methodsFor: 'scripts' stamp: 'hk 4/3/2015 17:07'!
createCompanyStaticSPO
	"self createCompany"

	firma := (DomainSVO new: 'GloConnGmbH' )
		 addValue: 'Dr. Christoph Crasemann' at:  'Inhaber' ;
		 addValue: 'Dr. Christoph Crasemann' at:  'Buchhalter' ;
		 addValue:  'Dr. Hartmut Krasemann' at: 'Disponent' ;
		 addValue: 'Euros' at:  'Gewinn' ;
		yourself.
	vorgang := (DomainSVO new: 'GloConnVorgang' )
		 addValue:  'V0000 ' at: 'id' ;
		 addValue: 'Datum/leer' at:  'start' ;
		 addValue:  'ja/nein' at: 'abgerechnet' ;
		 addValue: 'Datum/leer' at: 'archiviert' ;
		yourself.
	angebot := (DomainSVO new: 'GloConnAngebot' )
		 addValue: 'Euros' at: 'Preis' ;
		 addValue:  'Beschreibung' at: #Leistung ;
		yourself.
	auftrag := (DomainSVO new: 'GloConnAuftrag' )
		 addValue: 'Datum/leer'  at: #Termin;
		yourself.
	kalkulation := (DomainSVO new: 'GloConnKalkulation' )
		 addValue: 'km'  at: #entfernung ;
		yourself.
	transport := (DomainSVO new: 'GloConnTransport' )
		 addValue:  'ja/nein'  at: #fertig;
		 addValue:  'Euro'  at: #kosten;   "Akkumulator über Touren"
		yourself.
	tour := (DomainSVO new: 'GloConnTour' )
		 addValue:  'key' at:  #vorgang;
		 addValue: '100'  at: #km;
		 addValue:  '100'  at: #kg;
		 addValue:  '1'  at: #cbm ;
		 addValue: 'ja/nein'  at: #ausgeliefert;
		 addValue:  'Euro'  at: #kosten;
		yourself.
	rechnung := (DomainSVO new: 'GloConnBill' )
		 addValue:  'Euros'  at: #Endpreis;
		 addValue:  'Tage'  at: #Zahlungsziel;
		yourself.
	adresse := (DomainSVO new: 'GloConnAdresse' )
		 addValue:   'Straße'  at: #Strasse;
		 addValue:   'plz'  at: #PLZ;
		 addValue:  'city'  at: #Stadt ;
		yourself.
	kunde := (DomainSVO new: 'GloConnKunde' )
		 addValue:   'Müller'  at: #Name;
		 addValue:  'Fritz'  at: #Vorname;
		"#adresse"
		yourself.
	position := (DomainSVO new: 'GloConnAuftragsPos' )
		 addValue:   'Text'  at: #Beschreibung;
		yourself.

! !

!SvoTests class methodsFor: 'newScripts' stamp: 'hk 4/3/2015 17:08'!
createUC1
	"self createUC1"
	
	| gcMainPrintRole gcMainSettings gcNewCustomerFile   gcCopyRole  sd  gcEditRole gcDeleteRole gcCustView gcServiceView gcSharedView gcAnfrageView gcAngebotsView gcAuftragsView gcDashContext gcCalcContext |
	
	gcCopyRole := (BehaviourSVO new: 'GCCopy' )
		addMethod: 'emailAn an Kontakt' at: #email;
		yourself.
		
	gcEditRole := (BehaviourSVO new: 'GCEdit' )
		addMethod: 'edit mit GCServiceContext' at: #edit;
		yourself.

	gcDeleteRole := (BehaviourSVO new: 'GCDelete' )
		addMethod: 'delete an GCServiceContext' at: #delete;
		yourself.

	gcMainPrintRole := (BehaviourSVO new: 'GCMainPrinting' )
		addMethod: '' at: #print;
		yourself.

	gcMainSettings := (BehaviourSVO new: 'GCMainSetting' )
		addMethod: '' at: #settings;
		yourself.

	gcNewCustomerFile := (BehaviourSVO new: #neuerVorgang )
		addMethod: 'neu mit GCCustContext' at: #neuerTransportLand;
		addMethod: 'neu bla GCAnfrageContext' at: #neueAnfrage;
		addMethod: 'neu mit GCAngebotsContext' at: #neuesAngebot;
		addMethod: 'neu mit GCAuftragsContext' at: #neuerAuftrag ;
		addMethod: 'neu mit GCServiceContext' at: #neuerService ;
		yourself.

	ct := self makeContact .
	sd := self makeServiceDescription.

	process := (DomainSVO new: 'GCProcess' )
		addValue: 'undef' at:  #type forDisplay: true;
		addValue: 'undef' at:  #status forDisplay: true ;			"BPStatus ?"
		addSvo: sd at: #serviceDescription ;
		addValue: 'undef' at:  #ownership forDisplay: true ;
		addValue: 'undef' at:  #dateDue forDisplay: true ;
		yourself.
		
	gcCustView := (CFplainSVO new: 'GCCustContext' ) 
		displayName: 'Customer' ;
		aspect: #customer  ;
		aspectType: #GCContact ;
		vo: #bizProcessCustView ;   "vo is a view on contact"
		uiClass: #GloConnProcessCustUI ;
		yourself.
	gcServiceView := (CFplainSVO new: 'GCServiceContext' ) 
		displayName:  'Service'  ;
		uiClass: #SvoSpecUI ;
		aspect: #serviceDescription ;
		yourself.
	gcSharedView := (CFplainSVO new: 'GCSharedContext' ) 
		displayName:  'Shared Information' ;
		uiClass: #SvoSpecUI ;
		yourself .
	gcAnfrageView := (CFplainSVO new: 'GCAnfrageContext' ) 
		displayName:  'Anfrage'  ;
		uiClass: #SvoSpecUI ;
		yourself .
	gcAngebotsView := (CFplainSVO new: 'GCAngebotsContext' )
		displayName:  'Angebot'  ;
		uiClass: #SvoSpecUI ;
		yourself .
	gcAuftragsView := (CFplainSVO new: 'GCAuftragsContext' )
		displayName:  'Auftrag' ;
		uiClass: #SvoSpecUI ;
		yourself .
	
	(gcBizProcessContext := CFplainSVO new: 'GCBizProcessContext') 
		displayName:  'Biz Process'  ;
		aspect: #bizProcess ;
		uiClass: #GloConnProcessUI ;
		addRo: gcCopyRole ;
		addSvo: ct  at: #customer ;
		addView: gcCustView;
		addView: gcServiceView ;
		addView: gcSharedView ;
		addView: gcAnfrageView ;
		addView: gcAngebotsView ;
		addView: gcAuftragsView .
	
	(gcProcessesContext := CFlistSVO new: 'GCProcessesContext' ) 
		displayName: 'Biz Vorgänge'  ;
		aspect: #bizProcessesPane ;
		uiClass: #GloConnListUI ;
		addRo: gcEditRole ;
		addRo: gcDeleteRole ;
		addRo: gcNewCustomerFile  ;
		asvo: process ;
		cfPlain: gcBizProcessContext .

	(gcDashContext := CFlistSVO new: 'GCDashContext' ) 
		displayName: 'Dash Board'  ;
		uiClass: #GloConnDashUI ;
		aspect: #dashPane .

	(gcCalcContext := CFlistSVO new: 'GCCalcContext' ) 
		displayName: 'Calculator'  ;
		uiClass: #GloConnCalcUI ;
		aspect: #calcPane .

	gcMainContext := (CFplainSVO new: 'GCMainContext' )
		 addValue: ' ' at:  'loginTimeStamp' ;
		 addValue: ' ' at:  'loginName' ;
		addView: gcProcessesContext  ;
		addView: gcDashContext ;
		addView: gcCalcContext ;
		yourself.
	
	^gcProcessesContext ! !

!SvoTests class methodsFor: 'helpers' stamp: 'hk 4/3/2015 17:07'!
makeAdresse
	^(DomainSVO new: 'Adresse' )
		 addValue:  'Rheinstr. 7' at: 'strasse'  ;
		 addValue:  'D22869' at: 'PLZ' ;
		 addValue: 'Frankfurt' at: 'city' forDisplay: true ;
		yourself
! !

!SvoTests class methodsFor: 'newScripts' stamp: 'hk 4/7/2015 13:44'!
makeContact
	"(SvoSpecUI on: self makeContact) openWithSpec "	
		
	| email tel url communication contactIdentity contact |
	address := (DomainSVO new: 'GCAddress' )
		 addValue:   'street'  at: #street;
		 addValue:   'zip'  at: #zip;
		 addValue:  'city'  at: #city ;
		yourself.
	personIdentity := (DomainSVO new: 'GCPersonIdentity' )
		 addValue:   'id'  at: #contactId;
		 addValue:   'name'  at: #lastName;
		 addValue:  'first names' at: #firstName;
		yourself.
	email := (DomainSVO new: 'GCemail' )
		 addValueList:  #( #private #biz )  at: #usage;
		 addValue:   'undefinded'  at: #address;
		yourself.
	tel := (DomainSVO new: 'GCtel' )
		 addValueList:   #( #telPrivate #telBiz #faxPrivate #faxBiz #mobile)  at: #usage;
		 addValue:   'undefinded'  at: #no;
		yourself.
	url := (DomainSVO new: 'GCurl' )
		 addValueList:  #( #private #biz )  at: #usage;
		 addValue:   'undefinded'  at: #url;
		yourself.
	date := (DomainSVO new: 'GCdate' )
		 addValue:   'yyyy'  at: #year;
		 addValue:   'mm'  at: #month;
		 addValue:   'dd'  at: #day;
		addMethod: ' ' at: #checkDate;		"eigentlich ein Constraint"
		yourself.
	communication := (DomainSVO new: 'GCCommunication' )
		 addSvo:   email  at: #email;
		 addSvo:   tel at: #tel;
		 addSvo:   url at: #url;
		yourself.		
	person := (DomainSVO new: 'GCPerson' )
		 addSvo:  personIdentity at: #personIdentity;
		 addValueList: #( 'Mr.' 'Mrs.' 'Ms.' )  at: #salutation;
		 addValueList: #( '' 'Prof.' 'Dr.' )  at: #xtitle;
		 addSvo:  communication at: #communication;
		 addSvo:  address  at: #address;
		 addValue:   'undefined'  at: #role;
		 addSvo:  date at: #birthday;
		yourself.
			
	contactIdentity 	:= (DomainSVO new: 'GCContactIdentity' )
		 addValue:   'a company name'  at: #companyName;
		 addSvo:  person at: #mainContactPerson;
		 addValueList: #( 'supplier' 'customer' 'endCustomer' 'bizContact' )  at: #bizContactRoles;
		yourself.
	contact :=  (DomainSVO new: 'GCContact' )
		 addSvo:  contactIdentity  at: #contactIdentity;
		 addSvoStaticList:  person at: #contactStaff;
		yourself.
	
	contact contactStaff addExemplar .
	
	bizProcessCustView := 	(ViewSVO new: #bizProcessCustView ) 
		shortcut: #cfName for: 'contactIdentity.mainContactPerson.personIdentity.firstName' ;
		shortcut: #clName for: 'contactIdentity.mainContactPerson.personIdentity.lastName' ;
		shortcut: #cCompany for: 'contactIdentity.companyName' ;
		shortcut: #cStreet for: 'contactIdentity.mainContactPerson.address.street' ;
		shortcut: #cZip for: 'contactIdentity.mainContactPerson.address.zip' ;
		shortcut: #cCity for: 'contactIdentity.mainContactPerson.address.city' ;
		shortcut: #cTel for: 'contactIdentity.mainContactPerson.communication.tel.no' ;
		shortcut: #cEmail for: 'contactIdentity.mainContactPerson.communication.email.address' ;
		shortcut: #cUrl for: 'contactIdentity.mainContactPerson.communication.url.url' ;
		yourself.
		
	^contact! !

!SvoTests class methodsFor: 'helpers' stamp: 'hk 4/3/2015 17:07'!
makeEmail
	"self makeEmail; makeKontakt"
	| em  |
	em := DomainSVO new: 'Email'.
	em addValue: '' at: 'an' .
 	em addValue:  ''  at: 'betreff' .
	em addValue: '' at: 'text' .
	^ em 
! !

!SvoTests class methodsFor: 'helpers' stamp: 'hk 4/3/2015 17:07'!
makeKontakt
	| kont  |
	kont := DomainSVO new: 'Kontakt'.
	kont addValue: 'Krasemann' at: 'nachname' forDisplay: true.
 	kont addValue: 'Hartmut' at:  'vorname' forDisplay: true.
	kont addValue: 'Hartmut@Krasemann' at:  'email' forDisplay: true.
	^ kont
! !

!SvoTests class methodsFor: 'helpers' stamp: 'hk 3/15/2015 14:09'!
makeKontakte
	"self makeKontakte"
	| aspo  k2  k4 |
	aspo := self makeKontakt .
	aspo copy.
	k2 := aspo copy.
	aspo copy.
	k4 := aspo copy.
	k4 changeValueAt: 'vorname' to:  'Fritz'.
	k2 changeValueAt: 'vorname' to:  'Karl'.
	k4 changeValueAt: 'email' to:  'Fritz@Krasemann.de'; save.
	k2 changeValueAt: 'email' to:  'Karl@Krasemann.de'; save.
	^aspo

! !

!SvoTests class methodsFor: 'newScripts' stamp: 'hk 4/3/2015 17:07'!
makeServiceDescription
	"(SvoSpecUI on: self makeServiceDescription) openWithSpec "	
		
	| route |	
	route := (DomainSVO new: 'GCRoute' )
		addSvo: address at: #origin;
		addSvo: address at: #destination;
		yourself.
		
	position := (DomainSVO new: 'GCTransportPosition' )
		addValue: 'LKW ' at: #means;
		addValue:  '1' at: #amount;
		addValue: ' ' at: #weight;
		addValue: ' ' at: #volume ;
		addValue: ' ' at: #goods ;
		yourself.
	
	^(DomainSVO new: 'GCServiceDescription' )
		addSvo: route at: #route;
		addSvoStaticList: position at: #transport;
		yourself.
		
! !

!SvoTests class methodsFor: 'scripts' stamp: 'hk 1/26/2015 22:28'!
openSample
	"SvoTests  openSample"
	| adr kontakt  |
	self makeEmail.
	adr := self  makeAdresse .
	kontakt := self makeKontakte  .
	kontakt exec: (AddSvoCopy named:  'adr' on: adr  ).
	^(SvoSpecUI on: kontakt) openWithSpec ; yourself! !

!SvoTests class methodsFor: 'newScripts' stamp: 'hk 3/15/2015 15:01'!
populateUC1

	| p1 p2 p3    |

	 
	(p1 := process copy) addSvo: ct copy at: #customer .
	(p2 := process copy) addSvo: ct copy at: #customer .
	(p3 := process copy) addSvo: ct copy at: #customer .

	 p1 type: 'internal' .
	 p1  status: 'open' .
	 p1  ownership: 'hartmut' .
	 p1  dateDue: '3.3.2015' .
	p1 customer contactIdentity mainContactPerson personIdentity lastName: 'Crasemann' .
	p1 customer contactIdentity mainContactPerson personIdentity firstName: 'Chris W. T. ' .
	
	 p2 type: 'transport land' .
	 p2 status: 'open' .
	 p2 ownership: 'chris' .
	 p2 dateDue: '9.3.2015' .
	p2 customer contactIdentity mainContactPerson personIdentity lastName: 'Meier' .
	p2 customer contactIdentity mainContactPerson personIdentity firstName: 'Hans' .
	
	 p3  type: 'transport sea' .
	 p3  status: 'in progress' .
	 p3  ownership: 'chris' .
	 p3  dateDue: '9.2.2015' .
	 p3 customer contactIdentity mainContactPerson personIdentity lastName: 'Montabur' .
	 p3 customer contactIdentity mainContactPerson personIdentity firstName: 'Carl G. ' .
		! !

!SvoTests class methodsFor: 'newScripts' stamp: 'hk 3/4/2015 11:36'!
tryGloConn
	"self tryGloConn"
	
	self createUC1 .		
	self populateUC1 .
	 "singular contexts, no copy : "
	^(GloConnMainUI  on: gcMainContext )
		openWithSpec ! !

!SvoTests methodsFor: 'running' stamp: 'hk 1/5/2015 14:06'!
setUp
	self tearDown ! !

!SvoTests methodsFor: 'running' stamp: 'hk 2/9/2015 17:15'!
tearDown 
	SvoStorage deleteAllFiles.
	SVO clearSvos .
	SVO allSubclassesDo: [ :cls | cls clearSvos ]
! !

PPCompositeParser subclass: #DslGrammar
	instanceVariableNames: 'action id searchsvos sideEffect searchsvo slotlookup valuelist pathresult pathstart asvo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Parser'!

!DslGrammar commentStamp: 'hk 12/10/2014 10:45' prior: 0!
A DSLGrammar is the Parser for our SPO-DSL.

Me and my subclasses form a hierarchy where
 - the parsers (rules) are declared 
- the productions are organized. 

The leaves of my subclasss tree constitute different little languages used in different places 

Instance variables: 
	the single parsers
	

PPBrowser open!

!DslGrammar methodsFor: 'grammar' stamp: 'hk 2/12/2015 16:20'!
action
	^id , ('an' asParser | 'mit' asParser) trim! !

!DslGrammar methodsFor: 'grammar' stamp: 'hk 2/3/2015 17:02'!
asvo
	^id! !

!DslGrammar methodsFor: 'grammar' stamp: 'hk 10/27/2014 13:18'!
id
	^ (#letter asParser , #word asParser star) token trim ! !

!DslGrammar methodsFor: 'grammar' stamp: 'hk 12/10/2014 13:18'!
pathresult
	^ ( id,  $@ asParser trim,  pathresult) / pathstart! !

!DslGrammar methodsFor: 'grammar' stamp: 'hk 12/10/2014 13:05'!
pathstart
	^  id! !

!DslGrammar methodsFor: 'grammar' stamp: 'hk 1/21/2015 15:40'!
searchsvo
	^searchsvos ! !

!DslGrammar methodsFor: 'grammar' stamp: 'hk 1/21/2015 15:39'!
searchsvos
	^ id, valuelist! !

!DslGrammar methodsFor: 'grammar' stamp: 'hk 2/3/2015 17:02'!
sideEffect
	^action , ( searchsvo / asvo )! !

!DslGrammar methodsFor: 'grammar' stamp: 'hk 1/21/2015 15:41'!
slotlookup
	^id, $@ asParser trim, (searchsvo / pathresult)! !

!DslGrammar methodsFor: 'grammar' stamp: 'hk 12/10/2014 11:19'!
valuelist
	^  '(' asParser trim, id star, ')' asParser trim! !

DslGrammar subclass: #DslSearchParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Parser'!

!DslSearchParser commentStamp: 'hk 12/10/2014 10:41' prior: 0!
A DslSearchParser class is the abstract compiler carrying all common productions!

DslSearchParser subclass: #DslActionEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Parser'!

!DslActionEvaluator commentStamp: 'hk 12/3/2014 14:20' prior: 0!
A DSLActionCompiler executes a side effect, a command 
!

!DslActionEvaluator methodsFor: 'rules' stamp: 'hk 11/27/2014 19:02'!
action
	^ super action ==> [ :n | n ifNotNil: [ (n at: 1) inputValue] ] ! !

!DslActionEvaluator methodsFor: 'rules' stamp: 'hk 2/3/2015 17:03'!
asvo
	^ super asvo ==> [ :n | n inputValue ]! !

!DslActionEvaluator methodsFor: 'rules' stamp: 'hk 2/22/2015 14:33'!
sideEffect
	"call the SVO dsl service with the first arg provided by the dsl text and all other args as found in properties"
	
	^ super sideEffect ==> [ :n |  | args |
		args := OrderedCollection with: (n at: 2) .
		properties ifNotNil: [ args addAll: properties ] .
		SVO perform: (SVO perform: (n at: 1) asSymbol) withArguments: args asArray .
		'' ] ! !

!DslActionEvaluator methodsFor: 'grammar' stamp: 'hk 12/1/2014 14:05'!
start
	^sideEffect end ! !

DslSearchParser subclass: #DslSearchEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Parser'!

!DslSearchEvaluator commentStamp: 'hk 12/10/2014 11:35' prior: 0!
A DSLSearchCompiler returns a list of results.

typical syntax is:  ASPO ( slotValue { slotvalue-i } ) where
- ASPO is the name of ASPO that contains all searched exemplars
- slotValue is an arbitrary slot value of the hits
- more than 1 slotValue allowed

compile: returns either the desired result or an error string.
The error string may come from 
- PetitParser or
- from the SPO micro services that are used in the productions!

!DslSearchEvaluator methodsFor: 'grammar' stamp: 'hk 1/21/2015 15:41'!
start
	^searchsvos  end ! !

!DslSearchParser class methodsFor: 'instance creation' stamp: 'hk 2/12/2015 14:37'!
prop1: anObject  
	^self new propertyAt: #gcProp1 put: anObject; yourself! !

!DslSearchParser class methodsFor: 'instance creation' stamp: 'hk 2/12/2015 14:39'!
prop1: anObject  prop2: onotherObject
	^self new 
		propertyAt: #gcProp1 put: anObject; 
		propertyAt: #gcProp2 put: onotherObject; 
		yourself! !

!DslSearchParser class methodsFor: 'instance creation' stamp: 'hk 2/12/2015 17:17'!
props: anArray
	| o i |
	o := self new. 
	i := 0 .
	anArray do: [ :p |  | propName |
		i := i+1. 
		propName :=  ('gcProp', i asString)  .       
		o propertyAt: propName asSymbol put: p ] .
	^o
	


! !

!DslSearchParser class methodsFor: 'instance creation' stamp: 'hk 4/6/2015 11:06'!
withProperties: anArray
	^self props: anArray

! !

!DslSearchParser methodsFor: 'dsl' stamp: 'hk 12/10/2014 10:37'!
compile:  aSpec
	"answer the parse result or an error string"
	^self parse: aSpec onError: [:msg :pos | (msg, ' at: ', pos printString)] ! !

!DslSearchParser methodsFor: 'rules' stamp: 'hk 2/12/2015 14:49'!
searchsvo
	^super searchsvo ==> [ :n |  SVO selectFrom: n] 
	

! !

!DslSearchParser methodsFor: 'rules' stamp: 'hk 4/3/2015 17:07'!
searchsvos
	^super searchsvos ==> [ :n |  DomainSVO svoNamesFrom: (n at: 1) inputValue with: (n at: 2) ] ! !

!DslSearchParser methodsFor: 'rules' stamp: 'hk 12/10/2014 11:26'!
valuelist
	^super valuelist ==> [ :n |  (n at: 2) collect: [:a | a inputValue ] ] ! !

DslSearchParser subclass: #DslSlotSearchEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Parser'!

!DslSlotSearchEvaluator commentStamp: 'hk 12/3/2014 14:28' prior: 0!
A DSLSlotSearchCompiler finds a slot value of a SPO searched. 

typical syntax is:   slotName @ ASPO ( slotValue ), where 
- slotName is the key of the required slot,
- ASPO knows all searched exemplars,
- slotValue is an arbitrary slot value of the hit
!

!DslSlotSearchEvaluator methodsFor: 'rules' stamp: 'hk 4/3/2015 17:07'!
pathresult
	
	^super pathresult ==> [ :n |  |spoV node| 
			(n isKindOf: DomainSVO) ifTrue: [ n ] ifFalse: 
		 	[((n at: 1) inputValue = 'parent') 
				ifTrue:  [ (node := n at: 3) elder  ifNil: [  self error:   node pName, ' not in a slot' ]  ]
				ifFalse: [ (spoV := (n at: 3) slots at: (n at: 1) inputValue) isSvoSlot 
							ifTrue: [ spoV svo]
							ifFalse: [ self error: 'slot at ', n inputValue, ' not a SVO' ] ] ] ]
			
! !

!DslSlotSearchEvaluator methodsFor: 'rules' stamp: 'hk 2/12/2015 14:36'!
pathstart
	" #gcProp1 determines the start of the path"
	
	^super pathstart ==> [ :n |  |spoV node |   (n inputValue = 'parent') 
				ifTrue:  [ (node := self propertyAt: #gcProp1) elder ifNil: [ self error:  node pName, ' not in a slot' ] ]
				ifFalse: [ (spoV := (self propertyAt: #gcProp1) slots at: n inputValue) isSvoSlot 
							ifTrue: [ spoV svo]
							ifFalse: [ self error: 'slot at ', n inputValue, ' not a SVO' ] ]  ]
			
! !

!DslSlotSearchEvaluator methodsFor: 'rules' stamp: 'hk 4/3/2015 17:07'!
slotlookup
	^super slotlookup ==> [ :n |  DomainSVO slot: (n at: 1) inputValue of: (n at: 3)  ]! !

!DslSlotSearchEvaluator methodsFor: 'grammar' stamp: 'hk 12/8/2014 10:49'!
start
	^slotlookup end ! !

Object subclass: #AbstractSlot
	instanceVariableNames: 'key frame forDisplay viewTags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Slots-VO'!

!AbstractSlot commentStamp: 'hk 2/28/2015 17:34' prior: 0!
I am the abstract class for slot values in the slot dictionary.

No postcopy on frame since that will be done by SVO>>setSlotFrames

Instance Variables
	key:			<Symbol>			my key in the slot dictionary
	frame:			<SVO> 			that I am slot of
	forDisplay:		<Boolean>			true if I'm a visible attribute of my frame in lists
	viewTags 		<Set of Symbol>	each view denoted by a symbol
!

!AbstractSlot methodsFor: 'views' stamp: 'hk 2/6/2015 12:53'!
addToView: aSymbol
	^self views add: aSymbol! !

!AbstractSlot methodsFor: 'views' stamp: 'hk 2/6/2015 13:40'!
belongsToView: aSymbolOrNil
	^ aSymbolOrNil isNil or:  [ self views includes: aSymbolOrNil]! !

!AbstractSlot methodsFor: 'serializing' stamp: 'hk 1/20/2015 18:09'!
displayString
	^ 'no display string'
	! !

!AbstractSlot methodsFor: 'accessing' stamp: 'hk 1/20/2015 17:27'!
forDisplay
	^forDisplay ifNil: [ false ]! !

!AbstractSlot methodsFor: 'accessing' stamp: 'hk 1/20/2015 17:27'!
forDisplay: aBoolean
	 forDisplay := aBoolean! !

!AbstractSlot methodsFor: 'private' stamp: 'hk 1/5/2015 15:06'!
frame
	^ frame! !

!AbstractSlot methodsFor: 'accessing' stamp: 'hk 1/5/2015 15:05'!
frame: aSvo
	frame := aSvo! !

!AbstractSlot methodsFor: 'ui' stamp: 'hk 12/11/2014 14:06'!
index
	^self frame slotSequence indexOf: key! !

!AbstractSlot methodsFor: 'testing' stamp: 'hk 12/15/2014 20:24'!
isActionSlot
	^ false! !

!AbstractSlot methodsFor: 'testing' stamp: 'hk 12/15/2014 20:24'!
isConstraintSlot
	^ false! !

!AbstractSlot methodsFor: 'testing' stamp: 'hk 1/19/2015 17:44'!
isDropListSlot
	^ false! !

!AbstractSlot methodsFor: 'testing' stamp: 'hk 1/14/2015 12:03'!
isSvoDynamicList
	^ false! !

!AbstractSlot methodsFor: 'testing' stamp: 'hk 1/14/2015 12:03'!
isSvoList
	^ false! !

!AbstractSlot methodsFor: 'testing' stamp: 'hk 1/14/2015 13:25'!
isSvoSlot
	^ false! !

!AbstractSlot methodsFor: 'testing' stamp: 'hk 3/21/2015 16:05'!
isSvoStaticList
	^ false! !

!AbstractSlot methodsFor: 'testing' stamp: 'hk 12/15/2014 20:26'!
isValueSlot
	^ false! !

!AbstractSlot methodsFor: 'accessing' stamp: 'hk 11/7/2014 13:14'!
key
	^key ! !

!AbstractSlot methodsFor: 'accessing' stamp: 'hk 11/19/2014 13:00'!
key: aString
	key := aString asSymbol! !

!AbstractSlot methodsFor: 'ui' stamp: 'hk 12/14/2014 15:15'!
maxIndex
	^self frame slotSequence size! !

!AbstractSlot methodsFor: 'copying' stamp: 'hk 1/20/2015 17:28'!
postCopy
	forDisplay := forDisplay  copy.! !

!AbstractSlot methodsFor: 'serializing' stamp: 'hk 1/20/2015 17:29'!
storeDetailsOn:  aStream
	aStream nextPutAll:  ' forDisplay: ', forDisplay printString, ';' ! !

!AbstractSlot methodsFor: 'serializing' stamp: 'hk 1/5/2015 15:07'!
storeOn:  aStream
	"write the code needed to be instantiated"
	
	aStream 
		nextPut: $( ;
		nextPutAll:  self class name, ' new ';
		nextPutAll: ' key: ', key printString, ';'  ;
		nextPutAll: 'basicFrame: '.
	self frame storeOn: aStream.
	aStream nextPut: $; .
	self storeDetailsOn: aStream.
	aStream nextPutAll: 'yourself)' 
		
	! !

!AbstractSlot methodsFor: 'ui' stamp: 'hk 1/6/2015 13:17'!
uiClass
	"used for a slot display service of a VO (not list display) by the VO"
	
	self subclassResponsibility ! !

!AbstractSlot methodsFor: 'accessing' stamp: 'hk 3/23/2015 13:03'!
value
	"^self"! !

!AbstractSlot methodsFor: 'views' stamp: 'hk 2/6/2015 12:53'!
views
	^viewTags ifNil: [ viewTags := Set new ]! !

AbstractSlot subclass: #ActionSlot
	instanceVariableNames: 'source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Slots-VO'!

!ActionSlot commentStamp: 'hk 12/10/2014 17:12' prior: 0!
I hold a  DSL text that executes an action = side effect.

Instance Variables
	source:		<String>	the DSL source
!

!ActionSlot methodsFor: 'actions' stamp: 'hk 2/12/2015 14:40'!
evaluator
	^DslActionEvaluator new! !

!ActionSlot methodsFor: 'actions' stamp: 'hk 2/12/2015 17:18'!
evaluator: anArray
	^DslActionEvaluator props: anArray! !

!ActionSlot methodsFor: 'actions' stamp: 'hk 2/3/2015 16:48'!
exec  
	^self evaluator compile:  source ! !

!ActionSlot methodsFor: 'actions' stamp: 'hk 2/20/2015 19:03'!
execFor: anArray
	^ (self evaluator: anArray) compile:  source .
! !

!ActionSlot methodsFor: 'testing' stamp: 'hk 12/15/2014 20:24'!
isActionSlot
	^ true! !

!ActionSlot methodsFor: 'copying' stamp: 'hk 12/9/2014 20:35'!
postCopy
	source := source copy! !

!ActionSlot methodsFor: 'serializing' stamp: 'hk 11/24/2014 21:53'!
printOn:  aStream
	aStream nextPutAll: ' DslSV on: ', source! !

!ActionSlot methodsFor: 'accessing' stamp: 'hk 11/17/2014 14:56'!
source
	^ source ifNil: [ '' ]! !

!ActionSlot methodsFor: 'accessing' stamp: 'hk 11/17/2014 14:55'!
source: aString
	source := aString! !

!ActionSlot methodsFor: 'serializing' stamp: 'hk 12/10/2014 16:45'!
storeDetailsOn:  aStream
	"write the code needed to be instantiated, without Spec vars"
	
	aStream nextPutAll: ' source: ', self source, ';' 
		! !

!ActionSlot methodsFor: 'ui' stamp: 'hk 12/10/2014 17:23'!
uiClass
	^ActionSlotUI  ! !

AbstractSlot subclass: #DropListSlot
	instanceVariableNames: 'list selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Slots-VO'!

!DropListSlot commentStamp: 'hk 2/26/2015 19:01' prior: 0!
I hold a list of strings. My selction is my value.

Instance Variables
	list:		<List of String>
	selection 	<String> 	the selected item

!

!DropListSlot methodsFor: 'serializing' stamp: 'hk 1/20/2015 18:58'!
displayString
	^ self value
	! !

!DropListSlot methodsFor: 'testing' stamp: 'hk 1/19/2015 17:44'!
isDropListSlot
	^ true! !

!DropListSlot methodsFor: 'accessing' stamp: 'hk 12/2/2014 17:32'!
list
	^ list ifNil: [ #() ]! !

!DropListSlot methodsFor: 'accessing' stamp: 'hk 11/28/2014 10:27'!
list: anObject
	list := anObject! !

!DropListSlot methodsFor: 'copying' stamp: 'hk 1/14/2015 12:23'!
postCopy
	list := self list collect: [ :e | e copy ]! !

!DropListSlot methodsFor: 'accessing' stamp: 'hk 1/20/2015 18:57'!
selection
	^selection! !

!DropListSlot methodsFor: 'accessing' stamp: 'hk 1/20/2015 18:53'!
selection: aString
	selection := aString! !

!DropListSlot methodsFor: 'accessing' stamp: 'hk 1/20/2015 17:31'!
storeDetailsOn:  aStream
	"write the code needed to be instantiated, without Spec vars"

	super storeDetailsOn:  aStream. 
	aStream nextPutAll: ' list: '.
	list storeOn: aStream .
	aStream nextPut: $; .
	! !

!DropListSlot methodsFor: 'accessing' stamp: 'hk 1/19/2015 17:40'!
uiClass
	^DropListUI   ! !

!DropListSlot methodsFor: 'accessing' stamp: 'hk 1/20/2015 18:58'!
value
	^ selection ifNil: [ '' ]! !

AbstractSlot subclass: #SvoList
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Slots-VO'!

!SvoList commentStamp: 'hk 2/2/2015 12:55' prior: 0!
I hold a  list of arbitrary SVO .

Instance Variables
	list:			<List of SVO>		

!

SvoList subclass: #SvoDynamicList
	instanceVariableNames: 'source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Slots-VO'!

!SvoDynamicList commentStamp: 'hk 2/26/2015 19:07' prior: 0!
depricated ? 

I hold a dynamic list of SPO .
The list elements are determinded by the DSL text in source 


Instance Variables
	source:		<Object>

!

!SvoDynamicList methodsFor: 'accessing' stamp: 'hk 12/14/2014 11:17'!
evaluator
	^DslSearchEvaluator new! !

!SvoDynamicList methodsFor: 'accessing' stamp: 'hk 4/3/2015 17:07'!
exec
	| res |
	res := self evaluator compile: self source .
	res isString ifTrue: [ list := #(). ^res ].	
	list := res collect: [ :e | DomainSVO at: e ]! !

!SvoDynamicList methodsFor: 'testing' stamp: 'hk 1/14/2015 12:03'!
isSvoDynamicList
	^ true! !

!SvoDynamicList methodsFor: 'testing' stamp: 'hk 1/14/2015 12:03'!
isSvoList
	^ false! !

!SvoDynamicList methodsFor: 'copying' stamp: 'hk 12/14/2014 11:17'!
postCopy
	"list is filled again with exec"
	source := source copy! !

!SvoDynamicList methodsFor: 'accessing' stamp: 'hk 12/14/2014 11:17'!
source
	^source ifNil: [ '' ]! !

!SvoDynamicList methodsFor: 'accessing' stamp: 'hk 12/14/2014 11:17'!
source: aString
	source := aString! !

!SvoDynamicList methodsFor: 'serializing' stamp: 'hk 12/14/2014 11:17'!
storeDetailsOn:  aStream
	"write the code needed to be instantiated, without Spec vars"
	
	aStream nextPutAll: ' source: ', self source, ';' 
		! !

!SvoDynamicList methodsFor: 'accessing' stamp: 'hk 1/21/2015 16:01'!
uiClass
	^SvoDynamicListUI   ! !

!SvoList methodsFor: 'accessing' stamp: 'hk 1/14/2015 12:05'!
add: aSvo
	^self list add: aSvo
! !

!SvoList methodsFor: 'testing' stamp: 'hk 1/14/2015 12:03'!
isSvoList
	^ true! !

!SvoList methodsFor: 'accessing' stamp: 'hk 1/14/2015 12:16'!
list
	^list ifNil: [ list := OrderedCollection new ]
! !

!SvoList methodsFor: 'copying' stamp: 'hk 1/14/2015 13:16'!
postCopy
	list := self list collect: [ :e | e copy ]! !

!SvoList methodsFor: 'ui' stamp: 'hk 1/14/2015 13:36'!
uiClass
	^ SvoListUI ! !

SvoList subclass: #SvoStaticList
	instanceVariableNames: 'templateName accumulators'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Slots-VO'!

!SvoStaticList commentStamp: 'hk 12/31/2014 18:39' prior: 0!
I hold a list of all copies of a template.
I can accumulate fields of those copies

Instance Variables
	accumulators:		<List of Symbol>	accumulating slots
	templateName:		<String>!

!SvoStaticList methodsFor: 'accessing' stamp: 'hk 12/14/2014 21:28'!
accumulators
	^accumulators ifNil: [ accumulators := OrderedCollection new ] ! !

!SvoStaticList methodsFor: 'accessing' stamp: 'hk 12/14/2014 21:54'!
accumulatorsWithSums
	| coll |
	coll := OrderedCollection new.
	self accumulators do: [ :a | 
		coll add: a.
		coll add: (self valueOf: a) ].
	^coll
	
! !

!SvoStaticList methodsFor: 'accessing' stamp: 'hk 12/14/2014 21:36'!
addAccumulator: aLabel
	self accumulators add: aLabel. ! !

!SvoStaticList methodsFor: 'accessing' stamp: 'hk 4/3/2015 17:07'!
addExemplar
	| exmpl |
	exmpl := (DomainSVO at:  templateName) copy.
	exmpl elder: self frame.
	self refreshList! !

!SvoStaticList methodsFor: 'testing' stamp: 'hk 3/21/2015 16:05'!
isSvoStaticList
	^ true! !

!SvoStaticList methodsFor: 'private' stamp: 'hk 12/14/2014 22:16'!
numberOf: aString
	^Number readFrom: aString ifFail: [ 0 ]! !

!SvoStaticList methodsFor: 'copying' stamp: 'hk 12/14/2014 11:24'!
postCopy
	"list is filled again with exec
	ownSlots are calculated"
	templateName := templateName copy.
	! !

!SvoStaticList methodsFor: 'private' stamp: 'hk 4/3/2015 17:07'!
refreshList
	| exmpls |
	exmpls := (DomainSVO at: self templateName ifAbsent: [^self]) copies.
	list := exmpls values collect: [ :e | e  value  ].
! !

!SvoStaticList methodsFor: 'private' stamp: 'hk 12/31/2014 18:43'!
setEntityElders
	self list do: [ :e | e value elder: self frame  ]! !

!SvoStaticList methodsFor: 'accessing' stamp: 'hk 12/14/2014 12:24'!
templateName
	^templateName ifNil: [ '' ]! !

!SvoStaticList methodsFor: 'accessing' stamp: 'hk 12/14/2014 21:11'!
templateName: aPname
	templateName := aPname.
	self refreshList.
	self setEntityElders .
! !

!SvoStaticList methodsFor: 'accessing' stamp: 'hk 4/3/2015 17:07'!
templateValueSlotKeys
	| spo|
	spo := DomainSVO at: self templateName ifAbsent: [ ^#() ].
	^spo valueSlots keys! !

!SvoStaticList methodsFor: 'ui' stamp: 'hk 1/15/2015 14:03'!
uiClass
	^SvoStaticListUI   ! !

!SvoStaticList methodsFor: 'private' stamp: 'hk 12/14/2014 22:18'!
valueOf: accuSymbol
	^self list inject: 0 into: [ :sum :e |
		sum +  (self numberOf: (e valueSlots at: accuSymbol) value) ]! !

AbstractSlot subclass: #SvoSlot
	instanceVariableNames: 'svo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Slots-VO'!

!SvoSlot commentStamp: 'hk 2/2/2015 12:51' prior: 0!
I hold a single SPO in a SpoProxy

Instance Variables
	svo:		<SVO>		 the SVO that I contain
!

!SvoSlot methodsFor: 'serializing' stamp: 'hk 1/21/2015 15:33'!
displayString
	^ self svo ifNil: [ ^'' ]  ifNotNil: [ self svo displayString ]! !

!SvoSlot methodsFor: 'testing' stamp: 'hk 1/14/2015 13:25'!
isSvoSlot
	^ true! !

!SvoSlot methodsFor: 'accessing' stamp: 'hk 1/21/2015 15:33'!
pName
	^ self svo pName! !

!SvoSlot methodsFor: 'copying' stamp: 'hk 1/5/2015 15:09'!
postCopy
	svo :=  svo  copy ! !

!SvoSlot methodsFor: 'printing' stamp: 'hk 1/5/2015 15:09'!
printOn:  aStream
	super printOn: aStream.
	aStream nextPutAll:  ' on: ', svo pName! !

!SvoSlot methodsFor: 'serializing' stamp: 'hk 1/20/2015 17:31'!
storeDetailsOn:  aStream
	super storeDetailsOn:  aStream. 
	aStream nextPutAll: 'basicSpo: '.
	svo storeOn: aStream.
	aStream nextPut: $; .

! !

!SvoSlot methodsFor: 'accessing' stamp: 'hk 2/2/2015 12:51'!
svo
	^ svo! !

!SvoSlot methodsFor: 'accessing' stamp: 'hk 1/21/2015 15:33'!
svo: aSvo
	svo := aSvo
! !

!SvoSlot methodsFor: 'accessing' stamp: 'hk 1/21/2015 15:33'!
svoDisplayValues
	| coll |
	coll := OrderedCollection new.
	self svo slotSequence do: [ :k | | slot|
		(slot := self svo slots at: k) forDisplay ifTrue: [ coll add: slot ] ].
	^coll
	
  ! !

!SvoSlot methodsFor: 'testing' stamp: 'hk 1/14/2015 13:30'!
uiClass
	^ SvoEmbeddedUI ! !

!SvoSlot methodsFor: 'accessing' stamp: 'hk 3/23/2015 13:03'!
value
	^ self svo! !

AbstractSlot subclass: #ValueSlot
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Slots-VO'!

!ValueSlot commentStamp: 'hk 12/10/2014 17:17' prior: 0!
I hold a string attribute

Instance Variables
	forDisplay:		<Boolean> 		true if this slot is used in UI lists
	value:			<String>

!

ValueSlot subclass: #DslValueSlot
	instanceVariableNames: 'source origin originalKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Slots-VO'!

!DslValueSlot commentStamp: 'hk 2/26/2015 18:59' prior: 0!
depricated - use copyView instead

I am a ValueSlot that is filled by executing a piece of DSL

storeOn: und postCopy for origin & originaslKey ?

Instance Variables
	source:			<String>		DSL source
	origin: 			< String>		origin pName
	originalKey: 	< String>		key at origin 
			


!

!DslValueSlot methodsFor: 'ui-actions' stamp: 'hk 2/12/2015 14:30'!
evaluator
	^DslSlotSearchEvaluator prop1: self frame! !

!DslValueSlot methodsFor: 'ui-actions' stamp: 'hk 12/11/2014 20:06'!
exec
	| slot res |  
	res := self evaluator compile: self source . 
	res isString ifTrue: [ value := res. ^self  ] .
	slot := res copy.
	originalKey := slot key.
	value := slot value.
	origin := slot frame pName
	! !

!DslValueSlot methodsFor: 'testing' stamp: 'hk 1/26/2015 11:35'!
isActionSlot
	^ true! !

!DslValueSlot methodsFor: 'accessing' stamp: 'hk 12/2/2014 16:55'!
originalKey
	^originalKey ifNil: [ '' ]! !

!DslValueSlot methodsFor: 'copying' stamp: 'hk 12/9/2014 20:34'!
postCopy
"originalKey & origin are filled anew on exec"
	super postCopy.
	source := source copy! !

!DslValueSlot methodsFor: 'serializing' stamp: 'hk 12/3/2014 15:04'!
printOn:  aStream
	aStream nextPutAll: 'DslValueSV on: ', value printString! !

!DslValueSlot methodsFor: 'accessing' stamp: 'hk 12/2/2014 17:01'!
source
	^source ifNil: [ '' ]! !

!DslValueSlot methodsFor: 'accessing' stamp: 'hk 12/2/2014 17:01'!
source: aString
	source := aString! !

!DslValueSlot methodsFor: 'serializing' stamp: 'hk 12/10/2014 16:55'!
storeDetailsOn:  aStream
	"write the code needed to be instantiated, without Spec vars"

	super storeDetailsOn: aStream .
	aStream nextPutAll: ' source: ', self source printString, ';' ! !

!DslValueSlot methodsFor: 'ui' stamp: 'hk 12/10/2014 17:21'!
uiClass
	^DslValueSlotUI ! !

!ValueSlot methodsFor: 'testing' stamp: 'hk 11/23/2014 13:28'!
contains: aString
	^ aString  = value  ! !

!ValueSlot methodsFor: 'serializing' stamp: 'hk 1/20/2015 17:52'!
displayString
	^self value
	! !

!ValueSlot methodsFor: 'testing' stamp: 'hk 12/15/2014 20:26'!
isValueSlot
	^ true! !

!ValueSlot methodsFor: 'copying' stamp: 'hk 1/20/2015 17:28'!
postCopy
	value := value copy.
! !

!ValueSlot methodsFor: 'serializing' stamp: 'hk 12/3/2014 13:21'!
printOn:  aStream
	aStream nextPutAll: ' ValueSV on: ', value printString! !

!ValueSlot methodsFor: 'serializing' stamp: 'hk 1/20/2015 17:31'!
storeDetailsOn:  aStream
	super storeDetailsOn:  aStream. 
	aStream nextPutAll:  ' value: ', value printString, ';' ! !

!ValueSlot methodsFor: 'ui' stamp: 'hk 1/6/2015 13:05'!
uiClass
	^ValueUI   ! !

!ValueSlot methodsFor: 'accessing' stamp: 'hk 11/23/2014 13:31'!
value
	^value ifNil: [ '' ]! !

!ValueSlot methodsFor: 'accessing' stamp: 'hk 11/23/2014 13:34'!
value: aString
	value := aString! !

Object subclass: #Command
	instanceVariableNames: 'reverseBlock actionBlock receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Commands'!

!Command commentStamp: 'hk 11/18/2014 13:48' prior: 0!
A Command is used in between saves editing a SPO.
The command stack of a SPO is used for undo.
I can hold a SPO since I am not stored - no danger of cycles

Instance Variables
	actionBlock:	<Block>
	reverseBlock:	< Block>		for undo
	receiver:		<SPO>			that executes the command
!

!Command methodsFor: 'copying' stamp: 'hk 11/13/2014 17:04'!
deepCopy
	"don't copy a command"! !

!Command methodsFor: 'executing' stamp: 'hk 11/4/2014 09:13'!
do
	"prepare my blocks,
	execute the command"! !

!Command methodsFor: 'accessing' stamp: 'hk 11/3/2014 15:58'!
receiver: aSPO
	receiver := aSPO ! !

!Command methodsFor: 'executing' stamp: 'hk 11/4/2014 08:58'!
redo
	actionBlock value! !

!Command methodsFor: 'serializing' stamp: 'hk 12/10/2014 17:28'!
storeOn: aStream 
	"PRE: commands are never stored"! !

!Command methodsFor: 'executing' stamp: 'hk 11/4/2014 08:58'!
undo
	reverseBlock value! !

Command subclass: #SlotCommand
	instanceVariableNames: 'slotKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Commands'!

!SlotCommand commentStamp: 'hk 11/19/2014 12:59' prior: 0!
A SlotCommand is a Command for SPO slots 

Instance Variables
	slotKey:	<Symbol>		key of the slot
!

SlotCommand subclass: #AddAction
	instanceVariableNames: 'source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Commands'!

!AddAction commentStamp: 'hk 12/10/2014 17:40' prior: 0!
I am a SlotCommand that adds an ActionSlot to my receiver

Instance Variables
	source:		<String>		DSL source!

!AddAction class methodsFor: 'instance creation' stamp: 'hk 12/10/2014 17:47'!
named: aName source: aString 
	^(self named: aName)
		source: aString;
		yourself! !

!AddAction methodsFor: 'executing' stamp: 'hk 12/4/2014 18:33'!
do
	reverseBlock := [receiver removeSlot: slotKey].
	actionBlock := [receiver addMethod:   source at: slotKey].
	actionBlock value! !

!AddAction methodsFor: 'accessing' stamp: 'hk 11/3/2014 14:58'!
source: anObject
	source := anObject! !

SlotCommand subclass: #AddListOfStrings
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Commands'!

!AddListOfStrings commentStamp: 'hk 11/28/2014 16:38' prior: 0!
An AddList is xxxxxxxxx.

Instance Variables
	list:		<Collection>!

!AddListOfStrings class methodsFor: 'instance creation' stamp: 'hk 12/10/2014 17:47'!
named: aName list: aList 
	^(self named: aName )	
		list: aList;
		yourself! !

!AddListOfStrings methodsFor: 'executing' stamp: 'hk 12/4/2014 18:01'!
do
	reverseBlock := [receiver removeSlot: slotKey].
	actionBlock := [ receiver  addValueList: self list at: slotKey ].
	actionBlock value! !

!AddListOfStrings methodsFor: 'accessing' stamp: 'hk 11/28/2014 16:45'!
list
	^ list! !

!AddListOfStrings methodsFor: 'accessing' stamp: 'hk 11/28/2014 16:32'!
list: anObject
	list := anObject! !

SlotCommand subclass: #AddSpoDynamicList
	instanceVariableNames: 'source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Commands'!

!AddSpoDynamicList commentStamp: 'hk 11/27/2014 18:36' prior: 0!
An AddSpoList is xxxxxxxxx.

Instance Variables
	source:		<String>!

!AddSpoDynamicList class methodsFor: 'instance creation' stamp: 'hk 12/10/2014 17:48'!
named: aName source: aString 
	^(self named: aName )
		source: aString;
		yourself! !

!AddSpoDynamicList methodsFor: 'executing' stamp: 'hk 1/14/2015 11:17'!
do
	reverseBlock := [receiver removeSlot: slotKey].
	actionBlock := [receiver addSvoDynamicList: source at: slotKey ].
	actionBlock value! !

!AddSpoDynamicList methodsFor: 'accessing' stamp: 'hk 11/27/2014 18:43'!
source: aString
	source := aString! !

SlotCommand subclass: #AddSpoStaticList
	instanceVariableNames: 'template'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Commands'!

!AddSpoStaticList commentStamp: 'hk 12/14/2014 14:04' prior: 0!
I add a static spo list

Instance Variables
	template:		<String>!

!AddSpoStaticList class methodsFor: 'as yet unclassified' stamp: 'hk 12/14/2014 14:05'!
named: aName template: aSpoPname
	^(self named: aName )
		template: aSpoPname;
		yourself! !

!AddSpoStaticList methodsFor: 'accessing' stamp: 'hk 4/3/2015 17:07'!
do
	reverseBlock := [receiver removeSlot: slotKey].
	actionBlock := [receiver addSvoStaticList: (DomainSVO at: template) at: slotKey ].
	actionBlock value! !

!AddSpoStaticList methodsFor: 'accessing' stamp: 'hk 1/17/2015 18:33'!
template
	^ template ifNil: [ '' ]! !

!AddSpoStaticList methodsFor: 'accessing' stamp: 'hk 12/14/2014 14:05'!
template: anObject
	template := anObject! !

!AddSpoStaticList methodsFor: 'accessing' stamp: 'hk 4/3/2015 17:07'!
templateSpo
	^DomainSVO at: template! !

SlotCommand subclass: #AddSvoCopy
	instanceVariableNames: 'svo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Commands'!

!AddSvoCopy commentStamp: 'hk 1/30/2015 12:19' prior: 0!
An AddSPO is a SlotCommand

Instance Variables
	svo:		<SVO>		the SVO inserted (always a copy)

!

!AddSvoCopy class methodsFor: 'instance creation' stamp: 'hk 1/30/2015 12:19'!
named: aName on: aSvo 
	^(self new) 
		slotKey: aName;
		svo: aSvo copy ;
		yourself! !

!AddSvoCopy methodsFor: 'executing' stamp: 'hk 1/26/2015 22:19'!
do
	reverseBlock := [receiver removeSlot: slotKey].
	actionBlock := [	 receiver addSvo: svo at: slotKey].
	actionBlock value! !

!AddSvoCopy methodsFor: 'initialize - release' stamp: 'hk 1/30/2015 12:18'!
receiver: aSvo
	receiver := aSvo .
	svo elder: aSvo

! !

!AddSvoCopy methodsFor: 'initialize - release' stamp: 'hk 1/30/2015 12:18'!
svo: aSvo
	svo := aSvo ! !

AddSvoCopy subclass: #CopyAsvo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Commands'!

!CopyAsvo commentStamp: 'hk 1/30/2015 12:43' prior: 0!
I add the spo to exemplars (in list view).
The slotKey is not used, since no slot is used.
!

!CopyAsvo class methodsFor: 'instance creation' stamp: 'hk 1/30/2015 12:23'!
on:  aReceiver
	| cp |
	cp := aReceiver copy.
	^(self new) 
		slotKey: cp pName;
		svo: cp ;
		yourself! !

!CopyAsvo methodsFor: 'executing' stamp: 'hk 1/26/2015 22:19'!
do
	reverseBlock := [receiver removeCopy: svo pName ].
	actionBlock := [receiver addCopy: svo.].
	actionBlock value! !

!CopyAsvo methodsFor: 'executing' stamp: 'hk 1/26/2015 22:20'!
receiver: aSvo
	receiver := aSvo ! !

AddSvoCopy subclass: #RemoveSvoCopy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Commands'!

!RemoveSvoCopy commentStamp: 'hk 1/30/2015 12:43' prior: 0!
I remove the copy named in list view.
The slotKey holds the pName, only used for undo

!

!RemoveSvoCopy methodsFor: 'as yet unclassified' stamp: 'hk 1/26/2015 22:19'!
do
	reverseBlock := [receiver addCopy: svo].
	actionBlock := [svo :=  receiver removeCopy: slotKey ].
	actionBlock value! !

!RemoveSvoCopy methodsFor: 'as yet unclassified' stamp: 'hk 1/26/2015 22:20'!
receiver: aSvo
	receiver := aSvo ! !

SlotCommand subclass: #AddValue
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Commands'!

!AddValue commentStamp: 'hk 11/19/2014 12:56' prior: 0!
An AddValue is a SlotCommand

Instance Variables
	value:		<Srtring>		the slot content

!

AddValue subclass: #AddDslValue
	instanceVariableNames: 'source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Commands'!

!AddDslValue commentStamp: 'hk 12/2/2014 19:32' prior: 0!
An AddValueDsl is xxxxxxxxx.

Instance Variables
	source:		<String>!

!AddDslValue class methodsFor: 'instance creation' stamp: 'hk 12/10/2014 17:48'!
named: aName source: aString 
	^(self named: aName )
		source: aString;
		yourself! !

!AddDslValue methodsFor: 'executing' stamp: 'hk 12/4/2014 18:24'!
do
	reverseBlock := [receiver removeSlot: slotKey].
	actionBlock := [ receiver addValueDsl: self source at: slotKey].
	actionBlock value! !

!AddDslValue methodsFor: 'accessing' stamp: 'hk 12/2/2014 19:32'!
source
	^source ifNil: [ '' ]! !

!AddDslValue methodsFor: 'accessing' stamp: 'hk 12/2/2014 19:32'!
source: aString
	source := aString! !

!AddValue class methodsFor: 'instance creation' stamp: 'hk 12/10/2014 17:48'!
named: aName value: aString 
	^(self named: aName )	
		value: aString;
		yourself! !

!AddValue methodsFor: 'executing' stamp: 'hk 12/4/2014 18:03'!
do
	reverseBlock := [receiver removeSlot: slotKey].
	actionBlock := [ receiver  addValue: self value at: slotKey].
	actionBlock value! !

!AddValue methodsFor: 'accessing' stamp: 'hk 11/11/2014 15:53'!
value
	^value ifNil: [ '' ]! !

!AddValue methodsFor: 'accessing' stamp: 'hk 11/11/2014 15:46'!
value: aString
	value := aString! !

SlotCommand subclass: #MoveDown
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Commands'!

!MoveDown commentStamp: 'hk 11/19/2014 12:56' prior: 0!
A MoveDown is a SlotCommand
!

!MoveDown methodsFor: 'executing' stamp: 'hk 11/18/2014 13:46'!
do
	reverseBlock := [receiver moveUp: slotKey ].
	actionBlock := [receiver moveDown: slotKey ].
	actionBlock value! !

SlotCommand subclass: #MoveUp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Commands'!

!MoveUp commentStamp: 'hk 11/19/2014 12:56' prior: 0!
A MoveUp  is a SlotCommand
!

!MoveUp methodsFor: 'executing' stamp: 'hk 11/18/2014 13:47'!
do
	reverseBlock := [receiver moveDown: slotKey ].
	actionBlock := [receiver moveUp: slotKey ].
	actionBlock value! !

SlotCommand subclass: #RemoveSlot
	instanceVariableNames: 'theSlot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Commands'!

!RemoveSlot commentStamp: 'hk 11/19/2014 12:55' prior: 0!
A RemoveSlot is a SlotCommand

Instance Variables
	theSlot:		<SlotValue>		the one removed!

!RemoveSlot methodsFor: 'executing' stamp: 'hk 11/19/2014 12:54'!
do
	reverseBlock := [receiver addSlot: theSlot].
	actionBlock := [theSlot :=  receiver removeSlot: slotKey ].
	actionBlock value! !

!SlotCommand class methodsFor: 'instance creation' stamp: 'hk 12/10/2014 17:45'!
named: aName 
	^(self new)	
		slotKey:  aName ;
		yourself! !

!SlotCommand methodsFor: 'accessing' stamp: 'hk 12/15/2014 21:04'!
slotKey: aString    
	slotKey := aString asSymbol! !

Object subclass: #GloConnIcons
	instanceVariableNames: ''
	classVariableNames: 'Icons'
	poolDictionaries: ''
	category: 'SVO-UI-App'!

!GloConnIcons class methodsFor: 'icons' stamp: 'hk 3/2/2015 18:25'!
at: aSymbol
	^Icons at: aSymbol! !

!GloConnIcons class methodsFor: 'icons' stamp: 'hk 3/3/2015 19:22'!
iconAt: aKey
	(aKey = 'Customer' ) ifTrue: [ ^Smalltalk ui icons userIcon ].
	(aKey = 'Service' ) ifTrue: [ ^Smalltalk ui icons forwardIcon ].
	(aKey = 'Shared Information' ) ifTrue: [ ^Smalltalk ui icons smallCopyIcon ].
	^nil
	! !

!GloConnIcons class methodsFor: 'icons' stamp: 'hk 3/21/2015 15:03'!
initializeIcons
	"self initializeIcons"
	Icons := Dictionary new.
	Icons at: #bizNet put: ( ColorForm fromFileNamed: 'Icons/bizNet.gif' ).
	Icons at: #bizProcess put: ( ColorForm fromFileNamed: 'Icons/bizProcess.gif' ).
	Icons at: #calc put: ( ColorForm fromFileNamed: 'Icons/calc.gif' ).
	Icons at: #contacts put: ( ColorForm fromFileNamed: 'Icons/contacts.gif' ).
	Icons at: #controlling put: ( ColorForm fromFileNamed: 'Icons/controlling.gif' ).
	Icons at: #dash put: ( ColorForm fromFileNamed: 'Icons/dash.png' ).
	Icons at: #dashboard put: ( ColorForm fromFileNamed: 'Icons/dashboard.gif' ).
	Icons at: #header put: ( ColorForm fromFileNamed: 'Icons/header.gif' ).
	Icons at: #mail put: ( ColorForm fromFileNamed: 'Icons/mail.gif' ).
	Icons at: #processes put: ( ColorForm fromFileNamed: 'Icons/process.gif' ).
	Icons at: #route put: ( ColorForm fromFileNamed: 'Icons/route.gif' ).
	Icons at: #settings put: ( ColorForm fromFileNamed: 'Icons/settings.gif' ).
	Icons at: #tour put: ( ColorForm fromFileNamed: 'Icons/tour.gif' ).
	Icons at: #tourSub put: ( ColorForm fromFileNamed: 'Icons/tourSub.gif' ).
	Icons at: #tourPlan put: ( ColorForm fromFileNamed: 'Icons/tourPlan.gif' ).
	Icons at: #user put: ( ColorForm fromFileNamed: 'Icons/user.gif' ).
	Icons at: #right put: ( ColorForm fromFileNamed: 'Icons/right.png' ).
	Icons at: #down put: ( ColorForm fromFileNamed: 'Icons/down.png' ).
	Icons at: #plus put: ( ColorForm fromFileNamed: 'Icons/plus.png' ).
	! !

Object subclass: #SVO
	instanceVariableNames: 'version slots slotSequence pName undoStack redoStack announcer deleted copies template elder isAsvo uniqueNo view runningNo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO'!

SVO class
	instanceVariableNames: 'svos'!

!SVO commentStamp: 'hk 2/9/2015 16:45' prior: 0!
I am an abstract Smart Value Object. I come in four different flavours: 
- VO: value objects, that carry only data, plus eventually constraints
- RO: role objects (in the sense of DCI) that carry behaviour
- CO: constraint objects 
- UC: useCase context objects (in the sense of DCI) that know its roles and trigger. 

I have slots like a Frame, which are treated uniformly. My slots can be (for all types):
- ValueSlot				holds a string 
- ActionSlot				holds a dsl method 
- ValueListSlot 			holds a list of predefined strings
- SvoSlot 				holds a  SVO. This is essential for the SVO's structure
- SvoListSlot				holds a  list of SVO 


Unique key is my pName = my persistent name in the file system, together with my version. Within my own namespace, the uniqueNo + version is a key.

I know two copy operations:
- cloning results in a new name & fresh version. Used for authoring only.
- copying is the normal operation at runtime.
An application is programmed by authoring its SVO. These SVO then become ASVO - in order to be frozen (after cloning). 
A Copy can be made from a SVO or an ASVO. The pName of the copy is created by extending the original (template) pName. The original SVO (or ASVO) serves as a container for all its copies. Each copy knows the pName of its template.

Each SVO may be constructed in form of a tree of other SVO, held in special slots. This whole tree is a unique entity - the entity tree. The elder holds the parent node, slots the child nodes.  Whenever a new version of a node is saved, all its parent nodes up to the root of the tree must be saved with new version as well. This way the version of the root node denotes the version of the whole entity.
			
Instance Variables (all lazy)
	pName:			<String>								persistent name	
	deleted: 		<Boolean>								flag relevant for last version	
	version:		<String>								starts with '0' 
	template:		<VO>									my copy  source 
	elder:			<VO>									my entity parent node
	copies: 		<Dictionary>							of all SVO that are copied from me
	slots:			<Dictionary of SlotValue>				for fast access
	slotSequence:	<OrderedCollection> 					of the slot keys 
	isAsvo: 		<Boolean>								only true for templates
GUI related instance variables:			
	undoStack:		<OrderedCollection of Command>		for undo
	redoStack:		<OrderedCollection of Command>		for redo
	announcer: 		<SvoAnnouncer>						used for windows close & reOpen
	uniqueNo: 		<Number>								used as id - #id used like a valueSlot key
											
Class instance variables
	svos			<Dictionary of SVO>					pname -> SVO, holds all SVO of my type!

SVO class
	instanceVariableNames: 'svos'!

SVO subclass: #DomainSVO
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO'!

!DomainSVO commentStamp: 'hk 1/14/2015 11:21' prior: 0!
I am a Value Object. My slot types are the inherited ones.

!

SVO subclass: #ProgramSVO
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO'!

!ProgramSVO commentStamp: 'hk 3/23/2015 15:33' prior: 0!
I am a program object
!

ProgramSVO subclass: #BehaviourSVO
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO'!

!BehaviourSVO commentStamp: 'hk 1/14/2015 11:20' prior: 0!
I am a Role Object. My slot types are the inherited ones plus:
- ActionSlot				holds a DSLmethod 
				

!

!BehaviourSVO methodsFor: 'accessing actions' stamp: 'hk 1/26/2015 11:40'!
actionSlots
	^self dslSlots! !

!BehaviourSVO methodsFor: 'testing' stamp: 'hk 1/26/2015 14:17'!
hasMenu
	^self actionSlots isNotEmpty! !

!BehaviourSVO methodsFor: 'ui app' stamp: 'hk 2/12/2015 14:58'!
menu
	^self menuFor: nil! !

!BehaviourSVO methodsFor: 'ui app' stamp: 'hk 2/20/2015 18:55'!
menuFor: anArgumentArray
	self menuFor: anArgumentArray callBack: [ :a | ]! !

!BehaviourSVO methodsFor: 'ui app' stamp: 'hk 2/20/2015 18:49'!
menuFor: anArgumentArray callBack: aBlock
	|  actions  |
	self hasMenu ifFalse: [ ^nil ] .
	(actions := self actionSlots)  size = 1
		ifTrue: [ ^ MenuItemModel new	
						name: actions keys anyOne ;
						action: [aBlock value: (actions values anyOne execFor: anArgumentArray)] ;
						yourself ] .
	^MenuItemModel new	
		name: self pName ; 
		subMenu: (MenuModel new addGroup: [ :g | 
					actions keysAndValuesDo: [ :k :v | 
						g addItem: [ :i | i
							name: k ; 
							action: [aBlock value: (v execFor: anArgumentArray)  ] ] ] ] ) ;
		yourself .! !

ProgramSVO subclass: #ConstraintSVO
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO'!

!ConstraintSVO commentStamp: 'hk 1/8/2015 14:26' prior: 0!
I am a Constraint Object. !

ProgramSVO subclass: #ContextFolderSVO
	instanceVariableNames: 'roles contextVOs uiClass displayName aspect activeView aspectType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO'!

!ContextFolderSVO commentStamp: 'hk 3/29/2015 19:36' prior: 0!
I am a ACM Case Folder or DCI Context.
My contextVOs constitute my context data.
My roles constitute my behaviour.
I am not persistent !! I am instantiated from my vo or asvo, views or filters.
My contextVOs are added at runtime.

My subclasses represent 
- a plain context on a domain VO and
- a list contect on a ASVO. 

Instance Variables
	contextVOs:	<Collection of DomainVO>			not copied !!
	roles:			<Collection of BehaviourVO>
	uiClass: 		<Symbol>					my UI
	displayName: 	<String>					UI visible name
	aspect: 		<String>					slotName I am the view of
	aspectType:	<String>					template of aspect
									
the inherited elder slot is used:
	elder:										embeding context!

ContextFolderSVO subclass: #CFlistSVO
	instanceVariableNames: 'asvo cfPlain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO'!

!CFlistSVO commentStamp: 'hk 3/2/2015 18:33' prior: 0!
I am a list context,
bound to a template (asvo).
Thus indirectly I know all its copies.
cfPlain is the subContexts for any copy.

Instance Variables
	asvo:			<ASVO>		my template
	cfPlain			<CFplain>		my single item subcontext
!

!CFlistSVO methodsFor: 'accessing template' stamp: 'hk 2/8/2015 14:50'!
asvo
	^asvo ! !

!CFlistSVO methodsFor: 'accessing template' stamp: 'hk 2/2/2015 14:57'!
asvo: anASVO
	asvo := anASVO! !

!CFlistSVO methodsFor: 'accessing subcontext' stamp: 'hk 2/22/2015 15:28'!
cfPlain
	^cfPlain ! !

!CFlistSVO methodsFor: 'accessing subcontext' stamp: 'hk 3/3/2015 17:09'!
cfPlain: aCFplain
	cfPlain := aCFplain .
	aCFplain elder: self .! !

!CFlistSVO methodsFor: 'copying' stamp: 'hk 3/2/2015 18:45'!
copy 
	^super copy 
		asvo: asvo copy;
		cfPlain: cfPlain copy! !

!CFlistSVO methodsFor: 'accessing template' stamp: 'hk 2/8/2015 14:54'!
list
	^ self asvo copies values ! !

ContextFolderSVO subclass: #CFplainSVO
	instanceVariableNames: 'vo viewContexts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO'!

!CFplainSVO commentStamp: 'hk 3/29/2015 19:36' prior: 0!
I am a normal (plain) context,
bound to one VO.
Since there may be many views on my VO, 
I hold a context for each in my viewContexts

Instance Variables
	vo:				<VO>		for which I define the context
	viewContexts: 	<OColl of CFlist>			all my possible subContexts


!

!CFplainSVO methodsFor: 'copying' stamp: 'hk 3/2/2015 18:44'!
copy 
	^super copy vo: vo copy
			! !

!CFplainSVO methodsFor: 'accessing' stamp: 'hk 3/29/2015 19:35'!
views
	^viewContexts ifNil: [ viewContexts := OrderedCollection new ]! !

!CFplainSVO methodsFor: 'accessing' stamp: 'hk 2/2/2015 13:28'!
vo
	^vo ifNil: [ self error: self pName, ' has no VO' ]! !

!CFplainSVO methodsFor: 'accessing' stamp: 'hk 2/5/2015 13:51'!
vo: aVO
	vo := aVO! !

!ContextFolderSVO methodsFor: 'accessing' stamp: 'hk 3/4/2015 12:06'!
activeView
	^activeView
! !

!ContextFolderSVO methodsFor: 'accessing' stamp: 'hk 3/4/2015 12:06'!
activeView: aCFplain
	activeView := aCFplain.
! !

!ContextFolderSVO methodsFor: 'accessing' stamp: 'hk 2/2/2015 13:24'!
addRo: aRO
	self roles add: aRO.
	^aRO! !

!ContextFolderSVO methodsFor: 'accessing' stamp: 'hk 3/3/2015 17:08'!
addView: aCFplain
	self views add: aCFplain.
	aCFplain elder: self! !

!ContextFolderSVO methodsFor: 'copying' stamp: 'hk 3/2/2015 18:42'!
addViews: aColl
	self views addAll: aColl! !

!ContextFolderSVO methodsFor: 'accessing' stamp: 'hk 2/24/2015 13:04'!
addVo: aVO
	self contextVOs add: aVO.
	^aVO! !

!ContextFolderSVO methodsFor: 'accessing' stamp: 'hk 3/4/2015 10:42'!
aspect
	^aspect ifNil: [ aspect := 'undefined' ]! !

!ContextFolderSVO methodsFor: 'accessing' stamp: 'hk 3/4/2015 10:42'!
aspect: aString
	aspect := aString! !

!ContextFolderSVO methodsFor: 'accessing' stamp: 'hk 3/5/2015 16:37'!
aspectType
	^aspectType ifNil: [ aspectType := 'undefined' ]! !

!ContextFolderSVO methodsFor: 'accessing' stamp: 'hk 3/5/2015 16:39'!
aspectType: aString
	aspectType := aString! !

!ContextFolderSVO methodsFor: 'accessing' stamp: 'hk 2/13/2015 10:46'!
contextVOs
	"answer a coll of my VO "
	^contextVOs ifNil: [ contextVOs := Set new ]! !

!ContextFolderSVO methodsFor: 'copying' stamp: 'hk 3/2/2015 18:44'!
copy 
	| c |
	(c := super copy)
		addViews: self views.
	self roles do: [ :r | c addRo: r copy ]	.
	^c! !

!ContextFolderSVO methodsFor: 'accessing' stamp: 'hk 3/4/2015 10:31'!
displayName
	^displayName ifNil: [ displayName := 'undefined' ]! !

!ContextFolderSVO methodsFor: 'accessing' stamp: 'hk 3/4/2015 10:31'!
displayName: aString
	displayName := aString! !

!ContextFolderSVO methodsFor: 'accessing ui' stamp: 'hk 3/1/2015 13:10'!
newUI
	^(Smalltalk at: uiClass) on: self! !

!ContextFolderSVO methodsFor: 'accessing' stamp: 'hk 2/24/2015 21:37'!
roles
	"answer a coll of my RO objects"
	^roles ifNil: [ roles := OrderedCollection new ]! !

!ContextFolderSVO methodsFor: 'accessing ui' stamp: 'hk 2/13/2015 10:47'!
uiClass
	
	^uiClass! !

!ContextFolderSVO methodsFor: 'accessing ui' stamp: 'hk 2/13/2015 10:47'!
uiClass: aClassName
	
	uiClass := aClassName ! !

ProgramSVO subclass: #ViewSVO
	instanceVariableNames: 'model projectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO'!

!ViewSVO commentStamp: 'hk 2/28/2015 17:47' prior: 0!
A SvoView is is a projector from a copmlex VO to a simpler one.

Instance Variables
	pName:			<String>		my name
	model:			<VO>
	projectors:		<Dictionary>	selector -> SvoPath (point separated pathString)
	copies: 		<Dict of VO>	the view copies of the model

reading and writing with its selectors results in reading and writing the model VO!

!ViewSVO methodsFor: 'copying' stamp: 'hk 3/14/2015 18:19'!
copyView
	"answer a view vopy of my model. Store the copy in my copies"
	| child un |
	child := model class new template: self .
	self projectors do: [ :a |  child addValue: (self perform: a key) at: a key ] .
	child pName: ( self pName, '-', model pName, '-', (un := model nextRunningNo) asString );
			view: model view;
			beSvo;
			uniqueNo: un * 7 ;
			save.
	^self addCopy: child! !

!ViewSVO methodsFor: 'executing' stamp: 'hk 3/14/2015 18:37'!
doesNotUnderstand: aMessage 
	| proj path |
	proj := (aMessage selector trimRight: [ :c | c = $: ]) asSymbol .
	path := self projectorsAt: proj 
				ifAbsent: [ ^super doesNotUnderstand: aMessage] .
	^self exec: aMessage  with: path value
	! !

!ViewSVO methodsFor: 'executing' stamp: 'hk 3/15/2015 14:19'!
exec: aMessage with: aSvoPath
	"do nothing without model"
	| el msg |
	el := aSvoPath from: (model ifNil: [ ^ 'no model in ', self pName ] ) .
	msg := aSvoPath slotName asSymbol .
	^aMessage selector isKeyword    
"		ifTrue: [ el perform: msg asMutator with: aMessage argument ]
		ifFalse: [ el perform: msg ] 
"		ifTrue: [ el changeValueAt:  msg  to: aMessage argument ]
		ifFalse: [ el valueAt: msg ]   "value slots only"
	! !

!ViewSVO methodsFor: 'accessing' stamp: 'hk 3/14/2015 18:25'!
fields
	^ self projectors collect: [ :a | a key ] ! !

!ViewSVO methodsFor: 'accessing' stamp: 'hk 2/26/2015 19:33'!
model
	^ model! !

!ViewSVO methodsFor: 'accessing' stamp: 'hk 2/26/2015 19:34'!
model: aVO
	model := aVO! !

!ViewSVO methodsFor: 'accessing' stamp: 'hk 3/14/2015 18:18'!
projectors
	^ projectors ifNil: [ projectors := OrderedCollection new ]! !

!ViewSVO methodsFor: 'as yet unclassified' stamp: 'hk 3/14/2015 18:23'!
projectorsAt: aKey ifAbsent: aBlock
	^ projectors detect: [ :a | aKey = a key ] ifNone: aBlock ! !

!ViewSVO methodsFor: 'accessing' stamp: 'hk 3/5/2015 17:37'!
shortcut: aSelector for: aPathString
	self projectors add: aSelector asSymbol -> (SvoPath new: aPathString)! !

!SVO class methodsFor: 'accessing' stamp: 'hk 1/30/2015 11:44'!
addSvo: aSvo			
	self svos at: aSvo pName ifPresent: [ self inform: aSvo pName, ' overwritten'] .
	self svos add: aSvo pName -> aSvo. 
	^aSvo 
	
! !

!SVO class methodsFor: 'helpers' stamp: 'hk 1/7/2015 13:58'!
alert: errorString
	"the system wide alert dialog"

	WidgetExamples new exampleBuilder alert: errorString! !

!SVO class methodsFor: 'dsl services' stamp: 'hk 1/7/2015 15:33'!
allSvoNames
	^self svos values collect: [ :svo | svo pName ]! !

!SVO class methodsFor: 'accessing' stamp: 'hk 1/7/2015 14:00'!
at: aName
	^ self svos at: aName ifAbsent: [ nil ]! !

!SVO class methodsFor: 'accessing' stamp: 'hk 1/7/2015 14:00'!
at: aName ifAbsent: absentBlock
	^ self svos at: aName ifAbsent: absentBlock! !

!SVO class methodsFor: 'helpers' stamp: 'hk 1/7/2015 13:58'!
chooseFrom: aColl mess: aMessage
	"answers 0 or the index of the users choice in aColl
	<SPO chooseFrom: #(a b c) mess: 'choose one' >"
		
	^UIManager default chooseFrom: aColl asOrderedCollection lines: #() message: aMessage! !

!SVO class methodsFor: 'helpers' stamp: 'hk 1/7/2015 13:58'!
chooseValueFrom: aColl mess: aMessage
		"answers nil or the element of the users choice in aColl
		<SPO chooseValueFrom: #(a b c) mess: 'choose one'> "
		
	| coll index |
	coll := aColl asOrderedCollection.
	index :=  self chooseFrom: coll mess: aMessage.
	index = 0 ifTrue: [ ^nil ].
	^coll at: index

	! !

!SVO class methodsFor: 'accessing' stamp: 'hk 1/8/2015 14:50'!
clearSvos
	svos := nil! !

!SVO class methodsFor: 'dsl services' stamp: 'hk 4/3/2015 17:07'!
copy:  aVoName
	"do the action. answer a string with the actions result
	depends on the existence of an Email ASPO"

	( DomainSVO at: aVoName ifAbsent: [^ aVoName, ' not found' ] ) copy 
	
! !

!SVO class methodsFor: 'dsl commands' stamp: 'hk 2/13/2015 13:27'!
delete
 ^#delete:inContext:onUI: 

! !

!SVO class methodsFor: 'dsl commands' stamp: 'hk 2/22/2015 14:25'!
delete: aCFName inContext: aProcessesCF onUI: aUI
	"callback to UI"

	^aUI deleteSelection
 ! !

!SVO class methodsFor: 'dsl commands' stamp: 'hk 2/13/2015 12:34'!
edit
 ^#edit:inContext:onUI: 

! !

!SVO class methodsFor: 'dsl commands' stamp: 'hk 2/22/2015 14:25'!
edit: aCFName inContext: aProcessesCF onUI: aUI
	"callback to UI"

	^aUI editSelectionWith: aCFName 
 ! !

!SVO class methodsFor: 'dsl commands' stamp: 'hk 2/13/2015 11:22'!
email
 ^#email:
! !

!SVO class methodsFor: 'dsl commands' stamp: 'hk 4/3/2015 17:07'!
email:  aVoName
	"do the action. answer a string with the actions result
	depends on the existence of an Email ASPO"

	| email address | 
	email := ( DomainSVO at: #Email ifAbsent: [^ 'Email not found' ] ) copy .
	address := ((DomainSVO at: aVoName ifAbsent: [ ^aVoName  ] ) slots at: #email) value.
	(email slots at: #an) value: address.
	email edit.
	^ 'done'

! !

!SVO class methodsFor: 'dsl commands' stamp: 'hk 4/3/2015 17:07'!
email:  aVoName an: anO an: anotherO
	"do the action. answer a string with the actions result
	depends on the existence of an Email ASPO"

	| email address | 
	email := ( DomainSVO at: #Email ifAbsent: [^ 'Email not found' ] ) copy .
	address := ((DomainSVO at: aVoName ifAbsent: [ ^aVoName  ] ) slots at: #email) value.
	(email slots at: #an) value: address.
	email edit.
	^ 'done'

! !

!SVO class methodsFor: 'dsl commands' stamp: 'hk 2/13/2015 11:22'!
emailAn
 ^#email:an:an:
! !

!SVO class methodsFor: 'dsl commands' stamp: 'hk 2/12/2015 17:43'!
neu
	^#newContext:inContext:onUI: ! !

!SVO class methodsFor: 'dsl commands' stamp: 'hk 2/12/2015 16:44'!
neueTour
	^#neueTour:! !

!SVO class methodsFor: 'dsl commands' stamp: 'hk 4/3/2015 17:07'!
neueTour:  aVoName
	"do the action. answer a string with the actions result
	depends on the existence of an Email ASPO"

	| tour key | 
	key := ((DomainSVO at: aVoName ifAbsent: [ ^aVoName ] ) slots at: #id) value.
	tour := ( DomainSVO at: #GloConnTour ifAbsent: [^ 'GloConnTour not found' ] ) copy .
	tour changeValueAt: #vorgang to: key.
	^ 'done'

! !

!SVO class methodsFor: 'instance creation' stamp: 'hk 2/5/2015 20:20'!
new: aName
	(self = SVO) ifTrue: [ ^self error: 'SVO is an abstract class' ] .
	^self addSvo:  (self new pName: aName; beAsvo: 4710).
! !

!SVO class methodsFor: 'dsl commands' stamp: 'hk 2/22/2015 15:32'!
newContext: aCFName inContext: aProcessesCF onUI: aUI
	"callback to UI"

	aUI activateSubContextWith: aCFName ! !

!SVO class methodsFor: 'helpers' stamp: 'hk 1/7/2015 13:58'!
question: aMessage title: aTitle
	"answers 0 or the index of the users choice in aColl
	<GCService chooseFrom: #(a b c) mess: 'choose one' >"
		
	^UIManager default question: aMessage title: aTitle! !

!SVO class methodsFor: 'dsl services' stamp: 'hk 2/12/2015 15:15'!
selectFrom: aCollOrString
	"answer the only or user selected emelemt of aColl. or an error string"

	aCollOrString isString ifTrue: [ ^aCollOrString  ].
	aCollOrString size = 1 ifTrue: [ ^ aCollOrString anyOne ].
	^ (self chooseValueFrom: aCollOrString mess: 'select SVO')  
			ifNil: [ ^' aborted by user  ' ] ! !

!SVO class methodsFor: 'dsl services' stamp: 'hk 2/12/2015 15:15'!
slot: slotName of: SvoOrName
	"answer the slot or an error msg. the compiler calls this with SvoOrName = aString & aSvo"
	| svo |
	svo := SvoOrName.
	(svo isKindOf: String) ifTrue:  [ svo := self at: SvoOrName ifAbsent: [ ^ 'error: ', SvoOrName ]  ].
	^svo slots at: slotName ifAbsent: [ ^ 'error: ', slotName ]! !

!SVO class methodsFor: 'dsl services' stamp: 'hk 1/7/2015 15:27'!
svoNamesFrom: aSvoName with: aSlotValueArray
	"answer an error string or a Coll with all names of aSvoName copies that contain the values of aSlotValueArray in its slots"

	| results  |   
	results := (self at: aSvoName ifAbsent: [ ^aSvoName, ' not found' ] )
		copiesColl select: [ :e |  aSlotValueArray allSatisfy: [ :sv |  e value hasValue: sv ] ].  
	results ifEmpty: [ ^aSlotValueArray printString, ' not found'  ].
	^results collect: [ :e | e pName ]
	! !

!SVO class methodsFor: 'accessing' stamp: 'hk 1/7/2015 14:00'!
svos
	^ svos ifNil: [ svos := Dictionary new ]! !

!SVO class methodsFor: 'dsl services' stamp: 'hk 1/7/2015 14:06'!
valueNamed: aKey of: aPName
	"answer the value of slot aKey of aPName or signal an error"

	| aspo | 
	aspo := self at: aPName ifAbsent: [ ^nil ] .
	^ aspo valueSlots at: aKey ifAbsent: 
		[ aspo valueSlots at: aKey ifAbsent: 
			[ ^self alert: aKey , ' not found in ' , aPName ] ]! !

!SVO methodsFor: 'accessing - copies' stamp: 'hk 2/9/2015 16:46'!
addCopy: aSvo
	self copies add: aSvo pName ->  aSvo.
	self class at: aSvo pName ifAbsent: [ self class addSvo:  aSvo].  "on undo the copy must be registered again"
	^aSvo ! !

!SVO methodsFor: 'protocol - slots' stamp: 'hk 1/7/2015 13:57'!
addMethod:  aString at: slotName
	^self addSlot:  (ActionSlot new
				frame: self;
				key: slotName;
				source: aString ;
				yourself  )! !

!SVO methodsFor: 'protocol - slots' stamp: 'hk 2/9/2015 16:46'!
addSlot: aSlot
	"insert the ready made slot "
	| new |
	(self slotSequence includes: aSlot key) 
		ifTrue: [ self error: 'slot already exists' ].
	self slotSequence add: aSlot key.
	new := self slots add: (aSlot key -> aSlot).
	^new value
! !

!SVO methodsFor: 'protocol - slots' stamp: 'hk 1/21/2015 15:33'!
addSvo: aSvo at: slotName
	"put aSvo in this spo slot"
	aSvo elder: self .
	^self addSlot: (	(SvoSlot new
					frame: self;
					key: slotName;
					svo: aSvo ;
					yourself))! !

!SVO methodsFor: 'protocol - slots' stamp: 'hk 1/14/2015 11:48'!
addSvoDynamicList: aSource at: slotName
	^self addSlot: (	(SvoDynamicList new
					frame: self;
					key: slotName;
					source: aSource ;
					yourself))! !

!SVO methodsFor: 'protocol - slots' stamp: 'hk 1/14/2015 11:48'!
addSvoListAt: slotName
	^self addSlot: (	(SvoList new
					frame: self;
					key: slotName;
					yourself))! !

!SVO methodsFor: 'protocol - slots' stamp: 'hk 1/14/2015 11:48'!
addSvoStaticList: aSvo at: slotName
	^self addSlot: (	(SvoStaticList new
					frame: self;
					key: slotName;
					templateName: (aSvo ifNil: [ nil ] ifNotNil: [aSvo pName]) ;
					yourself))! !

!SVO methodsFor: 'protocol - slots' stamp: 'hk 2/2/2015 18:00'!
addValue: aString at: slotName
	^self addValue: aString at: slotName forDisplay: false! !

!SVO methodsFor: 'protocol - slots' stamp: 'hk 1/7/2015 13:57'!
addValue:  aString at: slotName forDisplay: aBoolean
	^self addSlot:  (ValueSlot new 
						frame: self;
						key: slotName;
						value: aString;
						forDisplay: aBoolean ;
						yourself)! !

!SVO methodsFor: 'protocol - slots' stamp: 'hk 1/7/2015 13:57'!
addValueDsl:  sourceString at: slotName
	^self addSlot:  (DslValueSlot new 
						frame: self;
						key: slotName;
						source: sourceString ;
						yourself)! !

!SVO methodsFor: 'protocol - slots' stamp: 'hk 1/19/2015 17:38'!
addValueList: listOfString at: slotName
		^self addSlot:  (DropListSlot new 
						frame: self;
						key: slotName;
						list: listOfString;
						yourself)! !

!SVO methodsFor: 'private' stamp: 'hk 1/7/2015 14:02'!
addYourself
	self class addSvo: self! !

!SVO methodsFor: 'private' stamp: 'hk 1/7/2015 13:57'!
alert: aString
	self class alert: aString! !

!SVO methodsFor: 'accessing' stamp: 'hk 2/9/2015 16:53'!
announcer
	^announcer ifNil: [ announcer := Announcer new ]! !

!SVO methodsFor: 'accessing' stamp: 'hk 2/9/2015 16:43'!
announcer: anAnnouncer
	announcer := anAnnouncer ! !

!SVO methodsFor: 'accessing - copies' stamp: 'hk 2/5/2015 20:19'!
beAsvo: aNumber
	uniqueNo := aNumber . 
	isAsvo := true
! !

!SVO methodsFor: 'accessing' stamp: 'hk 1/12/2015 17:14'!
beSvo
	isAsvo := false
! !

!SVO methodsFor: 'protocol - slots' stamp: 'hk 1/27/2015 14:34'!
change: slotName forDisplay: aBoolean
	| slot | 
	slot := self slots at: slotName ifAbsent: [ ^self ].	
	slot forDisplay: aBoolean ! !

!SVO methodsFor: 'protocol - slots' stamp: 'hk 3/15/2015 14:09'!
changeValueAt: slotName to: aString
	| slot | 
	slot := self valueSlots at: slotName ifAbsent: [ ^self ].	
	slot value: aString! !

!SVO methodsFor: 'private' stamp: 'hk 1/7/2015 13:57'!
clearCommandStacks
	undoStack := nil.
	redoStack := nil.
! !

!SVO methodsFor: 'copying' stamp: 'hk 2/5/2015 20:23'!
clone: newName
	"answer a copy of myself with a new name and a fresh version"
	| child |
	(self class svos includesKey: newName) ifTrue: 
		[^self error: ('SVO ', newName, ' already exists' )].
	^child := self copy 
				pName: newName;
				resetVersion;
				beAsvo: 1110 ; 
				save
	! !

!SVO methodsFor: 'protocol - ui' stamp: 'hk 2/9/2015 17:17'!
closeWindow
	self announcer announce: CloseFrame  new.
 ! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 1/7/2015 13:57'!
constraintSlots
	^ self slots select: [ :v | v isConstraintSlot]! !

!SVO methodsFor: 'accessing - copies' stamp: 'hk 1/7/2015 13:57'!
copies
	^ copies ifNil: [ copies := Dictionary new ]! !

!SVO methodsFor: 'accessing - copies' stamp: 'hk 1/7/2015 13:57'!
copiesColl
	^ self copies values asOrderedCollection! !

!SVO methodsFor: 'copying' stamp: 'hk 2/6/2015 13:35'!
copy
	"answer a new exemplar = value of myself "
	^self copy: nil ! !

!SVO methodsFor: 'copying' stamp: 'hk 2/20/2015 14:31'!
copy: aView
	"answer a new exemplar = value of myself projected with aView"
	| child un |
	(child := self class new template: self ).
	self copySlots: aView to: child.
	child 	pName: (pName, '_', (un := self nextRunningNo)  asString ) ;
			view: aView ;
			beSvo;
			uniqueNo: un * 10 ;
			addYourself; 
			save . 
	^self addCopy: child ! !

!SVO methodsFor: 'copying' stamp: 'hk 2/6/2015 13:12'!
copySlots: aView to: child
	"copy the slots of aView in sequence. pName is required "
	child 
		slots: (self slotsCopy: aView) ; setSlotFrames ;		
		slotSequence: (self slotSequence select: [ :sk | child slots keys includes: sk ] )! !

!SVO methodsFor: 'protocol' stamp: 'hk 1/7/2015 14:00'!
delete
	"I cannot be deleted with exemplars"

	self copies isEmpty
		ifFalse: [ 
			self alert: 'cannot delete with exemplars'.
			^ false ].

	self class svos removeKey: self pName ifAbsent: [  ].
	self deleteFile.
	^ true! !

!SVO methodsFor: 'private' stamp: 'hk 1/7/2015 13:57'!
deleteFile
	"just mark to be deleted"
	
	deleted := true.         
	self save ! !

!SVO methodsFor: 'accessing' stamp: 'hk 1/8/2015 15:25'!
deleted
	^deleted isNotNil! !

!SVO methodsFor: 'printing' stamp: 'hk 2/6/2015 14:45'!
displayArray
	| ar |     
	ar := OrderedCollection with: uniqueNo asString  .
	self slotsDo: [:s | s forDisplay ifTrue: [ ar add: s displayString ] ].
	 ^ar! !

!SVO methodsFor: 'printing' stamp: 'hk 2/15/2015 18:29'!
displayLabelArray: aUniqueNoLabel
	| ar |     
	ar := OrderedCollection with: aUniqueNoLabel asSymbol .
	self slotsDo: [:s | s forDisplay ifTrue: [ ar add: s key asSymbol] ].
	 ^ar! !

!SVO methodsFor: 'printing' stamp: 'hk 2/6/2015 14:30'!
displayString
	^self displayArray inject: '' into: [:res :a | res, ' ',a ]
! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 3/23/2015 13:04'!
doesNotUnderstand: aMessage 
	"answer the slot named by aMessage or change a valueSlot"
	| sel tsel |
	(sel := aMessage selector) isKeyword ifTrue:  
		[ tsel := (sel trimRight: [ :c | c = $: ]) asSymbol .
		self valueSlots at: tsel ifAbsent: [^super doesNotUnderstand: aMessage] .
		^self changeValueAt: tsel to: aMessage argument  ] .
	^(self slots at: sel ifAbsent: [ ^super doesNotUnderstand: aMessage  ]) 
		value
	! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 1/27/2015 11:03'!
dslSlots
	^ self slots select: [ :v | v isActionSlot]! !

!SVO methodsFor: 'protocol - ui' stamp: 'hk 1/14/2015 13:29'!
edit   
 	^( SvoSpecUI on: self) openWithSpec! !

!SVO methodsFor: 'accessing' stamp: 'hk 1/7/2015 13:57'!
elder
	^elder ! !

!SVO methodsFor: 'accessing' stamp: 'hk 1/7/2015 13:57'!
elder:  aSvo
	elder :=  aSvo! !

!SVO methodsFor: 'accessing' stamp: 'hk 1/7/2015 13:57'!
elderName
	^self elder ifNotNil: [ self elder pName ] ifNil: [ '' ]! !

!SVO methodsFor: 'accessing' stamp: 'hk 1/8/2015 15:10'!
elderVersion
	^self elder ifNil: [ '' ] ifNotNil: [self elder version ]

		
	! !

!SVO methodsFor: 'protocol' stamp: 'hk 1/7/2015 13:57'!
exec: aCommand
	aCommand receiver: self.
	self undoStack add: aCommand do.		! !

!SVO methodsFor: 'protocol - ui' stamp: 'hk 2/2/2015 18:50'!
exemplarsAsCollOfPairs
	"answer the exemplars as a CollectionOfPairs that understand pairsDo:
	the spo must be wrapped in a slot "

	| coll |
	coll := OrderedCollection new.
	self copiesColl do: [ :spo |  | sv |
			coll add: spo pName .
			sv := SvoSlot new 
						frame: self; 
						key: spo pName ;
						svo: spo value ;
						yourself.
			coll add: (CommonSlotUI  on: sv type: SvoUI ) ].					
	^ coll! !

!SVO methodsFor: 'file handling' stamp: 'hk 1/8/2015 15:10'!
fileName
	^self pName , '-v', self version, '.', self  fileType ! !

!SVO methodsFor: 'file handling' stamp: 'hk 1/7/2015 13:57'!
fileType
	^self isAsvo ifTrue: ['aspo'] ifFalse: ['dspo']! !

!SVO methodsFor: 'protocol - testing' stamp: 'hk 1/7/2015 13:57'!
hasValue: aString
	^(self valueSlots select: [ :v | v contains: aString ])  isNotEmpty ! !

!SVO methodsFor: 'private' stamp: 'hk 1/8/2015 15:06'!
incrementVersion
	version := (self version asInteger +1) asString
		
	! !

!SVO methodsFor: 'protocol - testing' stamp: 'hk 1/23/2015 19:39'!
isAsvo
	^isAsvo ifNil: [ isAsvo := true ].
! !

!SVO methodsFor: 'file handling' stamp: 'hk 1/7/2015 13:57'!
logFileName
	^ self pName , '.log'! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 2/9/2015 16:54'!
moveDown: aKey
	| i toMove size |
	i := slotSequence indexOf: aKey.
	toMove := slotSequence remove: aKey.
	size := slotSequence size.
	slotSequence add: toMove afterIndex: (size min: i ).
	self announcer announce: SlotsChanged new! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 2/9/2015 16:54'!
moveUp: aKey
	| i toMove |
	i := slotSequence indexOf: aKey.
	toMove := slotSequence remove: aKey.
	slotSequence add: toMove beforeIndex: (1 max: i - 1).
	self announcer announce: SlotsChanged new! !

!SVO methodsFor: 'private' stamp: 'hk 2/20/2015 14:30'!
nextRunningNo
	"be careful to call this only once per copy"
	^  runningNo := 1 + self runningNo
		
	! !

!SVO methodsFor: 'accessing' stamp: 'hk 3/5/2015 17:00'!
pName
	^pName ifNil: [ pName := 'undefined' asSymbol ] ! !

!SVO methodsFor: 'accessing' stamp: 'hk 1/7/2015 13:57'!
pName: aString
	pName  := aString asSymbol! !

!SVO methodsFor: 'printing' stamp: 'hk 1/7/2015 13:57'!
print: aDict labelled: aName on: aStream indent: anInt

	aStream cr; tab: anInt; nextPutAll: aName. 
	aDict associationsDo: [ :a | aStream crtab; tab: anInt. a printOn: aStream ] ! !

!SVO methodsFor: 'printing' stamp: 'hk 1/8/2015 15:22'!
printHeaderOn: aStream indent: anInt

	aStream tab: anInt; nextPutAll:  self class name, ': ', self pName ; 
		cr; tab: anInt; nextPutAll:  'version ', self version  ; 
		cr; tab: anInt; nextPutAll:  'elder: ', self templateName;
		cr; tab: anInt; nextPutAll:  'elder version: ', self templateVersion;
		cr; tab: anInt; nextPutAll:  'entityElder: ', self elderName;
		cr; tab: anInt; nextPutAll:  'entityElder version: ', self elderVersion;
		cr; tab: anInt; nextPutAll:  'exemplars: ', self copies size printString
! !

!SVO methodsFor: 'printing' stamp: 'hk 1/7/2015 13:57'!
printOn: aStream
	self printOn: aStream indent: 0! !

!SVO methodsFor: 'printing' stamp: 'hk 1/21/2015 15:33'!
printOn: aStream indent: anInt

	self printHeaderOn: aStream indent: anInt.
	self print: self slots labelled: 'Slots: ' on: aStream indent: anInt.
	aStream cr; tab: anInt; nextPutAll: 'contained SPO: '; cr. 
	self svoSlots do: [ :v | v svo printOn: aStream indent: anInt +1] .
! !

!SVO methodsFor: 'printing' stamp: 'hk 1/7/2015 13:57'!
qualifiedName
	^self class name asString, ': ', self pName

		
	! !

!SVO methodsFor: 'protocol - ui' stamp: 'hk 1/7/2015 13:57'!
reOpen  
	self announcer announce: ReOpenFrame  new.
 ! !

!SVO methodsFor: 'protocol' stamp: 'hk 1/7/2015 13:57'!
redo
	self redoStack ifEmpty: [ ^self ].		"precondition"
	^self undoStack add: ( self redoStack removeLast redo)! !

!SVO methodsFor: 'private' stamp: 'hk 1/7/2015 13:57'!
redoStack
	^redoStack ifNil: [ redoStack := OrderedCollection new ]

		
	! !

!SVO methodsFor: 'accessing - copies' stamp: 'hk 2/9/2015 16:54'!
removeCopy: aPname
	"remove a SPO from a SPO's exemplars"
	| svo |
	svo := self class at: aPname .
	self copies removeKey: aPname.
	self class svos removeKey: aPname.
	self announcer announce: SlotsChanged new.
	svo delete.
	^svo! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 2/9/2015 16:54'!
removeSlot: aKey 
	"answer the removed slot"
	| old |  
	slotSequence remove: aKey.
	old := self slots removeKey: aKey.
	self announcer announce: SlotsChanged new.
	^old

! !

!SVO methodsFor: 'private' stamp: 'hk 1/12/2015 17:19'!
resetVersion
	version := '0'! !

!SVO methodsFor: 'protocol' stamp: 'hk 1/7/2015 13:57'!
rollBack
	self undoStack reverseDo: [ :cmd | cmd undo ].
	self clearCommandStacks ! !

!SVO methodsFor: 'accessing' stamp: 'hk 2/20/2015 14:18'!
runningNo
	^  runningNo ifNil: [ 0 ]
		
	! !

!SVO methodsFor: 'protocol' stamp: 'hk 1/21/2015 15:48'!
save
	"save the SPO and increment the version "
	
	self incrementVersion.
	self clearCommandStacks.
	SvoStorage 
		store: self pName "storeString" isAsvo: self isAsvo to: self fileName;
		storeLog: pName, ' saved, version: ', self version isAsvo: self isAsvo .
	elder ifNotNil: [ self elder save ]! !

!SVO methodsFor: 'copying' stamp: 'hk 1/21/2015 15:33'!
setSlotFrames
	slots valuesDo: [ :v | v frame: self . 
						v isSvoSlot ifTrue: [ v svo elder: self ] .
						v isSvoList ifTrue: [ v list do: [ :e | e elder: self ] ] ].
	! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 1/30/2015 13:12'!
slotAt: aKey
	^ self slots at: aKey ifAbsent: [ nil ]! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 1/7/2015 13:57'!
slotSequence
	^slotSequence ifNil:  [slotSequence := OrderedCollection new ]! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 1/7/2015 13:57'!
slotSequence: aColl
	slotSequence := aColl! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 1/7/2015 13:57'!
slotSize
	^ slots size! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 1/7/2015 13:57'!
slots
	^ slots ifNil: [ slots := Dictionary new ]! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 1/7/2015 13:57'!
slots: aDict
	slots := aDict
	
	! !

!SVO methodsFor: 'protocol - ui' stamp: 'hk 2/2/2015 18:50'!
slotsAsCollOfPairs
	"answer the slots as a CollectionOfPairs that understand pairsDo: "
	
	| coll|
	coll := OrderedCollection new.
	self slotSequence do: [ :e | | v | 
		v := slots at: e. 
		coll add: e asSymbol . 
		coll add: (CommonSlotUI  on: v type: v uiClass)  ].
	^coll! !

!SVO methodsFor: 'copying' stamp: 'hk 2/6/2015 13:07'!
slotsCopy: aView
	| c |
	c := Dictionary new.
	self slots keysAndValuesDo: 
		[ :k :v | (v belongsToView: aView) ifTrue: [ c at: k put: v copy ] ].  
	^c! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 1/20/2015 18:00'!
slotsDo: aBlock
	self slotSequence do: [ :k |  aBlock value: (self slots at: k) ]! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 1/14/2015 12:03'!
svoDynamicListSlots
	^ self slots select: [ :v | v isSvoDynamicList ]! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 1/14/2015 12:03'!
svoListSlots
	^ self slots select: [ :v | v isSvoList ]! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 1/14/2015 13:25'!
svoSlots
	^ self slots select: [ :v | v isSvoSlot ]! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 3/21/2015 16:06'!
svoStaticListSlots
	^ self slots select: [ :v | v isSvoStaticList ]! !

!SVO methodsFor: 'accessing' stamp: 'hk 1/7/2015 13:57'!
template
	^template ! !

!SVO methodsFor: 'accessing' stamp: 'hk 1/7/2015 13:57'!
template:  aSvo
	template := aSvo! !

!SVO methodsFor: 'accessing' stamp: 'hk 1/8/2015 15:20'!
templateName
	^self template ifNil: [ '' ] ifNotNil: [ self template pName ] ! !

!SVO methodsFor: 'accessing' stamp: 'hk 1/8/2015 15:20'!
templateVersion
	^self template ifNil: [ '' ] ifNotNil: [self template version ]
! !

!SVO methodsFor: 'protocol' stamp: 'hk 1/7/2015 13:57'!
undo
	self undoStack ifEmpty: [ ^self ].		"precondition"
	^self redoStack add: ( self undoStack removeLast undo)! !

!SVO methodsFor: 'private' stamp: 'hk 1/7/2015 13:57'!
undoStack
	^undoStack ifNil: [ undoStack := OrderedCollection new ]

		
	! !

!SVO methodsFor: 'accessing' stamp: 'hk 2/9/2015 19:34'!
uniqueNo
	^ uniqueNo
	! !

!SVO methodsFor: 'accessing' stamp: 'hk 2/5/2015 20:40'!
uniqueNo: aNumber
	^ uniqueNo := aNumber
	! !

!SVO methodsFor: 'printing' stamp: 'hk 4/7/2015 12:23'!
userName
	
	^self pName, ' id: ', self uniqueNo asString 

		
	! !

!SVO methodsFor: 'protocol - slots' stamp: 'hk 2/5/2015 20:29'!
valueAt: aKey
	(aKey = #id) ifTrue: [ ^uniqueNo  ].
	^ (self slotAt: aKey) value! !

!SVO methodsFor: 'accessing slots' stamp: 'hk 1/7/2015 13:57'!
valueSlots
	^ self slots select: [ :v | v isValueSlot ]! !

!SVO methodsFor: 'accessing' stamp: 'hk 1/12/2015 17:19'!
version
	"answer the version string starting at '0' "
	^version ifNil: [ self resetVersion. version ] ! !

!SVO methodsFor: 'accessing' stamp: 'hk 2/6/2015 13:00'!
view
	^view! !

!SVO methodsFor: 'accessing' stamp: 'hk 2/6/2015 13:37'!
view: aSymbolOrNil
	^view := aSymbolOrNil ! !

Object subclass: #SvoCodeSize
	instanceVariableNames: 'vars methods loc classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO-Utilities'!

!SvoCodeSize commentStamp: 'hk 3/23/2015 19:34' prior: 0!
I help counting classes, LOC, methods and variables.
I can be added and subtracted.  

Instance Variables
	classes:		<Integer>
	loc:				<Integer>
	methods:		<Integer>
	vars:			<Integer>

"SvoCodeSize newOn: SVO
"
"SvoCodeSize  newOnCategoryOf:  SVO
"
"SvoCodeSize  newOnPackageOf:  SVO
"
"SvoCodeSize  newOnCategoryOf:  DslGrammar
"
"SvoCodeSize  newOnCategoryOf:  SvoTests
"
"SvoCodeSize  newOnCategoryOf:  GloConnMainUI
"

"SvoCodeSize newOnWithSubclasses: SVO
"
"SvoCodeSize newOn: (Array with: SVO with: SvoStorage)
"
!

!SvoCodeSize class methodsFor: 'instance creation' stamp: 'hk 5/13/2010 15:24'!
newOn: aClassOrCollectionOfClasses

	| size |
	(aClassOrCollectionOfClasses isKindOf: Class) 
		ifTrue: [^self new sizeOfClass: aClassOrCollectionOfClasses].
	size := self newOn: (aClassOrCollectionOfClasses first).
	aClassOrCollectionOfClasses allButFirst do: [:cls| size + (self newOn: cls)].
	^size! !

!SvoCodeSize class methodsFor: 'instance creation' stamp: 'hk 5/13/2010 14:48'!
newOnCategoryOf: aClass

	^self new sizeOfCategory: aClass! !

!SvoCodeSize class methodsFor: 'instance creation' stamp: 'hk 3/23/2015 19:34'!
newOnPackageOf: aClass

	^self new sizeOfPackage: aClass! !

!SvoCodeSize class methodsFor: 'instance creation' stamp: 'hk 5/13/2010 14:51'!
newOnSubclassesOf: aClass

	^self new sizeOfSuclassesOf: aClass! !

!SvoCodeSize class methodsFor: 'instance creation' stamp: 'hk 5/19/2010 20:31'!
newOnWithSubclasses: aClass

	| size |
	(aClass isKindOf: Class) ifFalse: [^self error: 'argument is no single class'].
	^(self newOn: aClass) + (self newOnSubclassesOf: aClass)! !

!SvoCodeSize methodsFor: 'arithmetic' stamp: 'hk 2/10/2015 13:25'!
+ anSvoCodeSize

	vars := vars + (anSvoCodeSize vars).
	methods  := methods + (anSvoCodeSize methods).
	loc := loc + (anSvoCodeSize loc).
	classes := classes + (anSvoCodeSize classes).! !

!SvoCodeSize methodsFor: 'arithmetic' stamp: 'hk 2/10/2015 13:25'!
- anSvoCodeSize

	vars := vars - (anSvoCodeSize vars).
	methods  := methods - (anSvoCodeSize methods).
	loc := loc - (anSvoCodeSize loc).
	classes := classes - (anSvoCodeSize classes).! !

!SvoCodeSize methodsFor: 'accessing' stamp: 'hk 5/10/2010 23:42'!
classes
	^classes! !

!SvoCodeSize methodsFor: 'accessing' stamp: 'hk 5/10/2010 19:18'!
loc
	^loc! !

!SvoCodeSize methodsFor: 'accessing' stamp: 'hk 5/10/2010 19:17'!
methods
	^methods! !

!SvoCodeSize methodsFor: 'printing' stamp: 'hk 5/10/2010 23:47'!
printOn: aStream

	super printOn: aStream.
	aStream nextPutAll: ': ',classes printString, ' Klassen; ', loc printString, ' LOC; ', vars printString, ' Variablen; ', methods printString, ' Methoden'
	! !

!SvoCodeSize methodsFor: 'initialize' stamp: 'hk 2/10/2015 13:20'!
sizeOfCategory: aClass

	loc := vars := methods := classes := 0.
	(SystemOrganization listAtCategoryNamed: aClass category)
		do: [:cls | self + (SvoCodeSize newOn:(Smalltalk at: cls)) ].
! !

!SvoCodeSize methodsFor: 'initialize' stamp: 'hk 5/13/2010 14:46'!
sizeOfClass: aClass

	loc := 0.
	aClass methodsDo: [:m | loc := loc +  (m getSource  asArray select: [:c | c = Character cr]) size].
	aClass class methodsDo: [:m | loc := loc +  (m getSource  asArray select: [:c | c = Character cr]) size].
	vars := ((aClass instVarNames size) + (aClass classVarNames size)).
	methods := ((aClass methodDict size) + (aClass class methodDict size)).
	classes := 1.! !

!SvoCodeSize methodsFor: 'initialize' stamp: 'hk 3/23/2015 19:41'!
sizeOfPackage: aClass

	loc := vars := methods := classes := 0.
	aClass package orderedClasses do: [:cls | self + (SvoCodeSize newOn: cls) ].
! !

!SvoCodeSize methodsFor: 'initialize' stamp: 'hk 2/10/2015 13:20'!
sizeOfSuclassesOf: aClass

	loc := vars := methods := classes := 0.
	aClass subclassesDo: [:cls |self + (SvoCodeSize newOn: cls)]! !

!SvoCodeSize methodsFor: 'accessing' stamp: 'hk 5/10/2010 19:17'!
vars
	^vars ! !

Object subclass: #SvoPath
	instanceVariableNames: 'pathString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO'!

!SvoPath commentStamp: 'hk 2/28/2015 13:14' prior: 0!
A SvoPath is a relative path within a VO.

Instance Variables
	pathString:		<String>		point separated

!

!SvoPath class methodsFor: 'as yet unclassified' stamp: 'hk 2/28/2015 13:15'!
new: aPathString
	^self new pathString: aPathString! !

!SvoPath methodsFor: 'evaluating' stamp: 'hk 3/15/2015 14:21'!
from: aVO
	"answer the VO reached from aVO"
	| depth res arr |
	arr := pathString subStrings:  '.' .
	depth := arr size -1 .
	res := aVO .
	1 to: depth do: 
		[ :i | res := (res slotAt: (arr at: i) ) svo ] .
	^res! !

!SvoPath methodsFor: 'accessing' stamp: 'hk 2/28/2015 13:15'!
pathString: aString
	pathString := aString! !

!SvoPath methodsFor: 'evaluating' stamp: 'hk 2/28/2015 13:30'!
slotName
	^(pathString subStrings:  '.') last ! !

Object subclass: #SvoStorage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SVO'!

!SvoStorage commentStamp: 'hk 11/17/2014 19:35' prior: 0!
A SPOStorage represents the interface to any storage.
!

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:53'!
aFilepattern
	^'*.asvo'! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:52'!
aFiletype
	^'asvo'! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:53'!
dFilename
	^'*.dsvo'! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:53'!
dFilepattern
	^'*.dsvo'! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:52'!
dFiletype
	^'dsvo'! !

!SvoStorage class methodsFor: 'private' stamp: 'hk 11/24/2014 22:31'!
delete: aPattern inDir: aDir

	((self storeReference: aDir) filesMatching: aPattern ) 
		do: [ :f | f delete ]! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:54'!
deleteAllAsvo
	"use with care	SPO deleteAllAspo"

	self delete: self aFilepattern inDir: self aFiletype! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:55'!
deleteAllDsvo
	"use with care	SVO deleteAllAsvo"

	self delete: self dFilepattern inDir: self dFiletype! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:45'!
deleteAllFiles
	"use with care	SpoStorage deleteAllFiles"

	self deleteAllInAspo ; deleteAllInDsvo ! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:55'!
deleteAllInAspo   
	self delete: '*.*' inDir: self aFiletype ! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:55'!
deleteAllInDsvo   
	self delete: '*.*' inDir: self dFiletype! !

!SvoStorage class methodsFor: 'private' stamp: 'hk 11/17/2014 21:03'!
logFileExt
^ '.log'! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:46'!
readAll
	"read all spo files -  SPO readAll"
	
	self readAllAsvo ; readAllDsvo ! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:56'!
readAllAsvo
	"read all aspo files ASPO readAllAspo"

	self readFilesMatching:  self aFilepattern  fromDir:  self aFiletype 
		! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:57'!
readAllDsvo
	"read all dsvo files -  SVO readAllDsvo"
	
	self readFilesMatching:  self dFilepattern fromDir:  self dFiletype 
		! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:57'!
readAsvo: fileName 
	^self readSvo: fileName type: self aFiletype ! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 1/21/2015 15:57'!
readDsvo: fileName 
	^self readSvo: fileName type: self dFiletype ! !

!SvoStorage class methodsFor: 'private' stamp: 'hk 1/21/2015 15:50'!
readFilesMatching: aPattern fromDir: aDir
	"read all asvo files ASVO readAllAspo"
	
	((self storeReference: aDir) filesMatching:  aPattern) do: 
		[ :f |  |stream svo|
		stream := f readStream readOnly. 
		svo := CodeImporter evaluateFileStream: stream.
"		SVO addIfCurrent: svo.				noch zu klären !!!!!!!!!!!!
"		stream close. ]! !

!SvoStorage class methodsFor: 'private' stamp: 'hk 4/3/2015 17:07'!
readSvo: fileName type: typeString
	| svo |
	((self storeReference: typeString ) / fileName ) 
		readStreamDo: [ :stream | 
			svo := CodeImporter evaluateFileStream: stream .
			DomainSVO addSvo: svo ].
	^svo! !

!SvoStorage class methodsFor: 'utilities' stamp: 'hk 4/3/2015 17:07'!
saveAll
	"handle with care  	SVO saveAll"
	
	DomainSVO svos do: [ :svo | svo save   ]! !

!SvoStorage class methodsFor: 'interface' stamp: 'hk 1/21/2015 15:58'!
store: storeString isAsvo: aBoolean to: fileName
	"take the storeString and write it into file fileName"
	
	aBoolean 
		ifTrue:  [ self store: self aFiletype  svo: storeString to: fileName ]
		ifFalse: [ self store: self dFiletype  svo: storeString to: fileName ]

! !

!SvoStorage class methodsFor: 'private' stamp: 'hk 1/21/2015 15:47'!
store: fileType svo: aString to: fileName
	((self storeReference: fileType) / fileName ) 
		ensureDelete;
		writeStreamDo: [ :stream | stream nextPutAll: aString]! !

!SvoStorage class methodsFor: 'private' stamp: 'hk 11/24/2014 21:25'!
storeFor: fileType log: aLine
	"file will be appended"

	(self storeReference: fileType) / (fileType , self logFileExt)
		writeStreamDo: [ :stream | stream setToEnd; cr; nextPutAll: DateAndTime current printString; nextPut: $ ; nextPutAll: aLine]! !

!SvoStorage class methodsFor: 'interface' stamp: 'hk 1/21/2015 15:58'!
storeLog: logLine isAsvo: aBoolean
	"write the logLine "
	aBoolean 
		ifTrue:  [ self storeFor: self aFiletype  log: logLine ]
		ifFalse: [ self storeFor: self dFiletype log: logLine ]
	! !

!SvoStorage class methodsFor: 'private' stamp: 'hk 11/17/2014 19:48'!
storeReference: dirName
	"answer my store fileReference"   
	| storeReference |
	storeReference :=  FileSystem disk workingDirectory / dirName.
	storeReference isDirectory ifFalse: [storeReference createDirectory] .
	^storeReference! !
